/// <summary>
///  Clase que representa los parámetros de configuración de la aplicación
///  registrados en el archivo appsettings.json (o equivalente definido).
/// </summary>
public sealed class Config
{
    public required string POS { get; set; } = "pruebas";
    public required string IpSCO { get; set; } = "127.0.0.1";
    public required int PortSCO { get; set; } = 6697;
    public required string Language { get; set; } = "en";

    public override string ToString()
   {
      return base.ToString() + " - " + $"POS: '{POS}', IpSCO: '{IpSCO}', PortSCO: '{PortSCO}', Language: '{Language}'";
   }
}