
using gatewayGK.Infraestructura;
using GatewaySCO;
/// <summary>
/// Factory que retorna un directorio de comandos instanciado
/// con los comandos apropiados según tipo de POS.
/// </summary>
public class DirectorioCmdsFactory
    {
        public static CreaDirectorioCmds CreaDirectorio(string tipoPOS)
        {
            switch (tipoPOS)
            {
                case "pruebas":
                    return DispensaDirectorioCmdsPruebas.Dispensa();
                case "evapos":
                    return DispensaDirectorioCmdsEvaPOS.Dispensa();
                case "gk":
                    return DispensaDirectorioCmdsGK.Dispensa();
                case "gk_test":
                    return DispensaDirectorioCmdsGKPruebas.Dispensa();
                case "posbc":
                    return DispensaDirectorioCmdPOSBC.Dispensa();
                default:
                    throw new ArgumentException("TipoPOS no válido", "tipoPOS");
            }
        }
    }
