﻿using gatewayGK.POSBC;
using Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace gatewayGK.Infraestructura
{
    /// <summary>
    /// Instancia directorio de comandos de POSBC con cada
    /// uno de los comandos.
    /// </summary>
    public class DispensaDirectorioCmdPOSBC : IDispensaDirectorioCmds
    {
        /// <summary>
        /// Retorna directorio de comandos instanciado y poblado de
        /// comandos. 
        /// </summary>
        /// 
        public static CreaDirectorioCmds Dispensa()
        {
            Log.Information("Instancia comandos POSBC.");
            return new IniciaDirectorioCmds()
                .AgregaCmd(new InitializeRequestPosbcCmd())
                .AgregaCmd(new QueryStatusRequestPosbcCmd())
                .AgregaCmd(new ReportStatusEventsRequestPosbcCmd())
                .DirectorioCmds;
        }
    }
}
