/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// WorkstationCommand &lt;p&gt;This DB table contains info about commands for POSes registered by POS server processes.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand :  IEquatable<ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand" /> class.
        /// </summary>
        /// <param name="key">&lt;p&gt;Getter for inner key class.&lt;/p&gt; (required).</param>
        /// <param name="command">designed for POS server processes (e.g. EOD) to set some commands to POSes (e.g. PERFORM_EOD_PROCEDURE) (required).</param>
        /// <param name="createTimestamp">time of creation; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone) (required).</param>
        /// <param name="createTimestampUTC0">UTC0 time of creation; UTC0 date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ&#39; (with timezone) (required).</param>
        /// <param name="xxcustom05">Customizable information.</param>
        /// <param name="xxcustom03">Customizable information.</param>
        /// <param name="xxcustom02">Customizable information.</param>
        /// <param name="xxcustom04">Customizable information.</param>
        /// <param name="xxcustom01">Customizable information.</param>
        public ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand(ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommandKey key = default(ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommandKey), string command = default(string), string createTimestamp = default(string), DateTime? createTimestampUTC0 = default(DateTime?), string xxcustom05 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom01 = default(string))
        {
            // to ensure "key" is required (not null)
            if (key == null)
            {
                throw new InvalidDataException("key is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand and cannot be null");
            }
            else
            {
                this.Key = key;
            }
            // to ensure "command" is required (not null)
            if (command == null)
            {
                throw new InvalidDataException("command is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand and cannot be null");
            }
            else
            {
                this.Command = command;
            }
            // to ensure "createTimestamp" is required (not null)
            if (createTimestamp == null)
            {
                throw new InvalidDataException("createTimestamp is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand and cannot be null");
            }
            else
            {
                this.CreateTimestamp = createTimestamp;
            }
            // to ensure "createTimestampUTC0" is required (not null)
            if (createTimestampUTC0 == null)
            {
                throw new InvalidDataException("createTimestampUTC0 is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand and cannot be null");
            }
            else
            {
                this.CreateTimestampUTC0 = createTimestampUTC0;
            }
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        [DataMember(Name="key", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommandKey Key { get; set; }

        /// <summary>
        /// designed for POS server processes (e.g. EOD) to set some commands to POSes (e.g. PERFORM_EOD_PROCEDURE)
        /// </summary>
        /// <value>designed for POS server processes (e.g. EOD) to set some commands to POSes (e.g. PERFORM_EOD_PROCEDURE)</value>
        [DataMember(Name="command", EmitDefaultValue=false)]
        public string Command { get; set; }

        /// <summary>
        /// time of creation; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>time of creation; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="createTimestamp", EmitDefaultValue=false)]
        public string CreateTimestamp { get; set; }

        /// <summary>
        /// UTC0 time of creation; UTC0 date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ&#39; (with timezone)
        /// </summary>
        /// <value>UTC0 time of creation; UTC0 date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ&#39; (with timezone)</value>
        [DataMember(Name="createTimestampUTC0", EmitDefaultValue=false)]
        public DateTime? CreateTimestampUTC0 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand {\n");
            sb.Append("  Key: ").Append(Key).Append("\n");
            sb.Append("  Command: ").Append(Command).Append("\n");
            sb.Append("  CreateTimestamp: ").Append(CreateTimestamp).Append("\n");
            sb.Append("  CreateTimestampUTC0: ").Append(CreateTimestampUTC0).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiLoginManagerDtoWorkstationCommand input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Key == input.Key ||
                    (this.Key != null &&
                    this.Key.Equals(input.Key))
                ) && 
                (
                    this.Command == input.Command ||
                    (this.Command != null &&
                    this.Command.Equals(input.Command))
                ) && 
                (
                    this.CreateTimestamp == input.CreateTimestamp ||
                    (this.CreateTimestamp != null &&
                    this.CreateTimestamp.Equals(input.CreateTimestamp))
                ) && 
                (
                    this.CreateTimestampUTC0 == input.CreateTimestampUTC0 ||
                    (this.CreateTimestampUTC0 != null &&
                    this.CreateTimestampUTC0.Equals(input.CreateTimestampUTC0))
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Key != null)
                    hashCode = hashCode * 59 + this.Key.GetHashCode();
                if (this.Command != null)
                    hashCode = hashCode * 59 + this.Command.GetHashCode();
                if (this.CreateTimestamp != null)
                    hashCode = hashCode * 59 + this.CreateTimestamp.GetHashCode();
                if (this.CreateTimestampUTC0 != null)
                    hashCode = hashCode * 59 + this.CreateTimestampUTC0.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
