/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BusinessUnitDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitID">&lt;p&gt;A unique retailer assigned identifier for a retail store, distribution center or administration center (internal identifier).&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for the group of business units.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey(string businessUnitID = default(string), string businessUnitGroupID = default(string))
        {
            // to ensure "businessUnitID" is required (not null)
            if (businessUnitID == null)
            {
                throw new InvalidDataException("businessUnitID is a required property for ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitID = businessUnitID;
            }
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique retailer assigned identifier for a retail store, distribution center or administration center (internal identifier).&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique retailer assigned identifier for a retail store, distribution center or administration center (internal identifier).&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitID", EmitDefaultValue=false)]
        public string BusinessUnitID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey {\n");
            sb.Append("  BusinessUnitID: ").Append(BusinessUnitID).Append("\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBusinessUnitDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitID == input.BusinessUnitID ||
                    (this.BusinessUnitID != null &&
                    this.BusinessUnitID.Equals(input.BusinessUnitID))
                ) && 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitID.GetHashCode();
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
