/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CurrencyDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="isocurrencyCode">&lt;p&gt;Currency code designated by ISO to identify national currency. The unique identifier of the currency.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey(string businessUnitGroupID = default(string), string isocurrencyCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "isocurrencyCode" is required (not null)
            if (isocurrencyCode == null)
            {
                throw new InvalidDataException("isocurrencyCode is a required property for ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey and cannot be null");
            }
            else
            {
                this.IsocurrencyCode = isocurrencyCode;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Currency code designated by ISO to identify national currency. The unique identifier of the currency.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Currency code designated by ISO to identify national currency. The unique identifier of the currency.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="isocurrencyCode", EmitDefaultValue=false)]
        public string IsocurrencyCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  IsocurrencyCode: ").Append(IsocurrencyCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.IsocurrencyCode == input.IsocurrencyCode ||
                    (this.IsocurrencyCode != null &&
                    this.IsocurrencyCode.Equals(input.IsocurrencyCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.IsocurrencyCode != null)
                    hashCode = hashCode * 59 + this.IsocurrencyCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
