/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ExchangeRateDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;The identifier for a group of business units.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="fromCurrencyCode">&lt;p&gt;The unique identifier of the source currency.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="toCurrencyCode">&lt;p&gt;The unique identifier of the destination currency.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="sequenceNumber">&lt;p&gt;A sequence number denoting the order in which Exchange rate records were created for this pairing of currencies.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey(string businessUnitGroupID = default(string), string fromCurrencyCode = default(string), string toCurrencyCode = default(string), int? sequenceNumber = default(int?))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "fromCurrencyCode" is required (not null)
            if (fromCurrencyCode == null)
            {
                throw new InvalidDataException("fromCurrencyCode is a required property for ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey and cannot be null");
            }
            else
            {
                this.FromCurrencyCode = fromCurrencyCode;
            }
            // to ensure "toCurrencyCode" is required (not null)
            if (toCurrencyCode == null)
            {
                throw new InvalidDataException("toCurrencyCode is a required property for ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey and cannot be null");
            }
            else
            {
                this.ToCurrencyCode = toCurrencyCode;
            }
            // to ensure "sequenceNumber" is required (not null)
            if (sequenceNumber == null)
            {
                throw new InvalidDataException("sequenceNumber is a required property for ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey and cannot be null");
            }
            else
            {
                this.SequenceNumber = sequenceNumber;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;The identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;The unique identifier of the source currency.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the source currency.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="fromCurrencyCode", EmitDefaultValue=false)]
        public string FromCurrencyCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The unique identifier of the destination currency.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the destination currency.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="toCurrencyCode", EmitDefaultValue=false)]
        public string ToCurrencyCode { get; set; }

        /// <summary>
        /// &lt;p&gt;A sequence number denoting the order in which Exchange rate records were created for this pairing of currencies.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A sequence number denoting the order in which Exchange rate records were created for this pairing of currencies.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="sequenceNumber", EmitDefaultValue=false)]
        public int? SequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  FromCurrencyCode: ").Append(FromCurrencyCode).Append("\n");
            sb.Append("  ToCurrencyCode: ").Append(ToCurrencyCode).Append("\n");
            sb.Append("  SequenceNumber: ").Append(SequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdExchangeRateDtoDomExchangeRateDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.FromCurrencyCode == input.FromCurrencyCode ||
                    (this.FromCurrencyCode != null &&
                    this.FromCurrencyCode.Equals(input.FromCurrencyCode))
                ) && 
                (
                    this.ToCurrencyCode == input.ToCurrencyCode ||
                    (this.ToCurrencyCode != null &&
                    this.ToCurrencyCode.Equals(input.ToCurrencyCode))
                ) && 
                (
                    this.SequenceNumber == input.SequenceNumber ||
                    (this.SequenceNumber != null &&
                    this.SequenceNumber.Equals(input.SequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.FromCurrencyCode != null)
                    hashCode = hashCode * 59 + this.FromCurrencyCode.GetHashCode();
                if (this.ToCurrencyCode != null)
                    hashCode = hashCode * 59 + this.ToCurrencyCode.GetHashCode();
                if (this.SequenceNumber != null)
                    hashCode = hashCode * 59 + this.SequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
