/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PosUOMItemText.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey :  IEquatable<ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey" /> class.
        /// </summary>
        /// <param name="textNumber">&lt;p&gt;Text number (number of the row)&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="textClass">&lt;p&gt;Text class (as part of the reference to the text)&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="languageId">&lt;p&gt;A combination of ISO-639-1 and ISO-3661-1 or an own identifier to denote the language&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey(int? textNumber = default(int?), string textClass = default(string), string languageId = default(string))
        {
            // to ensure "textNumber" is required (not null)
            if (textNumber == null)
            {
                throw new InvalidDataException("textNumber is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey and cannot be null");
            }
            else
            {
                this.TextNumber = textNumber;
            }
            // to ensure "textClass" is required (not null)
            if (textClass == null)
            {
                throw new InvalidDataException("textClass is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey and cannot be null");
            }
            else
            {
                this.TextClass = textClass;
            }
            // to ensure "languageId" is required (not null)
            if (languageId == null)
            {
                throw new InvalidDataException("languageId is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey and cannot be null");
            }
            else
            {
                this.LanguageId = languageId;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;Text number (number of the row)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Text number (number of the row)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="textNumber", EmitDefaultValue=false)]
        public int? TextNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Text class (as part of the reference to the text)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Text class (as part of the reference to the text)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="textClass", EmitDefaultValue=false)]
        public string TextClass { get; set; }

        /// <summary>
        /// &lt;p&gt;A combination of ISO-639-1 and ISO-3661-1 or an own identifier to denote the language&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A combination of ISO-639-1 and ISO-3661-1 or an own identifier to denote the language&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="languageId", EmitDefaultValue=false)]
        public string LanguageId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey {\n");
            sb.Append("  TextNumber: ").Append(TextNumber).Append("\n");
            sb.Append("  TextClass: ").Append(TextClass).Append("\n");
            sb.Append("  LanguageId: ").Append(LanguageId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemTextKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TextNumber == input.TextNumber ||
                    (this.TextNumber != null &&
                    this.TextNumber.Equals(input.TextNumber))
                ) && 
                (
                    this.TextClass == input.TextClass ||
                    (this.TextClass != null &&
                    this.TextClass.Equals(input.TextClass))
                ) && 
                (
                    this.LanguageId == input.LanguageId ||
                    (this.LanguageId != null &&
                    this.LanguageId.Equals(input.LanguageId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TextNumber != null)
                    hashCode = hashCode * 59 + this.TextNumber.GetHashCode();
                if (this.TextClass != null)
                    hashCode = hashCode * 59 + this.TextClass.GetHashCode();
                if (this.LanguageId != null)
                    hashCode = hashCode * 59 + this.LanguageId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
