/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FuellingPointDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="fuellingPointID">&lt;p&gt;A unique identifier for the FuelingPoint at a particular BusinessUnitGroup&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey(string businessUnitGroupID = default(string), string fuellingPointID = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "fuellingPointID" is required (not null)
            if (fuellingPointID == null)
            {
                throw new InvalidDataException("fuellingPointID is a required property for ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey and cannot be null");
            }
            else
            {
                this.FuellingPointID = fuellingPointID;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique identifier for the FuelingPoint at a particular BusinessUnitGroup&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique identifier for the FuelingPoint at a particular BusinessUnitGroup&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="fuellingPointID", EmitDefaultValue=false)]
        public string FuellingPointID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  FuellingPointID: ").Append(FuellingPointID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdPetrolDtoDomFuellingPointDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.FuellingPointID == input.FuellingPointID ||
                    (this.FuellingPointID != null &&
                    this.FuellingPointID.Equals(input.FuellingPointID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.FuellingPointID != null)
                    hashCode = hashCode * 59 + this.FuellingPointID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
