/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TenderRestrictionRule.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey :  IEquatable<ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for a group of business units.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="tenderTypeCode">&lt;p&gt;A code which uniquely identifies the type of tender, ie cash, check, credit card, etc.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="forbiddenTransactionTypeCode">&lt;p&gt;Transaction type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any transaction type)&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="forbiddenLineItemTypeCode">&lt;p&gt;Position type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any position type)&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey(string businessUnitGroupID = default(string), string tenderTypeCode = default(string), string forbiddenTransactionTypeCode = default(string), string forbiddenLineItemTypeCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "tenderTypeCode" is required (not null)
            if (tenderTypeCode == null)
            {
                throw new InvalidDataException("tenderTypeCode is a required property for ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey and cannot be null");
            }
            else
            {
                this.TenderTypeCode = tenderTypeCode;
            }
            // to ensure "forbiddenTransactionTypeCode" is required (not null)
            if (forbiddenTransactionTypeCode == null)
            {
                throw new InvalidDataException("forbiddenTransactionTypeCode is a required property for ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey and cannot be null");
            }
            else
            {
                this.ForbiddenTransactionTypeCode = forbiddenTransactionTypeCode;
            }
            // to ensure "forbiddenLineItemTypeCode" is required (not null)
            if (forbiddenLineItemTypeCode == null)
            {
                throw new InvalidDataException("forbiddenLineItemTypeCode is a required property for ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey and cannot be null");
            }
            else
            {
                this.ForbiddenLineItemTypeCode = forbiddenLineItemTypeCode;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A code which uniquely identifies the type of tender, ie cash, check, credit card, etc.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code which uniquely identifies the type of tender, ie cash, check, credit card, etc.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="tenderTypeCode", EmitDefaultValue=false)]
        public string TenderTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Transaction type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any transaction type)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any transaction type)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="forbiddenTransactionTypeCode", EmitDefaultValue=false)]
        public string ForbiddenTransactionTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Position type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any position type)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Position type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any position type)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="forbiddenLineItemTypeCode", EmitDefaultValue=false)]
        public string ForbiddenLineItemTypeCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TenderTypeCode: ").Append(TenderTypeCode).Append("\n");
            sb.Append("  ForbiddenTransactionTypeCode: ").Append(ForbiddenTransactionTypeCode).Append("\n");
            sb.Append("  ForbiddenLineItemTypeCode: ").Append(ForbiddenLineItemTypeCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TenderTypeCode == input.TenderTypeCode ||
                    (this.TenderTypeCode != null &&
                    this.TenderTypeCode.Equals(input.TenderTypeCode))
                ) && 
                (
                    this.ForbiddenTransactionTypeCode == input.ForbiddenTransactionTypeCode ||
                    (this.ForbiddenTransactionTypeCode != null &&
                    this.ForbiddenTransactionTypeCode.Equals(input.ForbiddenTransactionTypeCode))
                ) && 
                (
                    this.ForbiddenLineItemTypeCode == input.ForbiddenLineItemTypeCode ||
                    (this.ForbiddenLineItemTypeCode != null &&
                    this.ForbiddenLineItemTypeCode.Equals(input.ForbiddenLineItemTypeCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TenderTypeCode != null)
                    hashCode = hashCode * 59 + this.TenderTypeCode.GetHashCode();
                if (this.ForbiddenTransactionTypeCode != null)
                    hashCode = hashCode * 59 + this.ForbiddenTransactionTypeCode.GetHashCode();
                if (this.ForbiddenLineItemTypeCode != null)
                    hashCode = hashCode * 59 + this.ForbiddenLineItemTypeCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
