/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// LoyaltyRewardLineItem &lt;emph&gt;undocumented&lt;/emph&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem" /> class.
        /// </summary>
        /// <param name="key">&lt;p&gt;Getter for inner key class.&lt;/p&gt; (required).</param>
        /// <param name="pointsAwardedCount">The number of loyalty points awarded. &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!.</param>
        /// <param name="loyaltyRewardTypeCode">Describes the kind of loyalty reward, possible values include frequent shopper points, coupon, gift certificate .</param>
        /// <param name="promotionID">The unique identifier of the promotion..</param>
        /// <param name="priceDerivationRuleID">The unique identifier of the price derivation rule. .</param>
        /// <param name="priceDerivationRuleEligibilityID">The unique identifier of the root eligibility..</param>
        /// <param name="frequentShopperPointsEarnedAmount">The money equivalent (expressed in local currency) to the number of frequent shopper points earned (PointsAwardedCount)  (required).</param>
        /// <param name="triggerSequenceNumber">The ident of the manual trigger (because one line item can have more than one trigger) .</param>
        /// <param name="computationBaseAmount">The amount which was used as base for the points&#39; calculation  (required).</param>
        /// <param name="externalSystemOriginatorFlag">Determines whether this entry was created by an external system - if yes, it must not be changed, but own price modifications with higher sequence may be applied  (required).</param>
        /// <param name="couponNumber">The number of the coupon the customer gets .</param>
        /// <param name="couponAmount">The monetary value of the coupon the customer gets  (required).</param>
        /// <param name="giftCertificateFaceValueAmount">The monetary value printed or embossed on the GIFT CERTIFICATE. (required).</param>
        /// <param name="pointsPercentage">The points calculation rule to be applied, expressed as a percentage of the calculation base. Corresponds to ItemPriceDerivationRule.PriceModificationPercent if available.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(13, 4). Be aware of this and round value!.</param>
        /// <param name="loyaltyRewardLineItemCouponSerialList">list of coupon serials.</param>
        /// <param name="xxcustom05">Customizable information.</param>
        /// <param name="xxcustom03">Customizable information.</param>
        /// <param name="xxcustom02">Customizable information.</param>
        /// <param name="xxcustom04">Customizable information.</param>
        /// <param name="xxcustom01">Customizable information.</param>
        public ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem(ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemKey key = default(ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemKey), double? pointsAwardedCount = default(double?), string loyaltyRewardTypeCode = default(string), string promotionID = default(string), string priceDerivationRuleID = default(string), string priceDerivationRuleEligibilityID = default(string), double? frequentShopperPointsEarnedAmount = default(double?), int? triggerSequenceNumber = default(int?), double? computationBaseAmount = default(double?), bool? externalSystemOriginatorFlag = default(bool?), string couponNumber = default(string), double? couponAmount = default(double?), double? giftCertificateFaceValueAmount = default(double?), double? pointsPercentage = default(double?), List<ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemCouponSerial> loyaltyRewardLineItemCouponSerialList = default(List<ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemCouponSerial>), string xxcustom05 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom01 = default(string))
        {
            // to ensure "key" is required (not null)
            if (key == null)
            {
                throw new InvalidDataException("key is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.Key = key;
            }
            // to ensure "frequentShopperPointsEarnedAmount" is required (not null)
            if (frequentShopperPointsEarnedAmount == null)
            {
                throw new InvalidDataException("frequentShopperPointsEarnedAmount is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.FrequentShopperPointsEarnedAmount = frequentShopperPointsEarnedAmount;
            }
            // to ensure "computationBaseAmount" is required (not null)
            if (computationBaseAmount == null)
            {
                throw new InvalidDataException("computationBaseAmount is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.ComputationBaseAmount = computationBaseAmount;
            }
            // to ensure "externalSystemOriginatorFlag" is required (not null)
            if (externalSystemOriginatorFlag == null)
            {
                throw new InvalidDataException("externalSystemOriginatorFlag is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.ExternalSystemOriginatorFlag = externalSystemOriginatorFlag;
            }
            // to ensure "couponAmount" is required (not null)
            if (couponAmount == null)
            {
                throw new InvalidDataException("couponAmount is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.CouponAmount = couponAmount;
            }
            // to ensure "giftCertificateFaceValueAmount" is required (not null)
            if (giftCertificateFaceValueAmount == null)
            {
                throw new InvalidDataException("giftCertificateFaceValueAmount is a required property for ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem and cannot be null");
            }
            else
            {
                this.GiftCertificateFaceValueAmount = giftCertificateFaceValueAmount;
            }
            this.PointsAwardedCount = pointsAwardedCount;
            this.LoyaltyRewardTypeCode = loyaltyRewardTypeCode;
            this.PromotionID = promotionID;
            this.PriceDerivationRuleID = priceDerivationRuleID;
            this.PriceDerivationRuleEligibilityID = priceDerivationRuleEligibilityID;
            this.TriggerSequenceNumber = triggerSequenceNumber;
            this.CouponNumber = couponNumber;
            this.PointsPercentage = pointsPercentage;
            this.LoyaltyRewardLineItemCouponSerialList = loyaltyRewardLineItemCouponSerialList;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        [DataMember(Name="key", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemKey Key { get; set; }

        /// <summary>
        /// The number of loyalty points awarded. &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The number of loyalty points awarded. &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        [DataMember(Name="pointsAwardedCount", EmitDefaultValue=false)]
        public double? PointsAwardedCount { get; set; }

        /// <summary>
        /// Describes the kind of loyalty reward, possible values include frequent shopper points, coupon, gift certificate 
        /// </summary>
        /// <value>Describes the kind of loyalty reward, possible values include frequent shopper points, coupon, gift certificate </value>
        [DataMember(Name="loyaltyRewardTypeCode", EmitDefaultValue=false)]
        public string LoyaltyRewardTypeCode { get; set; }

        /// <summary>
        /// The unique identifier of the promotion.
        /// </summary>
        /// <value>The unique identifier of the promotion.</value>
        [DataMember(Name="promotionID", EmitDefaultValue=false)]
        public string PromotionID { get; set; }

        /// <summary>
        /// The unique identifier of the price derivation rule. 
        /// </summary>
        /// <value>The unique identifier of the price derivation rule. </value>
        [DataMember(Name="priceDerivationRuleID", EmitDefaultValue=false)]
        public string PriceDerivationRuleID { get; set; }

        /// <summary>
        /// The unique identifier of the root eligibility.
        /// </summary>
        /// <value>The unique identifier of the root eligibility.</value>
        [DataMember(Name="priceDerivationRuleEligibilityID", EmitDefaultValue=false)]
        public string PriceDerivationRuleEligibilityID { get; set; }

        /// <summary>
        /// The money equivalent (expressed in local currency) to the number of frequent shopper points earned (PointsAwardedCount) 
        /// </summary>
        /// <value>The money equivalent (expressed in local currency) to the number of frequent shopper points earned (PointsAwardedCount) </value>
        [DataMember(Name="frequentShopperPointsEarnedAmount", EmitDefaultValue=false)]
        public double? FrequentShopperPointsEarnedAmount { get; set; }

        /// <summary>
        /// The ident of the manual trigger (because one line item can have more than one trigger) 
        /// </summary>
        /// <value>The ident of the manual trigger (because one line item can have more than one trigger) </value>
        [DataMember(Name="triggerSequenceNumber", EmitDefaultValue=false)]
        public int? TriggerSequenceNumber { get; set; }

        /// <summary>
        /// The amount which was used as base for the points&#39; calculation 
        /// </summary>
        /// <value>The amount which was used as base for the points&#39; calculation </value>
        [DataMember(Name="computationBaseAmount", EmitDefaultValue=false)]
        public double? ComputationBaseAmount { get; set; }

        /// <summary>
        /// Determines whether this entry was created by an external system - if yes, it must not be changed, but own price modifications with higher sequence may be applied 
        /// </summary>
        /// <value>Determines whether this entry was created by an external system - if yes, it must not be changed, but own price modifications with higher sequence may be applied </value>
        [DataMember(Name="externalSystemOriginatorFlag", EmitDefaultValue=false)]
        public bool? ExternalSystemOriginatorFlag { get; set; }

        /// <summary>
        /// The number of the coupon the customer gets 
        /// </summary>
        /// <value>The number of the coupon the customer gets </value>
        [DataMember(Name="couponNumber", EmitDefaultValue=false)]
        public string CouponNumber { get; set; }

        /// <summary>
        /// The monetary value of the coupon the customer gets 
        /// </summary>
        /// <value>The monetary value of the coupon the customer gets </value>
        [DataMember(Name="couponAmount", EmitDefaultValue=false)]
        public double? CouponAmount { get; set; }

        /// <summary>
        /// The monetary value printed or embossed on the GIFT CERTIFICATE.
        /// </summary>
        /// <value>The monetary value printed or embossed on the GIFT CERTIFICATE.</value>
        [DataMember(Name="giftCertificateFaceValueAmount", EmitDefaultValue=false)]
        public double? GiftCertificateFaceValueAmount { get; set; }

        /// <summary>
        /// The points calculation rule to be applied, expressed as a percentage of the calculation base. Corresponds to ItemPriceDerivationRule.PriceModificationPercent if available.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(13, 4). Be aware of this and round value!
        /// </summary>
        /// <value>The points calculation rule to be applied, expressed as a percentage of the calculation base. Corresponds to ItemPriceDerivationRule.PriceModificationPercent if available.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(13, 4). Be aware of this and round value!</value>
        [DataMember(Name="pointsPercentage", EmitDefaultValue=false)]
        public double? PointsPercentage { get; set; }

        /// <summary>
        /// list of coupon serials
        /// </summary>
        /// <value>list of coupon serials</value>
        [DataMember(Name="loyaltyRewardLineItemCouponSerialList", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItemCouponSerial> LoyaltyRewardLineItemCouponSerialList { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem {\n");
            sb.Append("  Key: ").Append(Key).Append("\n");
            sb.Append("  PointsAwardedCount: ").Append(PointsAwardedCount).Append("\n");
            sb.Append("  LoyaltyRewardTypeCode: ").Append(LoyaltyRewardTypeCode).Append("\n");
            sb.Append("  PromotionID: ").Append(PromotionID).Append("\n");
            sb.Append("  PriceDerivationRuleID: ").Append(PriceDerivationRuleID).Append("\n");
            sb.Append("  PriceDerivationRuleEligibilityID: ").Append(PriceDerivationRuleEligibilityID).Append("\n");
            sb.Append("  FrequentShopperPointsEarnedAmount: ").Append(FrequentShopperPointsEarnedAmount).Append("\n");
            sb.Append("  TriggerSequenceNumber: ").Append(TriggerSequenceNumber).Append("\n");
            sb.Append("  ComputationBaseAmount: ").Append(ComputationBaseAmount).Append("\n");
            sb.Append("  ExternalSystemOriginatorFlag: ").Append(ExternalSystemOriginatorFlag).Append("\n");
            sb.Append("  CouponNumber: ").Append(CouponNumber).Append("\n");
            sb.Append("  CouponAmount: ").Append(CouponAmount).Append("\n");
            sb.Append("  GiftCertificateFaceValueAmount: ").Append(GiftCertificateFaceValueAmount).Append("\n");
            sb.Append("  PointsPercentage: ").Append(PointsPercentage).Append("\n");
            sb.Append("  LoyaltyRewardLineItemCouponSerialList: ").Append(LoyaltyRewardLineItemCouponSerialList).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoLoyaltyRewardLineItem input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Key == input.Key ||
                    (this.Key != null &&
                    this.Key.Equals(input.Key))
                ) && 
                (
                    this.PointsAwardedCount == input.PointsAwardedCount ||
                    (this.PointsAwardedCount != null &&
                    this.PointsAwardedCount.Equals(input.PointsAwardedCount))
                ) && 
                (
                    this.LoyaltyRewardTypeCode == input.LoyaltyRewardTypeCode ||
                    (this.LoyaltyRewardTypeCode != null &&
                    this.LoyaltyRewardTypeCode.Equals(input.LoyaltyRewardTypeCode))
                ) && 
                (
                    this.PromotionID == input.PromotionID ||
                    (this.PromotionID != null &&
                    this.PromotionID.Equals(input.PromotionID))
                ) && 
                (
                    this.PriceDerivationRuleID == input.PriceDerivationRuleID ||
                    (this.PriceDerivationRuleID != null &&
                    this.PriceDerivationRuleID.Equals(input.PriceDerivationRuleID))
                ) && 
                (
                    this.PriceDerivationRuleEligibilityID == input.PriceDerivationRuleEligibilityID ||
                    (this.PriceDerivationRuleEligibilityID != null &&
                    this.PriceDerivationRuleEligibilityID.Equals(input.PriceDerivationRuleEligibilityID))
                ) && 
                (
                    this.FrequentShopperPointsEarnedAmount == input.FrequentShopperPointsEarnedAmount ||
                    (this.FrequentShopperPointsEarnedAmount != null &&
                    this.FrequentShopperPointsEarnedAmount.Equals(input.FrequentShopperPointsEarnedAmount))
                ) && 
                (
                    this.TriggerSequenceNumber == input.TriggerSequenceNumber ||
                    (this.TriggerSequenceNumber != null &&
                    this.TriggerSequenceNumber.Equals(input.TriggerSequenceNumber))
                ) && 
                (
                    this.ComputationBaseAmount == input.ComputationBaseAmount ||
                    (this.ComputationBaseAmount != null &&
                    this.ComputationBaseAmount.Equals(input.ComputationBaseAmount))
                ) && 
                (
                    this.ExternalSystemOriginatorFlag == input.ExternalSystemOriginatorFlag ||
                    (this.ExternalSystemOriginatorFlag != null &&
                    this.ExternalSystemOriginatorFlag.Equals(input.ExternalSystemOriginatorFlag))
                ) && 
                (
                    this.CouponNumber == input.CouponNumber ||
                    (this.CouponNumber != null &&
                    this.CouponNumber.Equals(input.CouponNumber))
                ) && 
                (
                    this.CouponAmount == input.CouponAmount ||
                    (this.CouponAmount != null &&
                    this.CouponAmount.Equals(input.CouponAmount))
                ) && 
                (
                    this.GiftCertificateFaceValueAmount == input.GiftCertificateFaceValueAmount ||
                    (this.GiftCertificateFaceValueAmount != null &&
                    this.GiftCertificateFaceValueAmount.Equals(input.GiftCertificateFaceValueAmount))
                ) && 
                (
                    this.PointsPercentage == input.PointsPercentage ||
                    (this.PointsPercentage != null &&
                    this.PointsPercentage.Equals(input.PointsPercentage))
                ) && 
                (
                    this.LoyaltyRewardLineItemCouponSerialList == input.LoyaltyRewardLineItemCouponSerialList ||
                    this.LoyaltyRewardLineItemCouponSerialList != null &&
                    this.LoyaltyRewardLineItemCouponSerialList.SequenceEqual(input.LoyaltyRewardLineItemCouponSerialList)
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Key != null)
                    hashCode = hashCode * 59 + this.Key.GetHashCode();
                if (this.PointsAwardedCount != null)
                    hashCode = hashCode * 59 + this.PointsAwardedCount.GetHashCode();
                if (this.LoyaltyRewardTypeCode != null)
                    hashCode = hashCode * 59 + this.LoyaltyRewardTypeCode.GetHashCode();
                if (this.PromotionID != null)
                    hashCode = hashCode * 59 + this.PromotionID.GetHashCode();
                if (this.PriceDerivationRuleID != null)
                    hashCode = hashCode * 59 + this.PriceDerivationRuleID.GetHashCode();
                if (this.PriceDerivationRuleEligibilityID != null)
                    hashCode = hashCode * 59 + this.PriceDerivationRuleEligibilityID.GetHashCode();
                if (this.FrequentShopperPointsEarnedAmount != null)
                    hashCode = hashCode * 59 + this.FrequentShopperPointsEarnedAmount.GetHashCode();
                if (this.TriggerSequenceNumber != null)
                    hashCode = hashCode * 59 + this.TriggerSequenceNumber.GetHashCode();
                if (this.ComputationBaseAmount != null)
                    hashCode = hashCode * 59 + this.ComputationBaseAmount.GetHashCode();
                if (this.ExternalSystemOriginatorFlag != null)
                    hashCode = hashCode * 59 + this.ExternalSystemOriginatorFlag.GetHashCode();
                if (this.CouponNumber != null)
                    hashCode = hashCode * 59 + this.CouponNumber.GetHashCode();
                if (this.CouponAmount != null)
                    hashCode = hashCode * 59 + this.CouponAmount.GetHashCode();
                if (this.GiftCertificateFaceValueAmount != null)
                    hashCode = hashCode * 59 + this.GiftCertificateFaceValueAmount.GetHashCode();
                if (this.PointsPercentage != null)
                    hashCode = hashCode * 59 + this.PointsPercentage.GetHashCode();
                if (this.LoyaltyRewardLineItemCouponSerialList != null)
                    hashCode = hashCode * 59 + this.LoyaltyRewardLineItemCouponSerialList.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
