/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RetailTransactionLineItemAdditionalParameter.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">A unique system assigned identifier for a group of BusinessUnits. (required).</param>
        /// <param name="transactionID">A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members.  (required).</param>
        /// <param name="retailTransactionLineItemSequenceNumber">The sequence number of line item within the context of this RetailTransaction.  (required).</param>
        /// <param name="externalParameterID">The external parameter ident (is needed for export), e.g. ident of an additional input field  (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? retailTransactionLineItemSequenceNumber = default(int?), string externalParameterID = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "retailTransactionLineItemSequenceNumber" is required (not null)
            if (retailTransactionLineItemSequenceNumber == null)
            {
                throw new InvalidDataException("retailTransactionLineItemSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey and cannot be null");
            }
            else
            {
                this.RetailTransactionLineItemSequenceNumber = retailTransactionLineItemSequenceNumber;
            }
            // to ensure "externalParameterID" is required (not null)
            if (externalParameterID == null)
            {
                throw new InvalidDataException("externalParameterID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey and cannot be null");
            }
            else
            {
                this.ExternalParameterID = externalParameterID;
            }
        }
        
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        [DataMember(Name="retailTransactionLineItemSequenceNumber", EmitDefaultValue=false)]
        public int? RetailTransactionLineItemSequenceNumber { get; set; }

        /// <summary>
        /// The external parameter ident (is needed for export), e.g. ident of an additional input field 
        /// </summary>
        /// <value>The external parameter ident (is needed for export), e.g. ident of an additional input field </value>
        [DataMember(Name="externalParameterID", EmitDefaultValue=false)]
        public string ExternalParameterID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  RetailTransactionLineItemSequenceNumber: ").Append(RetailTransactionLineItemSequenceNumber).Append("\n");
            sb.Append("  ExternalParameterID: ").Append(ExternalParameterID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAdditionalParameterKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.RetailTransactionLineItemSequenceNumber == input.RetailTransactionLineItemSequenceNumber ||
                    (this.RetailTransactionLineItemSequenceNumber != null &&
                    this.RetailTransactionLineItemSequenceNumber.Equals(input.RetailTransactionLineItemSequenceNumber))
                ) && 
                (
                    this.ExternalParameterID == input.ExternalParameterID ||
                    (this.ExternalParameterID != null &&
                    this.ExternalParameterID.Equals(input.ExternalParameterID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.RetailTransactionLineItemSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemSequenceNumber.GetHashCode();
                if (this.ExternalParameterID != null)
                    hashCode = hashCode * 59 + this.ExternalParameterID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
