/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RetailTransactionLineItemAuditEvent.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">ID of the business unit group (required).</param>
        /// <param name="transactionID">ID of the transaction (required).</param>
        /// <param name="retailTransactionLineItemSequenceNumber">The sequence number of line item within the context of this RetailTransaction. Must be updated during retrieve. (required).</param>
        /// <param name="eventSequenceNumber">A unique identifier (within the context of the Transaction) for this event entry.  (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? retailTransactionLineItemSequenceNumber = default(int?), int? eventSequenceNumber = default(int?))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "retailTransactionLineItemSequenceNumber" is required (not null)
            if (retailTransactionLineItemSequenceNumber == null)
            {
                throw new InvalidDataException("retailTransactionLineItemSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey and cannot be null");
            }
            else
            {
                this.RetailTransactionLineItemSequenceNumber = retailTransactionLineItemSequenceNumber;
            }
            // to ensure "eventSequenceNumber" is required (not null)
            if (eventSequenceNumber == null)
            {
                throw new InvalidDataException("eventSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey and cannot be null");
            }
            else
            {
                this.EventSequenceNumber = eventSequenceNumber;
            }
        }
        
        /// <summary>
        /// ID of the business unit group
        /// </summary>
        /// <value>ID of the business unit group</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// ID of the transaction
        /// </summary>
        /// <value>ID of the transaction</value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. Must be updated during retrieve.
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. Must be updated during retrieve.</value>
        [DataMember(Name="retailTransactionLineItemSequenceNumber", EmitDefaultValue=false)]
        public int? RetailTransactionLineItemSequenceNumber { get; set; }

        /// <summary>
        /// A unique identifier (within the context of the Transaction) for this event entry. 
        /// </summary>
        /// <value>A unique identifier (within the context of the Transaction) for this event entry. </value>
        [DataMember(Name="eventSequenceNumber", EmitDefaultValue=false)]
        public int? EventSequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  RetailTransactionLineItemSequenceNumber: ").Append(RetailTransactionLineItemSequenceNumber).Append("\n");
            sb.Append("  EventSequenceNumber: ").Append(EventSequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemAuditEventKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.RetailTransactionLineItemSequenceNumber == input.RetailTransactionLineItemSequenceNumber ||
                    (this.RetailTransactionLineItemSequenceNumber != null &&
                    this.RetailTransactionLineItemSequenceNumber.Equals(input.RetailTransactionLineItemSequenceNumber))
                ) && 
                (
                    this.EventSequenceNumber == input.EventSequenceNumber ||
                    (this.EventSequenceNumber != null &&
                    this.EventSequenceNumber.Equals(input.EventSequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.RetailTransactionLineItemSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemSequenceNumber.GetHashCode();
                if (this.EventSequenceNumber != null)
                    hashCode = hashCode * 59 + this.EventSequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
