/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SaleReturnLineItemModifierCoupon.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">A unique system assigned identifier for a group of BusinessUnits. (required).</param>
        /// <param name="transactionID">A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members.  (required).</param>
        /// <param name="retailTransactionLineItemSequenceNumber">The sequence number of line item within the context of this RetailTransaction.  (required).</param>
        /// <param name="modifierSequenceNumber">The sequence number of the related FrequentShopperPointsModifier resp. RetailPriceModifier  (required).</param>
        /// <param name="promotionID">The unique identifier of the promotion. (required).</param>
        /// <param name="priceDerivationRuleID">The unique identifier of the price derivation rule.  (required).</param>
        /// <param name="priceDerivationRuleEligibilityID">The unique identifier of the root eligibility. (required).</param>
        /// <param name="couponSequenceNumber">The sequential number of the coupon entry (starting with 1), in case there was more than one coupon registered for one modifier  (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? retailTransactionLineItemSequenceNumber = default(int?), int? modifierSequenceNumber = default(int?), string promotionID = default(string), string priceDerivationRuleID = default(string), string priceDerivationRuleEligibilityID = default(string), int? couponSequenceNumber = default(int?))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "retailTransactionLineItemSequenceNumber" is required (not null)
            if (retailTransactionLineItemSequenceNumber == null)
            {
                throw new InvalidDataException("retailTransactionLineItemSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.RetailTransactionLineItemSequenceNumber = retailTransactionLineItemSequenceNumber;
            }
            // to ensure "modifierSequenceNumber" is required (not null)
            if (modifierSequenceNumber == null)
            {
                throw new InvalidDataException("modifierSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.ModifierSequenceNumber = modifierSequenceNumber;
            }
            // to ensure "promotionID" is required (not null)
            if (promotionID == null)
            {
                throw new InvalidDataException("promotionID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.PromotionID = promotionID;
            }
            // to ensure "priceDerivationRuleID" is required (not null)
            if (priceDerivationRuleID == null)
            {
                throw new InvalidDataException("priceDerivationRuleID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.PriceDerivationRuleID = priceDerivationRuleID;
            }
            // to ensure "priceDerivationRuleEligibilityID" is required (not null)
            if (priceDerivationRuleEligibilityID == null)
            {
                throw new InvalidDataException("priceDerivationRuleEligibilityID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.PriceDerivationRuleEligibilityID = priceDerivationRuleEligibilityID;
            }
            // to ensure "couponSequenceNumber" is required (not null)
            if (couponSequenceNumber == null)
            {
                throw new InvalidDataException("couponSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey and cannot be null");
            }
            else
            {
                this.CouponSequenceNumber = couponSequenceNumber;
            }
        }
        
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        [DataMember(Name="retailTransactionLineItemSequenceNumber", EmitDefaultValue=false)]
        public int? RetailTransactionLineItemSequenceNumber { get; set; }

        /// <summary>
        /// The sequence number of the related FrequentShopperPointsModifier resp. RetailPriceModifier 
        /// </summary>
        /// <value>The sequence number of the related FrequentShopperPointsModifier resp. RetailPriceModifier </value>
        [DataMember(Name="modifierSequenceNumber", EmitDefaultValue=false)]
        public int? ModifierSequenceNumber { get; set; }

        /// <summary>
        /// The unique identifier of the promotion.
        /// </summary>
        /// <value>The unique identifier of the promotion.</value>
        [DataMember(Name="promotionID", EmitDefaultValue=false)]
        public string PromotionID { get; set; }

        /// <summary>
        /// The unique identifier of the price derivation rule. 
        /// </summary>
        /// <value>The unique identifier of the price derivation rule. </value>
        [DataMember(Name="priceDerivationRuleID", EmitDefaultValue=false)]
        public string PriceDerivationRuleID { get; set; }

        /// <summary>
        /// The unique identifier of the root eligibility.
        /// </summary>
        /// <value>The unique identifier of the root eligibility.</value>
        [DataMember(Name="priceDerivationRuleEligibilityID", EmitDefaultValue=false)]
        public string PriceDerivationRuleEligibilityID { get; set; }

        /// <summary>
        /// The sequential number of the coupon entry (starting with 1), in case there was more than one coupon registered for one modifier 
        /// </summary>
        /// <value>The sequential number of the coupon entry (starting with 1), in case there was more than one coupon registered for one modifier </value>
        [DataMember(Name="couponSequenceNumber", EmitDefaultValue=false)]
        public int? CouponSequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  RetailTransactionLineItemSequenceNumber: ").Append(RetailTransactionLineItemSequenceNumber).Append("\n");
            sb.Append("  ModifierSequenceNumber: ").Append(ModifierSequenceNumber).Append("\n");
            sb.Append("  PromotionID: ").Append(PromotionID).Append("\n");
            sb.Append("  PriceDerivationRuleID: ").Append(PriceDerivationRuleID).Append("\n");
            sb.Append("  PriceDerivationRuleEligibilityID: ").Append(PriceDerivationRuleEligibilityID).Append("\n");
            sb.Append("  CouponSequenceNumber: ").Append(CouponSequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.RetailTransactionLineItemSequenceNumber == input.RetailTransactionLineItemSequenceNumber ||
                    (this.RetailTransactionLineItemSequenceNumber != null &&
                    this.RetailTransactionLineItemSequenceNumber.Equals(input.RetailTransactionLineItemSequenceNumber))
                ) && 
                (
                    this.ModifierSequenceNumber == input.ModifierSequenceNumber ||
                    (this.ModifierSequenceNumber != null &&
                    this.ModifierSequenceNumber.Equals(input.ModifierSequenceNumber))
                ) && 
                (
                    this.PromotionID == input.PromotionID ||
                    (this.PromotionID != null &&
                    this.PromotionID.Equals(input.PromotionID))
                ) && 
                (
                    this.PriceDerivationRuleID == input.PriceDerivationRuleID ||
                    (this.PriceDerivationRuleID != null &&
                    this.PriceDerivationRuleID.Equals(input.PriceDerivationRuleID))
                ) && 
                (
                    this.PriceDerivationRuleEligibilityID == input.PriceDerivationRuleEligibilityID ||
                    (this.PriceDerivationRuleEligibilityID != null &&
                    this.PriceDerivationRuleEligibilityID.Equals(input.PriceDerivationRuleEligibilityID))
                ) && 
                (
                    this.CouponSequenceNumber == input.CouponSequenceNumber ||
                    (this.CouponSequenceNumber != null &&
                    this.CouponSequenceNumber.Equals(input.CouponSequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.RetailTransactionLineItemSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemSequenceNumber.GetHashCode();
                if (this.ModifierSequenceNumber != null)
                    hashCode = hashCode * 59 + this.ModifierSequenceNumber.GetHashCode();
                if (this.PromotionID != null)
                    hashCode = hashCode * 59 + this.PromotionID.GetHashCode();
                if (this.PriceDerivationRuleID != null)
                    hashCode = hashCode * 59 + this.PriceDerivationRuleID.GetHashCode();
                if (this.PriceDerivationRuleEligibilityID != null)
                    hashCode = hashCode * 59 + this.PriceDerivationRuleEligibilityID.GetHashCode();
                if (this.CouponSequenceNumber != null)
                    hashCode = hashCode * 59 + this.CouponSequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
