/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AllowedTendersConfig &lt;p&gt;This configuration entity defines the allowed tenders process.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;Type of additional allowed tender validation to perform for returns.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type of additional allowed tender validation to perform for returns.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ReturnTenderRuleEnum
        {
            
            /// <summary>
            /// Enum TOANY for value: RETURN_TO_ANY
            /// </summary>
            [EnumMember(Value = "RETURN_TO_ANY")]
            TOANY = 1,
            
            /// <summary>
            /// Enum TOANYMAPPED for value: RETURN_TO_ANY_MAPPED
            /// </summary>
            [EnumMember(Value = "RETURN_TO_ANY_MAPPED")]
            TOANYMAPPED = 2,
            
            /// <summary>
            /// Enum TENDERTOTALTOMAPPED for value: RETURN_TENDER_TOTAL_TO_MAPPED
            /// </summary>
            [EnumMember(Value = "RETURN_TENDER_TOTAL_TO_MAPPED")]
            TENDERTOTALTOMAPPED = 3,
            
            /// <summary>
            /// Enum ITEMTOTALTOMAPPED for value: RETURN_ITEM_TOTAL_TO_MAPPED
            /// </summary>
            [EnumMember(Value = "RETURN_ITEM_TOTAL_TO_MAPPED")]
            ITEMTOTALTOMAPPED = 4
        }

        /// <summary>
        /// &lt;p&gt;Type of additional allowed tender validation to perform for returns.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type of additional allowed tender validation to perform for returns.&lt;/p&gt;</value>
        [DataMember(Name="returnTenderRule", EmitDefaultValue=false)]
        public ReturnTenderRuleEnum ReturnTenderRule { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig" /> class.
        /// </summary>
        /// <param name="processId">&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt; (required).</param>
        /// <param name="mainProcess">&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;.</param>
        /// <param name="authorizationConfig">&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;.</param>
        /// <param name="checkReasonTender">&lt;p&gt;This parameter enables admissibility checks based on payin/payout reasons.&lt;/p&gt; (required).</param>
        /// <param name="checkCustomerGroupTender">&lt;p&gt;This parameter enables admissibility checks based on a customer group assignment.&lt;/p&gt; (required).</param>
        /// <param name="checkNegativeTotal">&lt;p&gt;This parameter enables additional admissibility checks in case of a negative receipt total.&lt;br /&gt; @deprecated - since 5.9.2 this is not longer used.&lt;br /&gt; Use instead: returnTenderRule&lt;br /&gt; false -&amp;gt; RETURN_TO_ANY&lt;br /&gt; true -&amp;gt; RETURN_TO_ANY_MAPPED&lt;/p&gt; (required).</param>
        /// <param name="returnTenderRule">&lt;p&gt;Type of additional allowed tender validation to perform for returns.&lt;/p&gt; (required).</param>
        /// <param name="useTenderFromMasterData">&lt;p&gt;This parameter indicates whether tenders are used from the master data or taken from an existing collection for collection creation/updates.&lt;/p&gt; (required).</param>
        /// <param name="filterRulesChain">&lt;p&gt;This parameter defines the tender filter rules chain (filters are executed in order).&lt;/p&gt; (required).</param>
        /// <param name="overrideAdmissibilityPossible">&lt;p&gt;This parameter specifies whether it is possible to override the admissibility of the selected tender for a customer temporary.&lt;/p&gt; (required).</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig(string processId = default(string), bool? mainProcess = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig authorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), bool? checkReasonTender = default(bool?), bool? checkCustomerGroupTender = default(bool?), bool? checkNegativeTotal = default(bool?), ReturnTenderRuleEnum returnTenderRule = default(ReturnTenderRuleEnum), bool? useTenderFromMasterData = default(bool?), List<string> filterRulesChain = default(List<string>), bool? overrideAdmissibilityPossible = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "processId" is required (not null)
            if (processId == null)
            {
                throw new InvalidDataException("processId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.ProcessId = processId;
            }
            // to ensure "checkReasonTender" is required (not null)
            if (checkReasonTender == null)
            {
                throw new InvalidDataException("checkReasonTender is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.CheckReasonTender = checkReasonTender;
            }
            // to ensure "checkCustomerGroupTender" is required (not null)
            if (checkCustomerGroupTender == null)
            {
                throw new InvalidDataException("checkCustomerGroupTender is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.CheckCustomerGroupTender = checkCustomerGroupTender;
            }
            // to ensure "checkNegativeTotal" is required (not null)
            if (checkNegativeTotal == null)
            {
                throw new InvalidDataException("checkNegativeTotal is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.CheckNegativeTotal = checkNegativeTotal;
            }
            // to ensure "returnTenderRule" is required (not null)
            if (returnTenderRule == null)
            {
                throw new InvalidDataException("returnTenderRule is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.ReturnTenderRule = returnTenderRule;
            }
            // to ensure "useTenderFromMasterData" is required (not null)
            if (useTenderFromMasterData == null)
            {
                throw new InvalidDataException("useTenderFromMasterData is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.UseTenderFromMasterData = useTenderFromMasterData;
            }
            // to ensure "filterRulesChain" is required (not null)
            if (filterRulesChain == null)
            {
                throw new InvalidDataException("filterRulesChain is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.FilterRulesChain = filterRulesChain;
            }
            // to ensure "overrideAdmissibilityPossible" is required (not null)
            if (overrideAdmissibilityPossible == null)
            {
                throw new InvalidDataException("overrideAdmissibilityPossible is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig and cannot be null");
            }
            else
            {
                this.OverrideAdmissibilityPossible = overrideAdmissibilityPossible;
            }
            this.MainProcess = mainProcess;
            this.AuthorizationConfig = authorizationConfig;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;</value>
        [DataMember(Name="processId", EmitDefaultValue=false)]
        public string ProcessId { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;</value>
        [DataMember(Name="mainProcess", EmitDefaultValue=false)]
        public bool? MainProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines authorization related processes.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;</value>
        [DataMember(Name="authorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig AuthorizationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter enables admissibility checks based on payin/payout reasons.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter enables admissibility checks based on payin/payout reasons.&lt;/p&gt;</value>
        [DataMember(Name="checkReasonTender", EmitDefaultValue=false)]
        public bool? CheckReasonTender { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter enables admissibility checks based on a customer group assignment.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter enables admissibility checks based on a customer group assignment.&lt;/p&gt;</value>
        [DataMember(Name="checkCustomerGroupTender", EmitDefaultValue=false)]
        public bool? CheckCustomerGroupTender { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter enables additional admissibility checks in case of a negative receipt total.&lt;br /&gt; @deprecated - since 5.9.2 this is not longer used.&lt;br /&gt; Use instead: returnTenderRule&lt;br /&gt; false -&amp;gt; RETURN_TO_ANY&lt;br /&gt; true -&amp;gt; RETURN_TO_ANY_MAPPED&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter enables additional admissibility checks in case of a negative receipt total.&lt;br /&gt; @deprecated - since 5.9.2 this is not longer used.&lt;br /&gt; Use instead: returnTenderRule&lt;br /&gt; false -&amp;gt; RETURN_TO_ANY&lt;br /&gt; true -&amp;gt; RETURN_TO_ANY_MAPPED&lt;/p&gt;</value>
        [DataMember(Name="checkNegativeTotal", EmitDefaultValue=false)]
        public bool? CheckNegativeTotal { get; set; }


        /// <summary>
        /// &lt;p&gt;This parameter indicates whether tenders are used from the master data or taken from an existing collection for collection creation/updates.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether tenders are used from the master data or taken from an existing collection for collection creation/updates.&lt;/p&gt;</value>
        [DataMember(Name="useTenderFromMasterData", EmitDefaultValue=false)]
        public bool? UseTenderFromMasterData { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the tender filter rules chain (filters are executed in order).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the tender filter rules chain (filters are executed in order).&lt;/p&gt;</value>
        [DataMember(Name="filterRulesChain", EmitDefaultValue=false)]
        public List<string> FilterRulesChain { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether it is possible to override the admissibility of the selected tender for a customer temporary.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether it is possible to override the admissibility of the selected tender for a customer temporary.&lt;/p&gt;</value>
        [DataMember(Name="overrideAdmissibilityPossible", EmitDefaultValue=false)]
        public bool? OverrideAdmissibilityPossible { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig {\n");
            sb.Append("  ProcessId: ").Append(ProcessId).Append("\n");
            sb.Append("  MainProcess: ").Append(MainProcess).Append("\n");
            sb.Append("  AuthorizationConfig: ").Append(AuthorizationConfig).Append("\n");
            sb.Append("  CheckReasonTender: ").Append(CheckReasonTender).Append("\n");
            sb.Append("  CheckCustomerGroupTender: ").Append(CheckCustomerGroupTender).Append("\n");
            sb.Append("  CheckNegativeTotal: ").Append(CheckNegativeTotal).Append("\n");
            sb.Append("  ReturnTenderRule: ").Append(ReturnTenderRule).Append("\n");
            sb.Append("  UseTenderFromMasterData: ").Append(UseTenderFromMasterData).Append("\n");
            sb.Append("  FilterRulesChain: ").Append(FilterRulesChain).Append("\n");
            sb.Append("  OverrideAdmissibilityPossible: ").Append(OverrideAdmissibilityPossible).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProcessId == input.ProcessId ||
                    (this.ProcessId != null &&
                    this.ProcessId.Equals(input.ProcessId))
                ) && 
                (
                    this.MainProcess == input.MainProcess ||
                    (this.MainProcess != null &&
                    this.MainProcess.Equals(input.MainProcess))
                ) && 
                (
                    this.AuthorizationConfig == input.AuthorizationConfig ||
                    (this.AuthorizationConfig != null &&
                    this.AuthorizationConfig.Equals(input.AuthorizationConfig))
                ) && 
                (
                    this.CheckReasonTender == input.CheckReasonTender ||
                    (this.CheckReasonTender != null &&
                    this.CheckReasonTender.Equals(input.CheckReasonTender))
                ) && 
                (
                    this.CheckCustomerGroupTender == input.CheckCustomerGroupTender ||
                    (this.CheckCustomerGroupTender != null &&
                    this.CheckCustomerGroupTender.Equals(input.CheckCustomerGroupTender))
                ) && 
                (
                    this.CheckNegativeTotal == input.CheckNegativeTotal ||
                    (this.CheckNegativeTotal != null &&
                    this.CheckNegativeTotal.Equals(input.CheckNegativeTotal))
                ) && 
                (
                    this.ReturnTenderRule == input.ReturnTenderRule ||
                    (this.ReturnTenderRule != null &&
                    this.ReturnTenderRule.Equals(input.ReturnTenderRule))
                ) && 
                (
                    this.UseTenderFromMasterData == input.UseTenderFromMasterData ||
                    (this.UseTenderFromMasterData != null &&
                    this.UseTenderFromMasterData.Equals(input.UseTenderFromMasterData))
                ) && 
                (
                    this.FilterRulesChain == input.FilterRulesChain ||
                    this.FilterRulesChain != null &&
                    this.FilterRulesChain.SequenceEqual(input.FilterRulesChain)
                ) && 
                (
                    this.OverrideAdmissibilityPossible == input.OverrideAdmissibilityPossible ||
                    (this.OverrideAdmissibilityPossible != null &&
                    this.OverrideAdmissibilityPossible.Equals(input.OverrideAdmissibilityPossible))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProcessId != null)
                    hashCode = hashCode * 59 + this.ProcessId.GetHashCode();
                if (this.MainProcess != null)
                    hashCode = hashCode * 59 + this.MainProcess.GetHashCode();
                if (this.AuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.AuthorizationConfig.GetHashCode();
                if (this.CheckReasonTender != null)
                    hashCode = hashCode * 59 + this.CheckReasonTender.GetHashCode();
                if (this.CheckCustomerGroupTender != null)
                    hashCode = hashCode * 59 + this.CheckCustomerGroupTender.GetHashCode();
                if (this.CheckNegativeTotal != null)
                    hashCode = hashCode * 59 + this.CheckNegativeTotal.GetHashCode();
                if (this.ReturnTenderRule != null)
                    hashCode = hashCode * 59 + this.ReturnTenderRule.GetHashCode();
                if (this.UseTenderFromMasterData != null)
                    hashCode = hashCode * 59 + this.UseTenderFromMasterData.GetHashCode();
                if (this.FilterRulesChain != null)
                    hashCode = hashCode * 59 + this.FilterRulesChain.GetHashCode();
                if (this.OverrideAdmissibilityPossible != null)
                    hashCode = hashCode * 59 + this.OverrideAdmissibilityPossible.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
