/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ItemEntryConfig &lt;p&gt;This configuration entity defines itemEntry processes.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;The parameter defines the provider for the item data. Default Local.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the provider for the item data. Default Local.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ItemProviderEnum
        {
            
            /// <summary>
            /// Enum Local for value: Local
            /// </summary>
            [EnumMember(Value = "Local")]
            Local = 1,
            
            /// <summary>
            /// Enum LocalAndRemote for value: LocalAndRemote
            /// </summary>
            [EnumMember(Value = "LocalAndRemote")]
            LocalAndRemote = 2
        }

        /// <summary>
        /// &lt;p&gt;The parameter defines the provider for the item data. Default Local.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the provider for the item data. Default Local.&lt;/p&gt;</value>
        [DataMember(Name="itemProvider", EmitDefaultValue=false)]
        public ItemProviderEnum? ItemProvider { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig" /> class.
        /// </summary>
        /// <param name="processId">&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt; (required).</param>
        /// <param name="mainProcess">&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;.</param>
        /// <param name="authorizationConfig">&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;.</param>
        /// <param name="fixedItemNrEan">&lt;p&gt;This parameter defines a fixed item number/ EAN for fixed item keys.&lt;/p&gt;.</param>
        /// <param name="itemNrEan">&lt;p&gt;This parameter defines the input for the item number/ EAN.&lt;/p&gt;.</param>
        /// <param name="itemTraceableUnitID">&lt;p&gt;Input parameter for item traceable unit id (used for EPC codes scanned by RFID, for example)&lt;/p&gt;.</param>
        /// <param name="registrationNumber">&lt;p&gt;Raw barcode used for registration.&lt;/p&gt;.</param>
        /// <param name="textClassIds">&lt;p&gt;This parameter defines text class IDs.&lt;/p&gt;.</param>
        /// <param name="uomCode">&lt;p&gt;This parameter defines the unit of measure code.&lt;/p&gt;.</param>
        /// <param name="checkSalesRestrictions">&lt;p&gt;This parameter specifies whether sales restrictions are verified. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="checkSalesRestrictionsForReturn">&lt;p&gt;This parameter specifies whether sales restrictions are verified for return items. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="checkForVariants">&lt;p&gt;This parameter specifies whether a check is made for item variants. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="checkTaxGroup">&lt;p&gt;This parameter specifies whether the tax group should be validated.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; This means that the tax group exists in master data and fulfills the following conditions: TaxGroupRule.EffectiveDateTime &amp;lt;&#x3D; {current timestamp} and TaxGroupRule.ExpirationDateTime &amp;gt;&#x3D; {current timestamp}.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; The default is set at true.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="askForQuantity">&lt;p&gt;This parameter specifies whether a quantity is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="ageVerificationRequired">ageVerificationRequired (required).</param>
        /// <param name="checkSellerAgeRestrictions">&lt;p&gt;This parameter specifies whether seller age should be checked.&lt;/p&gt;.</param>
        /// <param name="confirmDialogAgeVerifacation">confirmDialogAgeVerifacation (required).</param>
        /// <param name="positionAmount">&lt;p&gt;This parameter defines the line item amount.&lt;/p&gt;.</param>
        /// <param name="itemPrice">&lt;p&gt;This parameter defines the unit price.&lt;/p&gt;.</param>
        /// <param name="factor">&lt;p&gt;This parameter defines the packaging quantity of an item.&lt;/p&gt;.</param>
        /// <param name="itemQuantity">&lt;p&gt;The parameter defines the single quantity in case of piece items.&lt;/p&gt;.</param>
        /// <param name="weight">&lt;p&gt;The parameter defines the manual weight in case of weight items.&lt;/p&gt;.</param>
        /// <param name="units">&lt;p&gt;The parameter defines the units in case of quantity with decimal places items (e.g. fuel items).&lt;/p&gt;.</param>
        /// <param name="serialNumber">&lt;p&gt;This parameter defines the serial number.&lt;/p&gt;.</param>
        /// <param name="saleableWithoutPrice">&lt;p&gt;This parameter specifies whether an item is salable even if no price exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="switchToItemSearch">&lt;p&gt;This parameter specifies whether the system switches to Item Search if no search term exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="askForReceiptText">&lt;p&gt;This parameter specifies whether the receipt text of the item is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="mode">&lt;p&gt;This parameter defines the mode. The default is set at 0.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: 0, 1, 2&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;0 - The standard item entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;1 - The set component entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;2 - The Bulk Registration is set.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="callPackageSelection">callPackageSelection.</param>
        /// <param name="itemPackageSelectionId">itemPackageSelectionId.</param>
        /// <param name="returnManualPositionAmountForWeightItemsRequired">&lt;p&gt;This parameter specifies whether the total price entry is requested in case of return of weighing items. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="returnReasonRequired">&lt;p&gt;This parameter specifies whether the reason is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="returnManualPriceRequired">&lt;p&gt;This parameter specifies whether a manual price entry is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="promptForReceiptTextConfig">&lt;p&gt;This config defines the Enter ReceiptText Dialog.&lt;/p&gt; (required).</param>
        /// <param name="promptForSerialNumberConfig">&lt;p&gt;This config defines the Enter SerialNumber Dialog.&lt;/p&gt; (required).</param>
        /// <param name="positionOperationConfig">&lt;p&gt;This config defines the position operation for registering.&lt;/p&gt; (required).</param>
        /// <param name="priceDifferenceLimitExceedAuthConfig">priceDifferenceLimitExceedAuthConfig (required).</param>
        /// <param name="promotionOperationConfig">promotionOperationConfig (required).</param>
        /// <param name="forceManualWeight">forceManualWeight (required).</param>
        /// <param name="quantityAccumulation">&lt;p&gt;It defines if the quantity of line items with the same item should be accumulated.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="itemRegistrationConfig">&lt;p&gt;It references the item details config to determine if additional info is needed&lt;/p&gt; (required).</param>
        /// <param name="itemIDCaseSensitive">itemIDCaseSensitive (required).</param>
        /// <param name="manualPriceAcousticSignalConfigId">&lt;p&gt;It references the acoustic signal configuration identifier for manual price input&lt;/p&gt; (required).</param>
        /// <param name="quantityAcousticSignalConfigId">&lt;p&gt;It references the acoustic signal configuration identifier for quantity input&lt;/p&gt; (required).</param>
        /// <param name="serialNumberAcousticSignalConfigId">&lt;p&gt;It references the acoustic signal configuration identifier for serial number input&lt;/p&gt; (required).</param>
        /// <param name="setQuantityForLineItemConfigId">&lt;p&gt;It references the SetQuantityForLineItemConfig identifier for the SetQuantityForLineItem sub process call.&lt;/p&gt; (required).</param>
        /// <param name="negativePositionProhibited">negativePositionProhibited (required).</param>
        /// <param name="customerOrderData">customerOrderData.</param>
        /// <param name="registerLineItemAddOnData">registerLineItemAddOnData.</param>
        /// <param name="additionalAttributes">&lt;p&gt;References the instance of configuration which indicates additional item related attributes to be assigned to sale return line item extensions during item registration.&lt;/p&gt;.</param>
        /// <param name="registerFuelLineItem">registerFuelLineItem.</param>
        /// <param name="removeOpenLineItemOnError">&lt;p&gt;It defines if an open line item (without item) will be removed if item entry fails with error.&lt;br /&gt; It should be set to true for barcode rules with multiple actions where second action is the item entry process.&lt;br /&gt; Default: null/false&lt;/p&gt;.</param>
        /// <param name="itemNotFoundAuthorizationConfig">&lt;p&gt;config item not found authorization. Mainly to be used by POS clients that will display an authorization error on item search failure (Ex: SCO)&lt;/p&gt; (required).</param>
        /// <param name="remoteServiceNotAvailableAuthorizationConfig">&lt;p&gt;config to handle remote service not available authorization errors, when doing remote item searches in SDC / SAP&lt;/p&gt; (required).</param>
        /// <param name="itemProvider">&lt;p&gt;The parameter defines the provider for the item data. Default Local.&lt;/p&gt;.</param>
        /// <param name="skipSalesRestrictionDialogs">&lt;p&gt;If true any forbidden dialogs for sales restrictions will be skipped.&lt;/p&gt;.</param>
        /// <param name="skipQuantityErrorDialogs">&lt;p&gt;If true any error dialogs triggered while setting quantity for line item will be skipped.&lt;/p&gt;.</param>
        /// <param name="salesRestrictionConfigID">&lt;p&gt;It defines the specific SalesRestriction configID for ItemEntryConfig, which will be overridden into sales restriction process (empty by default).&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig(string processId = default(string), bool? mainProcess = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig authorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), string fixedItemNrEan = default(string), string itemNrEan = default(string), string itemTraceableUnitID = default(string), string registrationNumber = default(string), List<string> textClassIds = default(List<string>), string uomCode = default(string), bool? checkSalesRestrictions = default(bool?), bool? checkSalesRestrictionsForReturn = default(bool?), bool? checkForVariants = default(bool?), bool? checkTaxGroup = default(bool?), bool? askForQuantity = default(bool?), bool? ageVerificationRequired = default(bool?), bool? checkSellerAgeRestrictions = default(bool?), ComGkSoftwarePosApiModelConfigProcessUiMessageDialogConfig confirmDialogAgeVerifacation = default(ComGkSoftwarePosApiModelConfigProcessUiMessageDialogConfig), double? positionAmount = default(double?), double? itemPrice = default(double?), double? factor = default(double?), int? itemQuantity = default(int?), double? weight = default(double?), double? units = default(double?), string serialNumber = default(string), bool? saleableWithoutPrice = default(bool?), bool? switchToItemSearch = default(bool?), bool? askForReceiptText = default(bool?), int? mode = default(int?), bool? callPackageSelection = default(bool?), string itemPackageSelectionId = default(string), bool? returnManualPositionAmountForWeightItemsRequired = default(bool?), bool? returnReasonRequired = default(bool?), bool? returnManualPriceRequired = default(bool?), ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig promptForReceiptTextConfig = default(ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig), ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig promptForSerialNumberConfig = default(ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig), ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig positionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig priceDifferenceLimitExceedAuthConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), ComGkSoftwarePosApiModelConfigProcessActionPromotionOperationConfig promotionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPromotionOperationConfig), bool? forceManualWeight = default(bool?), bool? quantityAccumulation = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsItemRegistrationConfig itemRegistrationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsItemRegistrationConfig), bool? itemIDCaseSensitive = default(bool?), string manualPriceAcousticSignalConfigId = default(string), string quantityAcousticSignalConfigId = default(string), string serialNumberAcousticSignalConfigId = default(string), string setQuantityForLineItemConfigId = default(string), bool? negativePositionProhibited = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsCustomerOrderData customerOrderData = default(ComGkSoftwarePosApiModelConfigProcessFlowsCustomerOrderData), ComGkSoftwarePosApiModelConfigProcessFlowsRegisterLineItemAddonData registerLineItemAddOnData = default(ComGkSoftwarePosApiModelConfigProcessFlowsRegisterLineItemAddonData), ComGkSoftwarePosApiModelConfigProcessFlowsAdditionalAttributes additionalAttributes = default(ComGkSoftwarePosApiModelConfigProcessFlowsAdditionalAttributes), ComGkSoftwarePosApiModelConfigProcessFlowsRegisterFuelLineItem registerFuelLineItem = default(ComGkSoftwarePosApiModelConfigProcessFlowsRegisterFuelLineItem), bool? removeOpenLineItemOnError = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig itemNotFoundAuthorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig remoteServiceNotAvailableAuthorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), ItemProviderEnum? itemProvider = default(ItemProviderEnum?), bool? skipSalesRestrictionDialogs = default(bool?), bool? skipQuantityErrorDialogs = default(bool?), string salesRestrictionConfigID = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "processId" is required (not null)
            if (processId == null)
            {
                throw new InvalidDataException("processId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ProcessId = processId;
            }
            // to ensure "ageVerificationRequired" is required (not null)
            if (ageVerificationRequired == null)
            {
                throw new InvalidDataException("ageVerificationRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.AgeVerificationRequired = ageVerificationRequired;
            }
            // to ensure "confirmDialogAgeVerifacation" is required (not null)
            if (confirmDialogAgeVerifacation == null)
            {
                throw new InvalidDataException("confirmDialogAgeVerifacation is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ConfirmDialogAgeVerifacation = confirmDialogAgeVerifacation;
            }
            // to ensure "switchToItemSearch" is required (not null)
            if (switchToItemSearch == null)
            {
                throw new InvalidDataException("switchToItemSearch is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.SwitchToItemSearch = switchToItemSearch;
            }
            // to ensure "askForReceiptText" is required (not null)
            if (askForReceiptText == null)
            {
                throw new InvalidDataException("askForReceiptText is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.AskForReceiptText = askForReceiptText;
            }
            // to ensure "returnManualPriceRequired" is required (not null)
            if (returnManualPriceRequired == null)
            {
                throw new InvalidDataException("returnManualPriceRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ReturnManualPriceRequired = returnManualPriceRequired;
            }
            // to ensure "promptForReceiptTextConfig" is required (not null)
            if (promptForReceiptTextConfig == null)
            {
                throw new InvalidDataException("promptForReceiptTextConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.PromptForReceiptTextConfig = promptForReceiptTextConfig;
            }
            // to ensure "promptForSerialNumberConfig" is required (not null)
            if (promptForSerialNumberConfig == null)
            {
                throw new InvalidDataException("promptForSerialNumberConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.PromptForSerialNumberConfig = promptForSerialNumberConfig;
            }
            // to ensure "positionOperationConfig" is required (not null)
            if (positionOperationConfig == null)
            {
                throw new InvalidDataException("positionOperationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.PositionOperationConfig = positionOperationConfig;
            }
            // to ensure "priceDifferenceLimitExceedAuthConfig" is required (not null)
            if (priceDifferenceLimitExceedAuthConfig == null)
            {
                throw new InvalidDataException("priceDifferenceLimitExceedAuthConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.PriceDifferenceLimitExceedAuthConfig = priceDifferenceLimitExceedAuthConfig;
            }
            // to ensure "promotionOperationConfig" is required (not null)
            if (promotionOperationConfig == null)
            {
                throw new InvalidDataException("promotionOperationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.PromotionOperationConfig = promotionOperationConfig;
            }
            // to ensure "forceManualWeight" is required (not null)
            if (forceManualWeight == null)
            {
                throw new InvalidDataException("forceManualWeight is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ForceManualWeight = forceManualWeight;
            }
            // to ensure "quantityAccumulation" is required (not null)
            if (quantityAccumulation == null)
            {
                throw new InvalidDataException("quantityAccumulation is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.QuantityAccumulation = quantityAccumulation;
            }
            // to ensure "itemRegistrationConfig" is required (not null)
            if (itemRegistrationConfig == null)
            {
                throw new InvalidDataException("itemRegistrationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ItemRegistrationConfig = itemRegistrationConfig;
            }
            // to ensure "itemIDCaseSensitive" is required (not null)
            if (itemIDCaseSensitive == null)
            {
                throw new InvalidDataException("itemIDCaseSensitive is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ItemIDCaseSensitive = itemIDCaseSensitive;
            }
            // to ensure "manualPriceAcousticSignalConfigId" is required (not null)
            if (manualPriceAcousticSignalConfigId == null)
            {
                throw new InvalidDataException("manualPriceAcousticSignalConfigId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ManualPriceAcousticSignalConfigId = manualPriceAcousticSignalConfigId;
            }
            // to ensure "quantityAcousticSignalConfigId" is required (not null)
            if (quantityAcousticSignalConfigId == null)
            {
                throw new InvalidDataException("quantityAcousticSignalConfigId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.QuantityAcousticSignalConfigId = quantityAcousticSignalConfigId;
            }
            // to ensure "serialNumberAcousticSignalConfigId" is required (not null)
            if (serialNumberAcousticSignalConfigId == null)
            {
                throw new InvalidDataException("serialNumberAcousticSignalConfigId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.SerialNumberAcousticSignalConfigId = serialNumberAcousticSignalConfigId;
            }
            // to ensure "setQuantityForLineItemConfigId" is required (not null)
            if (setQuantityForLineItemConfigId == null)
            {
                throw new InvalidDataException("setQuantityForLineItemConfigId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.SetQuantityForLineItemConfigId = setQuantityForLineItemConfigId;
            }
            // to ensure "negativePositionProhibited" is required (not null)
            if (negativePositionProhibited == null)
            {
                throw new InvalidDataException("negativePositionProhibited is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.NegativePositionProhibited = negativePositionProhibited;
            }
            // to ensure "itemNotFoundAuthorizationConfig" is required (not null)
            if (itemNotFoundAuthorizationConfig == null)
            {
                throw new InvalidDataException("itemNotFoundAuthorizationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.ItemNotFoundAuthorizationConfig = itemNotFoundAuthorizationConfig;
            }
            // to ensure "remoteServiceNotAvailableAuthorizationConfig" is required (not null)
            if (remoteServiceNotAvailableAuthorizationConfig == null)
            {
                throw new InvalidDataException("remoteServiceNotAvailableAuthorizationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig and cannot be null");
            }
            else
            {
                this.RemoteServiceNotAvailableAuthorizationConfig = remoteServiceNotAvailableAuthorizationConfig;
            }
            this.MainProcess = mainProcess;
            this.AuthorizationConfig = authorizationConfig;
            this.FixedItemNrEan = fixedItemNrEan;
            this.ItemNrEan = itemNrEan;
            this.ItemTraceableUnitID = itemTraceableUnitID;
            this.RegistrationNumber = registrationNumber;
            this.TextClassIds = textClassIds;
            this.UomCode = uomCode;
            this.CheckSalesRestrictions = checkSalesRestrictions;
            this.CheckSalesRestrictionsForReturn = checkSalesRestrictionsForReturn;
            this.CheckForVariants = checkForVariants;
            this.CheckTaxGroup = checkTaxGroup;
            this.AskForQuantity = askForQuantity;
            this.CheckSellerAgeRestrictions = checkSellerAgeRestrictions;
            this.PositionAmount = positionAmount;
            this.ItemPrice = itemPrice;
            this.Factor = factor;
            this.ItemQuantity = itemQuantity;
            this.Weight = weight;
            this.Units = units;
            this.SerialNumber = serialNumber;
            this.SaleableWithoutPrice = saleableWithoutPrice;
            this.Mode = mode;
            this.CallPackageSelection = callPackageSelection;
            this.ItemPackageSelectionId = itemPackageSelectionId;
            this.ReturnManualPositionAmountForWeightItemsRequired = returnManualPositionAmountForWeightItemsRequired;
            this.ReturnReasonRequired = returnReasonRequired;
            this.CustomerOrderData = customerOrderData;
            this.RegisterLineItemAddOnData = registerLineItemAddOnData;
            this.AdditionalAttributes = additionalAttributes;
            this.RegisterFuelLineItem = registerFuelLineItem;
            this.RemoveOpenLineItemOnError = removeOpenLineItemOnError;
            this.ItemProvider = itemProvider;
            this.SkipSalesRestrictionDialogs = skipSalesRestrictionDialogs;
            this.SkipQuantityErrorDialogs = skipQuantityErrorDialogs;
            this.SalesRestrictionConfigID = salesRestrictionConfigID;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;</value>
        [DataMember(Name="processId", EmitDefaultValue=false)]
        public string ProcessId { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;</value>
        [DataMember(Name="mainProcess", EmitDefaultValue=false)]
        public bool? MainProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines authorization related processes.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;</value>
        [DataMember(Name="authorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig AuthorizationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines a fixed item number/ EAN for fixed item keys.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines a fixed item number/ EAN for fixed item keys.&lt;/p&gt;</value>
        [DataMember(Name="fixedItemNrEan", EmitDefaultValue=false)]
        public string FixedItemNrEan { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the input for the item number/ EAN.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the input for the item number/ EAN.&lt;/p&gt;</value>
        [DataMember(Name="itemNrEan", EmitDefaultValue=false)]
        public string ItemNrEan { get; set; }

        /// <summary>
        /// &lt;p&gt;Input parameter for item traceable unit id (used for EPC codes scanned by RFID, for example)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Input parameter for item traceable unit id (used for EPC codes scanned by RFID, for example)&lt;/p&gt;</value>
        [DataMember(Name="itemTraceableUnitID", EmitDefaultValue=false)]
        public string ItemTraceableUnitID { get; set; }

        /// <summary>
        /// &lt;p&gt;Raw barcode used for registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Raw barcode used for registration.&lt;/p&gt;</value>
        [DataMember(Name="registrationNumber", EmitDefaultValue=false)]
        public string RegistrationNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines text class IDs.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines text class IDs.&lt;/p&gt;</value>
        [DataMember(Name="textClassIds", EmitDefaultValue=false)]
        public List<string> TextClassIds { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the unit of measure code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unit of measure code.&lt;/p&gt;</value>
        [DataMember(Name="uomCode", EmitDefaultValue=false)]
        public string UomCode { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether sales restrictions are verified. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether sales restrictions are verified. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="checkSalesRestrictions", EmitDefaultValue=false)]
        public bool? CheckSalesRestrictions { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether sales restrictions are verified for return items. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether sales restrictions are verified for return items. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="checkSalesRestrictionsForReturn", EmitDefaultValue=false)]
        public bool? CheckSalesRestrictionsForReturn { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a check is made for item variants. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a check is made for item variants. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="checkForVariants", EmitDefaultValue=false)]
        public bool? CheckForVariants { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the tax group should be validated.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; This means that the tax group exists in master data and fulfills the following conditions: TaxGroupRule.EffectiveDateTime &amp;lt;&#x3D; {current timestamp} and TaxGroupRule.ExpirationDateTime &amp;gt;&#x3D; {current timestamp}.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; The default is set at true.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the tax group should be validated.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; This means that the tax group exists in master data and fulfills the following conditions: TaxGroupRule.EffectiveDateTime &amp;lt;&#x3D; {current timestamp} and TaxGroupRule.ExpirationDateTime &amp;gt;&#x3D; {current timestamp}.&lt;br /&gt; &lt;br/&gt;&lt;br /&gt; The default is set at true.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="checkTaxGroup", EmitDefaultValue=false)]
        public bool? CheckTaxGroup { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a quantity is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a quantity is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="askForQuantity", EmitDefaultValue=false)]
        public bool? AskForQuantity { get; set; }

        /// <summary>
        /// Gets or Sets AgeVerificationRequired
        /// </summary>
        [DataMember(Name="ageVerificationRequired", EmitDefaultValue=false)]
        public bool? AgeVerificationRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether seller age should be checked.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether seller age should be checked.&lt;/p&gt;</value>
        [DataMember(Name="checkSellerAgeRestrictions", EmitDefaultValue=false)]
        public bool? CheckSellerAgeRestrictions { get; set; }

        /// <summary>
        /// Gets or Sets ConfirmDialogAgeVerifacation
        /// </summary>
        [DataMember(Name="confirmDialogAgeVerifacation", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessUiMessageDialogConfig ConfirmDialogAgeVerifacation { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the line item amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the line item amount.&lt;/p&gt;</value>
        [DataMember(Name="positionAmount", EmitDefaultValue=false)]
        public double? PositionAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the unit price.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unit price.&lt;/p&gt;</value>
        [DataMember(Name="itemPrice", EmitDefaultValue=false)]
        public double? ItemPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the packaging quantity of an item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the packaging quantity of an item.&lt;/p&gt;</value>
        [DataMember(Name="factor", EmitDefaultValue=false)]
        public double? Factor { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter defines the single quantity in case of piece items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the single quantity in case of piece items.&lt;/p&gt;</value>
        [DataMember(Name="itemQuantity", EmitDefaultValue=false)]
        public int? ItemQuantity { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter defines the manual weight in case of weight items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the manual weight in case of weight items.&lt;/p&gt;</value>
        [DataMember(Name="weight", EmitDefaultValue=false)]
        public double? Weight { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter defines the units in case of quantity with decimal places items (e.g. fuel items).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the units in case of quantity with decimal places items (e.g. fuel items).&lt;/p&gt;</value>
        [DataMember(Name="units", EmitDefaultValue=false)]
        public double? Units { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the serial number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the serial number.&lt;/p&gt;</value>
        [DataMember(Name="serialNumber", EmitDefaultValue=false)]
        public string SerialNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether an item is salable even if no price exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether an item is salable even if no price exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="saleableWithoutPrice", EmitDefaultValue=false)]
        public bool? SaleableWithoutPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the system switches to Item Search if no search term exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the system switches to Item Search if no search term exists. The default is set at true.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="switchToItemSearch", EmitDefaultValue=false)]
        public bool? SwitchToItemSearch { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the receipt text of the item is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the receipt text of the item is requested. The default is set at false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="askForReceiptText", EmitDefaultValue=false)]
        public bool? AskForReceiptText { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the mode. The default is set at 0.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: 0, 1, 2&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;0 - The standard item entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;1 - The set component entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;2 - The Bulk Registration is set.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the mode. The default is set at 0.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: 0, 1, 2&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;0 - The standard item entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;1 - The set component entry is set.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;2 - The Bulk Registration is set.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="mode", EmitDefaultValue=false)]
        public int? Mode { get; set; }

        /// <summary>
        /// Gets or Sets CallPackageSelection
        /// </summary>
        [DataMember(Name="callPackageSelection", EmitDefaultValue=false)]
        public bool? CallPackageSelection { get; set; }

        /// <summary>
        /// Gets or Sets ItemPackageSelectionId
        /// </summary>
        [DataMember(Name="itemPackageSelectionId", EmitDefaultValue=false)]
        public string ItemPackageSelectionId { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the total price entry is requested in case of return of weighing items. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the total price entry is requested in case of return of weighing items. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="returnManualPositionAmountForWeightItemsRequired", EmitDefaultValue=false)]
        public bool? ReturnManualPositionAmountForWeightItemsRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the reason is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the reason is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="returnReasonRequired", EmitDefaultValue=false)]
        public bool? ReturnReasonRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a manual price entry is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a manual price entry is requested in case of returns. The value is set by Goods Return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="returnManualPriceRequired", EmitDefaultValue=false)]
        public bool? ReturnManualPriceRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines the Enter ReceiptText Dialog.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines the Enter ReceiptText Dialog.&lt;/p&gt;</value>
        [DataMember(Name="promptForReceiptTextConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig PromptForReceiptTextConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines the Enter SerialNumber Dialog.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines the Enter SerialNumber Dialog.&lt;/p&gt;</value>
        [DataMember(Name="promptForSerialNumberConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig PromptForSerialNumberConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines the position operation for registering.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines the position operation for registering.&lt;/p&gt;</value>
        [DataMember(Name="positionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig PositionOperationConfig { get; set; }

        /// <summary>
        /// Gets or Sets PriceDifferenceLimitExceedAuthConfig
        /// </summary>
        [DataMember(Name="priceDifferenceLimitExceedAuthConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig PriceDifferenceLimitExceedAuthConfig { get; set; }

        /// <summary>
        /// Gets or Sets PromotionOperationConfig
        /// </summary>
        [DataMember(Name="promotionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPromotionOperationConfig PromotionOperationConfig { get; set; }

        /// <summary>
        /// Gets or Sets ForceManualWeight
        /// </summary>
        [DataMember(Name="forceManualWeight", EmitDefaultValue=false)]
        public bool? ForceManualWeight { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the quantity of line items with the same item should be accumulated.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the quantity of line items with the same item should be accumulated.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="quantityAccumulation", EmitDefaultValue=false)]
        public bool? QuantityAccumulation { get; set; }

        /// <summary>
        /// &lt;p&gt;It references the item details config to determine if additional info is needed&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It references the item details config to determine if additional info is needed&lt;/p&gt;</value>
        [DataMember(Name="itemRegistrationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsItemRegistrationConfig ItemRegistrationConfig { get; set; }

        /// <summary>
        /// Gets or Sets ItemIDCaseSensitive
        /// </summary>
        [DataMember(Name="itemIDCaseSensitive", EmitDefaultValue=false)]
        public bool? ItemIDCaseSensitive { get; set; }

        /// <summary>
        /// &lt;p&gt;It references the acoustic signal configuration identifier for manual price input&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It references the acoustic signal configuration identifier for manual price input&lt;/p&gt;</value>
        [DataMember(Name="manualPriceAcousticSignalConfigId", EmitDefaultValue=false)]
        public string ManualPriceAcousticSignalConfigId { get; set; }

        /// <summary>
        /// &lt;p&gt;It references the acoustic signal configuration identifier for quantity input&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It references the acoustic signal configuration identifier for quantity input&lt;/p&gt;</value>
        [DataMember(Name="quantityAcousticSignalConfigId", EmitDefaultValue=false)]
        public string QuantityAcousticSignalConfigId { get; set; }

        /// <summary>
        /// &lt;p&gt;It references the acoustic signal configuration identifier for serial number input&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It references the acoustic signal configuration identifier for serial number input&lt;/p&gt;</value>
        [DataMember(Name="serialNumberAcousticSignalConfigId", EmitDefaultValue=false)]
        public string SerialNumberAcousticSignalConfigId { get; set; }

        /// <summary>
        /// &lt;p&gt;It references the SetQuantityForLineItemConfig identifier for the SetQuantityForLineItem sub process call.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It references the SetQuantityForLineItemConfig identifier for the SetQuantityForLineItem sub process call.&lt;/p&gt;</value>
        [DataMember(Name="setQuantityForLineItemConfigId", EmitDefaultValue=false)]
        public string SetQuantityForLineItemConfigId { get; set; }

        /// <summary>
        /// Gets or Sets NegativePositionProhibited
        /// </summary>
        [DataMember(Name="negativePositionProhibited", EmitDefaultValue=false)]
        public bool? NegativePositionProhibited { get; set; }

        /// <summary>
        /// Gets or Sets CustomerOrderData
        /// </summary>
        [DataMember(Name="customerOrderData", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsCustomerOrderData CustomerOrderData { get; set; }

        /// <summary>
        /// Gets or Sets RegisterLineItemAddOnData
        /// </summary>
        [DataMember(Name="registerLineItemAddOnData", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsRegisterLineItemAddonData RegisterLineItemAddOnData { get; set; }

        /// <summary>
        /// &lt;p&gt;References the instance of configuration which indicates additional item related attributes to be assigned to sale return line item extensions during item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;References the instance of configuration which indicates additional item related attributes to be assigned to sale return line item extensions during item registration.&lt;/p&gt;</value>
        [DataMember(Name="additionalAttributes", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAdditionalAttributes AdditionalAttributes { get; set; }

        /// <summary>
        /// Gets or Sets RegisterFuelLineItem
        /// </summary>
        [DataMember(Name="registerFuelLineItem", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsRegisterFuelLineItem RegisterFuelLineItem { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if an open line item (without item) will be removed if item entry fails with error.&lt;br /&gt; It should be set to true for barcode rules with multiple actions where second action is the item entry process.&lt;br /&gt; Default: null/false&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if an open line item (without item) will be removed if item entry fails with error.&lt;br /&gt; It should be set to true for barcode rules with multiple actions where second action is the item entry process.&lt;br /&gt; Default: null/false&lt;/p&gt;</value>
        [DataMember(Name="removeOpenLineItemOnError", EmitDefaultValue=false)]
        public bool? RemoveOpenLineItemOnError { get; set; }

        /// <summary>
        /// &lt;p&gt;config item not found authorization. Mainly to be used by POS clients that will display an authorization error on item search failure (Ex: SCO)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;config item not found authorization. Mainly to be used by POS clients that will display an authorization error on item search failure (Ex: SCO)&lt;/p&gt;</value>
        [DataMember(Name="itemNotFoundAuthorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig ItemNotFoundAuthorizationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;config to handle remote service not available authorization errors, when doing remote item searches in SDC / SAP&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;config to handle remote service not available authorization errors, when doing remote item searches in SDC / SAP&lt;/p&gt;</value>
        [DataMember(Name="remoteServiceNotAvailableAuthorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig RemoteServiceNotAvailableAuthorizationConfig { get; set; }


        /// <summary>
        /// &lt;p&gt;If true any forbidden dialogs for sales restrictions will be skipped.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;If true any forbidden dialogs for sales restrictions will be skipped.&lt;/p&gt;</value>
        [DataMember(Name="skipSalesRestrictionDialogs", EmitDefaultValue=false)]
        public bool? SkipSalesRestrictionDialogs { get; set; }

        /// <summary>
        /// &lt;p&gt;If true any error dialogs triggered while setting quantity for line item will be skipped.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;If true any error dialogs triggered while setting quantity for line item will be skipped.&lt;/p&gt;</value>
        [DataMember(Name="skipQuantityErrorDialogs", EmitDefaultValue=false)]
        public bool? SkipQuantityErrorDialogs { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the specific SalesRestriction configID for ItemEntryConfig, which will be overridden into sales restriction process (empty by default).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the specific SalesRestriction configID for ItemEntryConfig, which will be overridden into sales restriction process (empty by default).&lt;/p&gt;</value>
        [DataMember(Name="salesRestrictionConfigID", EmitDefaultValue=false)]
        public string SalesRestrictionConfigID { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig {\n");
            sb.Append("  ProcessId: ").Append(ProcessId).Append("\n");
            sb.Append("  MainProcess: ").Append(MainProcess).Append("\n");
            sb.Append("  AuthorizationConfig: ").Append(AuthorizationConfig).Append("\n");
            sb.Append("  FixedItemNrEan: ").Append(FixedItemNrEan).Append("\n");
            sb.Append("  ItemNrEan: ").Append(ItemNrEan).Append("\n");
            sb.Append("  ItemTraceableUnitID: ").Append(ItemTraceableUnitID).Append("\n");
            sb.Append("  RegistrationNumber: ").Append(RegistrationNumber).Append("\n");
            sb.Append("  TextClassIds: ").Append(TextClassIds).Append("\n");
            sb.Append("  UomCode: ").Append(UomCode).Append("\n");
            sb.Append("  CheckSalesRestrictions: ").Append(CheckSalesRestrictions).Append("\n");
            sb.Append("  CheckSalesRestrictionsForReturn: ").Append(CheckSalesRestrictionsForReturn).Append("\n");
            sb.Append("  CheckForVariants: ").Append(CheckForVariants).Append("\n");
            sb.Append("  CheckTaxGroup: ").Append(CheckTaxGroup).Append("\n");
            sb.Append("  AskForQuantity: ").Append(AskForQuantity).Append("\n");
            sb.Append("  AgeVerificationRequired: ").Append(AgeVerificationRequired).Append("\n");
            sb.Append("  CheckSellerAgeRestrictions: ").Append(CheckSellerAgeRestrictions).Append("\n");
            sb.Append("  ConfirmDialogAgeVerifacation: ").Append(ConfirmDialogAgeVerifacation).Append("\n");
            sb.Append("  PositionAmount: ").Append(PositionAmount).Append("\n");
            sb.Append("  ItemPrice: ").Append(ItemPrice).Append("\n");
            sb.Append("  Factor: ").Append(Factor).Append("\n");
            sb.Append("  ItemQuantity: ").Append(ItemQuantity).Append("\n");
            sb.Append("  Weight: ").Append(Weight).Append("\n");
            sb.Append("  Units: ").Append(Units).Append("\n");
            sb.Append("  SerialNumber: ").Append(SerialNumber).Append("\n");
            sb.Append("  SaleableWithoutPrice: ").Append(SaleableWithoutPrice).Append("\n");
            sb.Append("  SwitchToItemSearch: ").Append(SwitchToItemSearch).Append("\n");
            sb.Append("  AskForReceiptText: ").Append(AskForReceiptText).Append("\n");
            sb.Append("  Mode: ").Append(Mode).Append("\n");
            sb.Append("  CallPackageSelection: ").Append(CallPackageSelection).Append("\n");
            sb.Append("  ItemPackageSelectionId: ").Append(ItemPackageSelectionId).Append("\n");
            sb.Append("  ReturnManualPositionAmountForWeightItemsRequired: ").Append(ReturnManualPositionAmountForWeightItemsRequired).Append("\n");
            sb.Append("  ReturnReasonRequired: ").Append(ReturnReasonRequired).Append("\n");
            sb.Append("  ReturnManualPriceRequired: ").Append(ReturnManualPriceRequired).Append("\n");
            sb.Append("  PromptForReceiptTextConfig: ").Append(PromptForReceiptTextConfig).Append("\n");
            sb.Append("  PromptForSerialNumberConfig: ").Append(PromptForSerialNumberConfig).Append("\n");
            sb.Append("  PositionOperationConfig: ").Append(PositionOperationConfig).Append("\n");
            sb.Append("  PriceDifferenceLimitExceedAuthConfig: ").Append(PriceDifferenceLimitExceedAuthConfig).Append("\n");
            sb.Append("  PromotionOperationConfig: ").Append(PromotionOperationConfig).Append("\n");
            sb.Append("  ForceManualWeight: ").Append(ForceManualWeight).Append("\n");
            sb.Append("  QuantityAccumulation: ").Append(QuantityAccumulation).Append("\n");
            sb.Append("  ItemRegistrationConfig: ").Append(ItemRegistrationConfig).Append("\n");
            sb.Append("  ItemIDCaseSensitive: ").Append(ItemIDCaseSensitive).Append("\n");
            sb.Append("  ManualPriceAcousticSignalConfigId: ").Append(ManualPriceAcousticSignalConfigId).Append("\n");
            sb.Append("  QuantityAcousticSignalConfigId: ").Append(QuantityAcousticSignalConfigId).Append("\n");
            sb.Append("  SerialNumberAcousticSignalConfigId: ").Append(SerialNumberAcousticSignalConfigId).Append("\n");
            sb.Append("  SetQuantityForLineItemConfigId: ").Append(SetQuantityForLineItemConfigId).Append("\n");
            sb.Append("  NegativePositionProhibited: ").Append(NegativePositionProhibited).Append("\n");
            sb.Append("  CustomerOrderData: ").Append(CustomerOrderData).Append("\n");
            sb.Append("  RegisterLineItemAddOnData: ").Append(RegisterLineItemAddOnData).Append("\n");
            sb.Append("  AdditionalAttributes: ").Append(AdditionalAttributes).Append("\n");
            sb.Append("  RegisterFuelLineItem: ").Append(RegisterFuelLineItem).Append("\n");
            sb.Append("  RemoveOpenLineItemOnError: ").Append(RemoveOpenLineItemOnError).Append("\n");
            sb.Append("  ItemNotFoundAuthorizationConfig: ").Append(ItemNotFoundAuthorizationConfig).Append("\n");
            sb.Append("  RemoteServiceNotAvailableAuthorizationConfig: ").Append(RemoteServiceNotAvailableAuthorizationConfig).Append("\n");
            sb.Append("  ItemProvider: ").Append(ItemProvider).Append("\n");
            sb.Append("  SkipSalesRestrictionDialogs: ").Append(SkipSalesRestrictionDialogs).Append("\n");
            sb.Append("  SkipQuantityErrorDialogs: ").Append(SkipQuantityErrorDialogs).Append("\n");
            sb.Append("  SalesRestrictionConfigID: ").Append(SalesRestrictionConfigID).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessFlowsItemEntryConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProcessId == input.ProcessId ||
                    (this.ProcessId != null &&
                    this.ProcessId.Equals(input.ProcessId))
                ) && 
                (
                    this.MainProcess == input.MainProcess ||
                    (this.MainProcess != null &&
                    this.MainProcess.Equals(input.MainProcess))
                ) && 
                (
                    this.AuthorizationConfig == input.AuthorizationConfig ||
                    (this.AuthorizationConfig != null &&
                    this.AuthorizationConfig.Equals(input.AuthorizationConfig))
                ) && 
                (
                    this.FixedItemNrEan == input.FixedItemNrEan ||
                    (this.FixedItemNrEan != null &&
                    this.FixedItemNrEan.Equals(input.FixedItemNrEan))
                ) && 
                (
                    this.ItemNrEan == input.ItemNrEan ||
                    (this.ItemNrEan != null &&
                    this.ItemNrEan.Equals(input.ItemNrEan))
                ) && 
                (
                    this.ItemTraceableUnitID == input.ItemTraceableUnitID ||
                    (this.ItemTraceableUnitID != null &&
                    this.ItemTraceableUnitID.Equals(input.ItemTraceableUnitID))
                ) && 
                (
                    this.RegistrationNumber == input.RegistrationNumber ||
                    (this.RegistrationNumber != null &&
                    this.RegistrationNumber.Equals(input.RegistrationNumber))
                ) && 
                (
                    this.TextClassIds == input.TextClassIds ||
                    this.TextClassIds != null &&
                    this.TextClassIds.SequenceEqual(input.TextClassIds)
                ) && 
                (
                    this.UomCode == input.UomCode ||
                    (this.UomCode != null &&
                    this.UomCode.Equals(input.UomCode))
                ) && 
                (
                    this.CheckSalesRestrictions == input.CheckSalesRestrictions ||
                    (this.CheckSalesRestrictions != null &&
                    this.CheckSalesRestrictions.Equals(input.CheckSalesRestrictions))
                ) && 
                (
                    this.CheckSalesRestrictionsForReturn == input.CheckSalesRestrictionsForReturn ||
                    (this.CheckSalesRestrictionsForReturn != null &&
                    this.CheckSalesRestrictionsForReturn.Equals(input.CheckSalesRestrictionsForReturn))
                ) && 
                (
                    this.CheckForVariants == input.CheckForVariants ||
                    (this.CheckForVariants != null &&
                    this.CheckForVariants.Equals(input.CheckForVariants))
                ) && 
                (
                    this.CheckTaxGroup == input.CheckTaxGroup ||
                    (this.CheckTaxGroup != null &&
                    this.CheckTaxGroup.Equals(input.CheckTaxGroup))
                ) && 
                (
                    this.AskForQuantity == input.AskForQuantity ||
                    (this.AskForQuantity != null &&
                    this.AskForQuantity.Equals(input.AskForQuantity))
                ) && 
                (
                    this.AgeVerificationRequired == input.AgeVerificationRequired ||
                    (this.AgeVerificationRequired != null &&
                    this.AgeVerificationRequired.Equals(input.AgeVerificationRequired))
                ) && 
                (
                    this.CheckSellerAgeRestrictions == input.CheckSellerAgeRestrictions ||
                    (this.CheckSellerAgeRestrictions != null &&
                    this.CheckSellerAgeRestrictions.Equals(input.CheckSellerAgeRestrictions))
                ) && 
                (
                    this.ConfirmDialogAgeVerifacation == input.ConfirmDialogAgeVerifacation ||
                    (this.ConfirmDialogAgeVerifacation != null &&
                    this.ConfirmDialogAgeVerifacation.Equals(input.ConfirmDialogAgeVerifacation))
                ) && 
                (
                    this.PositionAmount == input.PositionAmount ||
                    (this.PositionAmount != null &&
                    this.PositionAmount.Equals(input.PositionAmount))
                ) && 
                (
                    this.ItemPrice == input.ItemPrice ||
                    (this.ItemPrice != null &&
                    this.ItemPrice.Equals(input.ItemPrice))
                ) && 
                (
                    this.Factor == input.Factor ||
                    (this.Factor != null &&
                    this.Factor.Equals(input.Factor))
                ) && 
                (
                    this.ItemQuantity == input.ItemQuantity ||
                    (this.ItemQuantity != null &&
                    this.ItemQuantity.Equals(input.ItemQuantity))
                ) && 
                (
                    this.Weight == input.Weight ||
                    (this.Weight != null &&
                    this.Weight.Equals(input.Weight))
                ) && 
                (
                    this.Units == input.Units ||
                    (this.Units != null &&
                    this.Units.Equals(input.Units))
                ) && 
                (
                    this.SerialNumber == input.SerialNumber ||
                    (this.SerialNumber != null &&
                    this.SerialNumber.Equals(input.SerialNumber))
                ) && 
                (
                    this.SaleableWithoutPrice == input.SaleableWithoutPrice ||
                    (this.SaleableWithoutPrice != null &&
                    this.SaleableWithoutPrice.Equals(input.SaleableWithoutPrice))
                ) && 
                (
                    this.SwitchToItemSearch == input.SwitchToItemSearch ||
                    (this.SwitchToItemSearch != null &&
                    this.SwitchToItemSearch.Equals(input.SwitchToItemSearch))
                ) && 
                (
                    this.AskForReceiptText == input.AskForReceiptText ||
                    (this.AskForReceiptText != null &&
                    this.AskForReceiptText.Equals(input.AskForReceiptText))
                ) && 
                (
                    this.Mode == input.Mode ||
                    (this.Mode != null &&
                    this.Mode.Equals(input.Mode))
                ) && 
                (
                    this.CallPackageSelection == input.CallPackageSelection ||
                    (this.CallPackageSelection != null &&
                    this.CallPackageSelection.Equals(input.CallPackageSelection))
                ) && 
                (
                    this.ItemPackageSelectionId == input.ItemPackageSelectionId ||
                    (this.ItemPackageSelectionId != null &&
                    this.ItemPackageSelectionId.Equals(input.ItemPackageSelectionId))
                ) && 
                (
                    this.ReturnManualPositionAmountForWeightItemsRequired == input.ReturnManualPositionAmountForWeightItemsRequired ||
                    (this.ReturnManualPositionAmountForWeightItemsRequired != null &&
                    this.ReturnManualPositionAmountForWeightItemsRequired.Equals(input.ReturnManualPositionAmountForWeightItemsRequired))
                ) && 
                (
                    this.ReturnReasonRequired == input.ReturnReasonRequired ||
                    (this.ReturnReasonRequired != null &&
                    this.ReturnReasonRequired.Equals(input.ReturnReasonRequired))
                ) && 
                (
                    this.ReturnManualPriceRequired == input.ReturnManualPriceRequired ||
                    (this.ReturnManualPriceRequired != null &&
                    this.ReturnManualPriceRequired.Equals(input.ReturnManualPriceRequired))
                ) && 
                (
                    this.PromptForReceiptTextConfig == input.PromptForReceiptTextConfig ||
                    (this.PromptForReceiptTextConfig != null &&
                    this.PromptForReceiptTextConfig.Equals(input.PromptForReceiptTextConfig))
                ) && 
                (
                    this.PromptForSerialNumberConfig == input.PromptForSerialNumberConfig ||
                    (this.PromptForSerialNumberConfig != null &&
                    this.PromptForSerialNumberConfig.Equals(input.PromptForSerialNumberConfig))
                ) && 
                (
                    this.PositionOperationConfig == input.PositionOperationConfig ||
                    (this.PositionOperationConfig != null &&
                    this.PositionOperationConfig.Equals(input.PositionOperationConfig))
                ) && 
                (
                    this.PriceDifferenceLimitExceedAuthConfig == input.PriceDifferenceLimitExceedAuthConfig ||
                    (this.PriceDifferenceLimitExceedAuthConfig != null &&
                    this.PriceDifferenceLimitExceedAuthConfig.Equals(input.PriceDifferenceLimitExceedAuthConfig))
                ) && 
                (
                    this.PromotionOperationConfig == input.PromotionOperationConfig ||
                    (this.PromotionOperationConfig != null &&
                    this.PromotionOperationConfig.Equals(input.PromotionOperationConfig))
                ) && 
                (
                    this.ForceManualWeight == input.ForceManualWeight ||
                    (this.ForceManualWeight != null &&
                    this.ForceManualWeight.Equals(input.ForceManualWeight))
                ) && 
                (
                    this.QuantityAccumulation == input.QuantityAccumulation ||
                    (this.QuantityAccumulation != null &&
                    this.QuantityAccumulation.Equals(input.QuantityAccumulation))
                ) && 
                (
                    this.ItemRegistrationConfig == input.ItemRegistrationConfig ||
                    (this.ItemRegistrationConfig != null &&
                    this.ItemRegistrationConfig.Equals(input.ItemRegistrationConfig))
                ) && 
                (
                    this.ItemIDCaseSensitive == input.ItemIDCaseSensitive ||
                    (this.ItemIDCaseSensitive != null &&
                    this.ItemIDCaseSensitive.Equals(input.ItemIDCaseSensitive))
                ) && 
                (
                    this.ManualPriceAcousticSignalConfigId == input.ManualPriceAcousticSignalConfigId ||
                    (this.ManualPriceAcousticSignalConfigId != null &&
                    this.ManualPriceAcousticSignalConfigId.Equals(input.ManualPriceAcousticSignalConfigId))
                ) && 
                (
                    this.QuantityAcousticSignalConfigId == input.QuantityAcousticSignalConfigId ||
                    (this.QuantityAcousticSignalConfigId != null &&
                    this.QuantityAcousticSignalConfigId.Equals(input.QuantityAcousticSignalConfigId))
                ) && 
                (
                    this.SerialNumberAcousticSignalConfigId == input.SerialNumberAcousticSignalConfigId ||
                    (this.SerialNumberAcousticSignalConfigId != null &&
                    this.SerialNumberAcousticSignalConfigId.Equals(input.SerialNumberAcousticSignalConfigId))
                ) && 
                (
                    this.SetQuantityForLineItemConfigId == input.SetQuantityForLineItemConfigId ||
                    (this.SetQuantityForLineItemConfigId != null &&
                    this.SetQuantityForLineItemConfigId.Equals(input.SetQuantityForLineItemConfigId))
                ) && 
                (
                    this.NegativePositionProhibited == input.NegativePositionProhibited ||
                    (this.NegativePositionProhibited != null &&
                    this.NegativePositionProhibited.Equals(input.NegativePositionProhibited))
                ) && 
                (
                    this.CustomerOrderData == input.CustomerOrderData ||
                    (this.CustomerOrderData != null &&
                    this.CustomerOrderData.Equals(input.CustomerOrderData))
                ) && 
                (
                    this.RegisterLineItemAddOnData == input.RegisterLineItemAddOnData ||
                    (this.RegisterLineItemAddOnData != null &&
                    this.RegisterLineItemAddOnData.Equals(input.RegisterLineItemAddOnData))
                ) && 
                (
                    this.AdditionalAttributes == input.AdditionalAttributes ||
                    (this.AdditionalAttributes != null &&
                    this.AdditionalAttributes.Equals(input.AdditionalAttributes))
                ) && 
                (
                    this.RegisterFuelLineItem == input.RegisterFuelLineItem ||
                    (this.RegisterFuelLineItem != null &&
                    this.RegisterFuelLineItem.Equals(input.RegisterFuelLineItem))
                ) && 
                (
                    this.RemoveOpenLineItemOnError == input.RemoveOpenLineItemOnError ||
                    (this.RemoveOpenLineItemOnError != null &&
                    this.RemoveOpenLineItemOnError.Equals(input.RemoveOpenLineItemOnError))
                ) && 
                (
                    this.ItemNotFoundAuthorizationConfig == input.ItemNotFoundAuthorizationConfig ||
                    (this.ItemNotFoundAuthorizationConfig != null &&
                    this.ItemNotFoundAuthorizationConfig.Equals(input.ItemNotFoundAuthorizationConfig))
                ) && 
                (
                    this.RemoteServiceNotAvailableAuthorizationConfig == input.RemoteServiceNotAvailableAuthorizationConfig ||
                    (this.RemoteServiceNotAvailableAuthorizationConfig != null &&
                    this.RemoteServiceNotAvailableAuthorizationConfig.Equals(input.RemoteServiceNotAvailableAuthorizationConfig))
                ) && 
                (
                    this.ItemProvider == input.ItemProvider ||
                    (this.ItemProvider != null &&
                    this.ItemProvider.Equals(input.ItemProvider))
                ) && 
                (
                    this.SkipSalesRestrictionDialogs == input.SkipSalesRestrictionDialogs ||
                    (this.SkipSalesRestrictionDialogs != null &&
                    this.SkipSalesRestrictionDialogs.Equals(input.SkipSalesRestrictionDialogs))
                ) && 
                (
                    this.SkipQuantityErrorDialogs == input.SkipQuantityErrorDialogs ||
                    (this.SkipQuantityErrorDialogs != null &&
                    this.SkipQuantityErrorDialogs.Equals(input.SkipQuantityErrorDialogs))
                ) && 
                (
                    this.SalesRestrictionConfigID == input.SalesRestrictionConfigID ||
                    (this.SalesRestrictionConfigID != null &&
                    this.SalesRestrictionConfigID.Equals(input.SalesRestrictionConfigID))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProcessId != null)
                    hashCode = hashCode * 59 + this.ProcessId.GetHashCode();
                if (this.MainProcess != null)
                    hashCode = hashCode * 59 + this.MainProcess.GetHashCode();
                if (this.AuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.AuthorizationConfig.GetHashCode();
                if (this.FixedItemNrEan != null)
                    hashCode = hashCode * 59 + this.FixedItemNrEan.GetHashCode();
                if (this.ItemNrEan != null)
                    hashCode = hashCode * 59 + this.ItemNrEan.GetHashCode();
                if (this.ItemTraceableUnitID != null)
                    hashCode = hashCode * 59 + this.ItemTraceableUnitID.GetHashCode();
                if (this.RegistrationNumber != null)
                    hashCode = hashCode * 59 + this.RegistrationNumber.GetHashCode();
                if (this.TextClassIds != null)
                    hashCode = hashCode * 59 + this.TextClassIds.GetHashCode();
                if (this.UomCode != null)
                    hashCode = hashCode * 59 + this.UomCode.GetHashCode();
                if (this.CheckSalesRestrictions != null)
                    hashCode = hashCode * 59 + this.CheckSalesRestrictions.GetHashCode();
                if (this.CheckSalesRestrictionsForReturn != null)
                    hashCode = hashCode * 59 + this.CheckSalesRestrictionsForReturn.GetHashCode();
                if (this.CheckForVariants != null)
                    hashCode = hashCode * 59 + this.CheckForVariants.GetHashCode();
                if (this.CheckTaxGroup != null)
                    hashCode = hashCode * 59 + this.CheckTaxGroup.GetHashCode();
                if (this.AskForQuantity != null)
                    hashCode = hashCode * 59 + this.AskForQuantity.GetHashCode();
                if (this.AgeVerificationRequired != null)
                    hashCode = hashCode * 59 + this.AgeVerificationRequired.GetHashCode();
                if (this.CheckSellerAgeRestrictions != null)
                    hashCode = hashCode * 59 + this.CheckSellerAgeRestrictions.GetHashCode();
                if (this.ConfirmDialogAgeVerifacation != null)
                    hashCode = hashCode * 59 + this.ConfirmDialogAgeVerifacation.GetHashCode();
                if (this.PositionAmount != null)
                    hashCode = hashCode * 59 + this.PositionAmount.GetHashCode();
                if (this.ItemPrice != null)
                    hashCode = hashCode * 59 + this.ItemPrice.GetHashCode();
                if (this.Factor != null)
                    hashCode = hashCode * 59 + this.Factor.GetHashCode();
                if (this.ItemQuantity != null)
                    hashCode = hashCode * 59 + this.ItemQuantity.GetHashCode();
                if (this.Weight != null)
                    hashCode = hashCode * 59 + this.Weight.GetHashCode();
                if (this.Units != null)
                    hashCode = hashCode * 59 + this.Units.GetHashCode();
                if (this.SerialNumber != null)
                    hashCode = hashCode * 59 + this.SerialNumber.GetHashCode();
                if (this.SaleableWithoutPrice != null)
                    hashCode = hashCode * 59 + this.SaleableWithoutPrice.GetHashCode();
                if (this.SwitchToItemSearch != null)
                    hashCode = hashCode * 59 + this.SwitchToItemSearch.GetHashCode();
                if (this.AskForReceiptText != null)
                    hashCode = hashCode * 59 + this.AskForReceiptText.GetHashCode();
                if (this.Mode != null)
                    hashCode = hashCode * 59 + this.Mode.GetHashCode();
                if (this.CallPackageSelection != null)
                    hashCode = hashCode * 59 + this.CallPackageSelection.GetHashCode();
                if (this.ItemPackageSelectionId != null)
                    hashCode = hashCode * 59 + this.ItemPackageSelectionId.GetHashCode();
                if (this.ReturnManualPositionAmountForWeightItemsRequired != null)
                    hashCode = hashCode * 59 + this.ReturnManualPositionAmountForWeightItemsRequired.GetHashCode();
                if (this.ReturnReasonRequired != null)
                    hashCode = hashCode * 59 + this.ReturnReasonRequired.GetHashCode();
                if (this.ReturnManualPriceRequired != null)
                    hashCode = hashCode * 59 + this.ReturnManualPriceRequired.GetHashCode();
                if (this.PromptForReceiptTextConfig != null)
                    hashCode = hashCode * 59 + this.PromptForReceiptTextConfig.GetHashCode();
                if (this.PromptForSerialNumberConfig != null)
                    hashCode = hashCode * 59 + this.PromptForSerialNumberConfig.GetHashCode();
                if (this.PositionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PositionOperationConfig.GetHashCode();
                if (this.PriceDifferenceLimitExceedAuthConfig != null)
                    hashCode = hashCode * 59 + this.PriceDifferenceLimitExceedAuthConfig.GetHashCode();
                if (this.PromotionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PromotionOperationConfig.GetHashCode();
                if (this.ForceManualWeight != null)
                    hashCode = hashCode * 59 + this.ForceManualWeight.GetHashCode();
                if (this.QuantityAccumulation != null)
                    hashCode = hashCode * 59 + this.QuantityAccumulation.GetHashCode();
                if (this.ItemRegistrationConfig != null)
                    hashCode = hashCode * 59 + this.ItemRegistrationConfig.GetHashCode();
                if (this.ItemIDCaseSensitive != null)
                    hashCode = hashCode * 59 + this.ItemIDCaseSensitive.GetHashCode();
                if (this.ManualPriceAcousticSignalConfigId != null)
                    hashCode = hashCode * 59 + this.ManualPriceAcousticSignalConfigId.GetHashCode();
                if (this.QuantityAcousticSignalConfigId != null)
                    hashCode = hashCode * 59 + this.QuantityAcousticSignalConfigId.GetHashCode();
                if (this.SerialNumberAcousticSignalConfigId != null)
                    hashCode = hashCode * 59 + this.SerialNumberAcousticSignalConfigId.GetHashCode();
                if (this.SetQuantityForLineItemConfigId != null)
                    hashCode = hashCode * 59 + this.SetQuantityForLineItemConfigId.GetHashCode();
                if (this.NegativePositionProhibited != null)
                    hashCode = hashCode * 59 + this.NegativePositionProhibited.GetHashCode();
                if (this.CustomerOrderData != null)
                    hashCode = hashCode * 59 + this.CustomerOrderData.GetHashCode();
                if (this.RegisterLineItemAddOnData != null)
                    hashCode = hashCode * 59 + this.RegisterLineItemAddOnData.GetHashCode();
                if (this.AdditionalAttributes != null)
                    hashCode = hashCode * 59 + this.AdditionalAttributes.GetHashCode();
                if (this.RegisterFuelLineItem != null)
                    hashCode = hashCode * 59 + this.RegisterFuelLineItem.GetHashCode();
                if (this.RemoveOpenLineItemOnError != null)
                    hashCode = hashCode * 59 + this.RemoveOpenLineItemOnError.GetHashCode();
                if (this.ItemNotFoundAuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.ItemNotFoundAuthorizationConfig.GetHashCode();
                if (this.RemoteServiceNotAvailableAuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.RemoteServiceNotAvailableAuthorizationConfig.GetHashCode();
                if (this.ItemProvider != null)
                    hashCode = hashCode * 59 + this.ItemProvider.GetHashCode();
                if (this.SkipSalesRestrictionDialogs != null)
                    hashCode = hashCode * 59 + this.SkipSalesRestrictionDialogs.GetHashCode();
                if (this.SkipQuantityErrorDialogs != null)
                    hashCode = hashCode * 59 + this.SkipQuantityErrorDialogs.GetHashCode();
                if (this.SalesRestrictionConfigID != null)
                    hashCode = hashCode * 59 + this.SalesRestrictionConfigID.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
