/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Amount &lt;p&gt;A data object which encapsulates a monetary amount value for a certain currency.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppAmountAmount :  IEquatable<ComGkSoftwarePosApiModelDomAppAmountAmount>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppAmountAmount" /> class.
        /// </summary>
        /// <param name="amount">&lt;p&gt;The monetary amount value.&lt;/p&gt;.</param>
        /// <param name="currency">&lt;p&gt;Holds the currency for the amount (see [master_data_gkr.currency.v1_0_0.Currency]).&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelDomAppAmountAmount(double? amount = default(double?), ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDO currency = default(ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDO))
        {
            this.Amount = amount;
            this.Currency = currency;
        }
        
        /// <summary>
        /// &lt;p&gt;The monetary amount value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The monetary amount value.&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;Holds the currency for the amount (see [master_data_gkr.currency.v1_0_0.Currency]).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Holds the currency for the amount (see [master_data_gkr.currency.v1_0_0.Currency]).&lt;/p&gt;</value>
        [DataMember(Name="currency", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdCurrencyDtoDomCurrencyDO Currency { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppAmountAmount {\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  Currency: ").Append(Currency).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppAmountAmount);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppAmountAmount instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppAmountAmount to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppAmountAmount input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.Currency == input.Currency ||
                    (this.Currency != null &&
                    this.Currency.Equals(input.Currency))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.Currency != null)
                    hashCode = hashCode * 59 + this.Currency.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
