/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GiftCertInfo &lt;p&gt;Contains gift certificate attributes returned by the stored value server.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo :  IEquatable<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo" /> class.
        /// </summary>
        /// <param name="gcId">&lt;p&gt;Gift certificate id.&lt;/p&gt;.</param>
        /// <param name="gcNumber">&lt;p&gt;Gift certificate number.&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;Amount of the gift certificate.&lt;/p&gt;.</param>
        /// <param name="state">&lt;p&gt;Gift certificate status: SELLABLE, REDEEMABLE, LOCKED, INVALID.&lt;/p&gt;.</param>
        /// <param name="validFrom">&lt;p&gt;Start of gift certificate validity period.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="validTo">&lt;p&gt;End of gift certificate validity period&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="uuid">&lt;p&gt;An unique transaction ID for the requested operation.&lt;/p&gt;.</param>
        /// <param name="overpaymentType">&lt;p&gt;Defines the handling of over payments (NOT_ACCEPTED, NO_CHANGE, GIFT_CERTIFICATE_CHANGE, CASH_CHANGE).&lt;/p&gt;.</param>
        /// <param name="blacklistedItems">&lt;p&gt;Items that are not included when comparing the receipt total with the minimum transaction amount (MinSale).&lt;/p&gt;.</param>
        /// <param name="blacklistedArticleGroupNumbers">&lt;p&gt;Merchandise categories that are not included when comparing the receipt total with the minimum transaction  amount (MinSale).&lt;/p&gt;.</param>
        /// <param name="includeDiscountedArticlesToMinimumSale">&lt;p&gt;Defines if discounted items will be included into minimum sale check.&lt;/p&gt;.</param>
        /// <param name="minimumTransactionAmount">&lt;p&gt;Minimum amount for this gift certificate.&lt;/p&gt;.</param>
        /// <param name="additionalInfo">&lt;p&gt;Additional attributes for gift certificates sent by stored value server.&lt;/p&gt;.</param>
        /// <param name="track2">track2.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo(int? gcId = default(int?), string gcNumber = default(string), ComGkSoftwarePosApiModelDomAppAmountAmount amount = default(ComGkSoftwarePosApiModelDomAppAmountAmount), string state = default(string), string validFrom = default(string), string validTo = default(string), string uuid = default(string), string overpaymentType = default(string), List<string> blacklistedItems = default(List<string>), List<string> blacklistedArticleGroupNumbers = default(List<string>), bool? includeDiscountedArticlesToMinimumSale = default(bool?), ComGkSoftwarePosApiModelDomAppAmountAmount minimumTransactionAmount = default(ComGkSoftwarePosApiModelDomAppAmountAmount), List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> additionalInfo = default(List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue>), string track2 = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.GcId = gcId;
            this.GcNumber = gcNumber;
            this.Amount = amount;
            this.State = state;
            this.ValidFrom = validFrom;
            this.ValidTo = validTo;
            this.Uuid = uuid;
            this.OverpaymentType = overpaymentType;
            this.BlacklistedItems = blacklistedItems;
            this.BlacklistedArticleGroupNumbers = blacklistedArticleGroupNumbers;
            this.IncludeDiscountedArticlesToMinimumSale = includeDiscountedArticlesToMinimumSale;
            this.MinimumTransactionAmount = minimumTransactionAmount;
            this.AdditionalInfo = additionalInfo;
            this.Track2 = track2;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Gift certificate id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate id.&lt;/p&gt;</value>
        [DataMember(Name="gcId", EmitDefaultValue=false)]
        public int? GcId { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate number.&lt;/p&gt;</value>
        [DataMember(Name="gcNumber", EmitDefaultValue=false)]
        public string GcNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Amount of the gift certificate.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the gift certificate.&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppAmountAmount Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate status: SELLABLE, REDEEMABLE, LOCKED, INVALID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate status: SELLABLE, REDEEMABLE, LOCKED, INVALID.&lt;/p&gt;</value>
        [DataMember(Name="state", EmitDefaultValue=false)]
        public string State { get; set; }

        /// <summary>
        /// &lt;p&gt;Start of gift certificate validity period.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Start of gift certificate validity period.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="validFrom", EmitDefaultValue=false)]
        public string ValidFrom { get; set; }

        /// <summary>
        /// &lt;p&gt;End of gift certificate validity period&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;End of gift certificate validity period&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="validTo", EmitDefaultValue=false)]
        public string ValidTo { get; set; }

        /// <summary>
        /// &lt;p&gt;An unique transaction ID for the requested operation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;An unique transaction ID for the requested operation.&lt;/p&gt;</value>
        [DataMember(Name="uuid", EmitDefaultValue=false)]
        public string Uuid { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines the handling of over payments (NOT_ACCEPTED, NO_CHANGE, GIFT_CERTIFICATE_CHANGE, CASH_CHANGE).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines the handling of over payments (NOT_ACCEPTED, NO_CHANGE, GIFT_CERTIFICATE_CHANGE, CASH_CHANGE).&lt;/p&gt;</value>
        [DataMember(Name="overpaymentType", EmitDefaultValue=false)]
        public string OverpaymentType { get; set; }

        /// <summary>
        /// &lt;p&gt;Items that are not included when comparing the receipt total with the minimum transaction amount (MinSale).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Items that are not included when comparing the receipt total with the minimum transaction amount (MinSale).&lt;/p&gt;</value>
        [DataMember(Name="blacklistedItems", EmitDefaultValue=false)]
        public List<string> BlacklistedItems { get; set; }

        /// <summary>
        /// &lt;p&gt;Merchandise categories that are not included when comparing the receipt total with the minimum transaction  amount (MinSale).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Merchandise categories that are not included when comparing the receipt total with the minimum transaction  amount (MinSale).&lt;/p&gt;</value>
        [DataMember(Name="blacklistedArticleGroupNumbers", EmitDefaultValue=false)]
        public List<string> BlacklistedArticleGroupNumbers { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines if discounted items will be included into minimum sale check.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines if discounted items will be included into minimum sale check.&lt;/p&gt;</value>
        [DataMember(Name="includeDiscountedArticlesToMinimumSale", EmitDefaultValue=false)]
        public bool? IncludeDiscountedArticlesToMinimumSale { get; set; }

        /// <summary>
        /// &lt;p&gt;Minimum amount for this gift certificate.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Minimum amount for this gift certificate.&lt;/p&gt;</value>
        [DataMember(Name="minimumTransactionAmount", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppAmountAmount MinimumTransactionAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional attributes for gift certificates sent by stored value server.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional attributes for gift certificates sent by stored value server.&lt;/p&gt;</value>
        [DataMember(Name="additionalInfo", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> AdditionalInfo { get; set; }

        /// <summary>
        /// Gets or Sets Track2
        /// </summary>
        [DataMember(Name="track2", EmitDefaultValue=false)]
        public string Track2 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo {\n");
            sb.Append("  GcId: ").Append(GcId).Append("\n");
            sb.Append("  GcNumber: ").Append(GcNumber).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  State: ").Append(State).Append("\n");
            sb.Append("  ValidFrom: ").Append(ValidFrom).Append("\n");
            sb.Append("  ValidTo: ").Append(ValidTo).Append("\n");
            sb.Append("  Uuid: ").Append(Uuid).Append("\n");
            sb.Append("  OverpaymentType: ").Append(OverpaymentType).Append("\n");
            sb.Append("  BlacklistedItems: ").Append(BlacklistedItems).Append("\n");
            sb.Append("  BlacklistedArticleGroupNumbers: ").Append(BlacklistedArticleGroupNumbers).Append("\n");
            sb.Append("  IncludeDiscountedArticlesToMinimumSale: ").Append(IncludeDiscountedArticlesToMinimumSale).Append("\n");
            sb.Append("  MinimumTransactionAmount: ").Append(MinimumTransactionAmount).Append("\n");
            sb.Append("  AdditionalInfo: ").Append(AdditionalInfo).Append("\n");
            sb.Append("  Track2: ").Append(Track2).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertInfo input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.GcId == input.GcId ||
                    (this.GcId != null &&
                    this.GcId.Equals(input.GcId))
                ) && 
                (
                    this.GcNumber == input.GcNumber ||
                    (this.GcNumber != null &&
                    this.GcNumber.Equals(input.GcNumber))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.State == input.State ||
                    (this.State != null &&
                    this.State.Equals(input.State))
                ) && 
                (
                    this.ValidFrom == input.ValidFrom ||
                    (this.ValidFrom != null &&
                    this.ValidFrom.Equals(input.ValidFrom))
                ) && 
                (
                    this.ValidTo == input.ValidTo ||
                    (this.ValidTo != null &&
                    this.ValidTo.Equals(input.ValidTo))
                ) && 
                (
                    this.Uuid == input.Uuid ||
                    (this.Uuid != null &&
                    this.Uuid.Equals(input.Uuid))
                ) && 
                (
                    this.OverpaymentType == input.OverpaymentType ||
                    (this.OverpaymentType != null &&
                    this.OverpaymentType.Equals(input.OverpaymentType))
                ) && 
                (
                    this.BlacklistedItems == input.BlacklistedItems ||
                    this.BlacklistedItems != null &&
                    this.BlacklistedItems.SequenceEqual(input.BlacklistedItems)
                ) && 
                (
                    this.BlacklistedArticleGroupNumbers == input.BlacklistedArticleGroupNumbers ||
                    this.BlacklistedArticleGroupNumbers != null &&
                    this.BlacklistedArticleGroupNumbers.SequenceEqual(input.BlacklistedArticleGroupNumbers)
                ) && 
                (
                    this.IncludeDiscountedArticlesToMinimumSale == input.IncludeDiscountedArticlesToMinimumSale ||
                    (this.IncludeDiscountedArticlesToMinimumSale != null &&
                    this.IncludeDiscountedArticlesToMinimumSale.Equals(input.IncludeDiscountedArticlesToMinimumSale))
                ) && 
                (
                    this.MinimumTransactionAmount == input.MinimumTransactionAmount ||
                    (this.MinimumTransactionAmount != null &&
                    this.MinimumTransactionAmount.Equals(input.MinimumTransactionAmount))
                ) && 
                (
                    this.AdditionalInfo == input.AdditionalInfo ||
                    this.AdditionalInfo != null &&
                    this.AdditionalInfo.SequenceEqual(input.AdditionalInfo)
                ) && 
                (
                    this.Track2 == input.Track2 ||
                    (this.Track2 != null &&
                    this.Track2.Equals(input.Track2))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.GcId != null)
                    hashCode = hashCode * 59 + this.GcId.GetHashCode();
                if (this.GcNumber != null)
                    hashCode = hashCode * 59 + this.GcNumber.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.State != null)
                    hashCode = hashCode * 59 + this.State.GetHashCode();
                if (this.ValidFrom != null)
                    hashCode = hashCode * 59 + this.ValidFrom.GetHashCode();
                if (this.ValidTo != null)
                    hashCode = hashCode * 59 + this.ValidTo.GetHashCode();
                if (this.Uuid != null)
                    hashCode = hashCode * 59 + this.Uuid.GetHashCode();
                if (this.OverpaymentType != null)
                    hashCode = hashCode * 59 + this.OverpaymentType.GetHashCode();
                if (this.BlacklistedItems != null)
                    hashCode = hashCode * 59 + this.BlacklistedItems.GetHashCode();
                if (this.BlacklistedArticleGroupNumbers != null)
                    hashCode = hashCode * 59 + this.BlacklistedArticleGroupNumbers.GetHashCode();
                if (this.IncludeDiscountedArticlesToMinimumSale != null)
                    hashCode = hashCode * 59 + this.IncludeDiscountedArticlesToMinimumSale.GetHashCode();
                if (this.MinimumTransactionAmount != null)
                    hashCode = hashCode * 59 + this.MinimumTransactionAmount.GetHashCode();
                if (this.AdditionalInfo != null)
                    hashCode = hashCode * 59 + this.AdditionalInfo.GetHashCode();
                if (this.Track2 != null)
                    hashCode = hashCode * 59 + this.Track2.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
