/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TenderAuthorizationKey &lt;p&gt;Key identifier for tender authorization.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey :  IEquatable<ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt; (required).</param>
        /// <param name="transactionID">&lt;p&gt;A universally unique identifier (UUID) for the Transaction.&lt;/p&gt; (required).</param>
        /// <param name="tenderAuthorizationSequenceNumber">&lt;p&gt;A unique sequence number for this TenderAuthorization. &lt;br /&gt; Note: A particular TenderLineItem may have more than one TenderAuthorization attempt.&lt;/p&gt; (required).</param>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? tenderAuthorizationSequenceNumber = default(int?))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "tenderAuthorizationSequenceNumber" is required (not null)
            if (tenderAuthorizationSequenceNumber == null)
            {
                throw new InvalidDataException("tenderAuthorizationSequenceNumber is a required property for ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey and cannot be null");
            }
            else
            {
                this.TenderAuthorizationSequenceNumber = tenderAuthorizationSequenceNumber;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A universally unique identifier (UUID) for the Transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A universally unique identifier (UUID) for the Transaction.&lt;/p&gt;</value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique sequence number for this TenderAuthorization. &lt;br /&gt; Note: A particular TenderLineItem may have more than one TenderAuthorization attempt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique sequence number for this TenderAuthorization. &lt;br /&gt; Note: A particular TenderLineItem may have more than one TenderAuthorization attempt.&lt;/p&gt;</value>
        [DataMember(Name="tenderAuthorizationSequenceNumber", EmitDefaultValue=false)]
        public int? TenderAuthorizationSequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  TenderAuthorizationSequenceNumber: ").Append(TenderAuthorizationSequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.TenderAuthorizationSequenceNumber == input.TenderAuthorizationSequenceNumber ||
                    (this.TenderAuthorizationSequenceNumber != null &&
                    this.TenderAuthorizationSequenceNumber.Equals(input.TenderAuthorizationSequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.TenderAuthorizationSequenceNumber != null)
                    hashCode = hashCode * 59 + this.TenderAuthorizationSequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
