/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// EwicBasketResult &lt;p&gt;Result object for the EwicBasketResult.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceEwicEwicBasketResult :  IEquatable<ComGkSoftwarePosApiServiceEwicEwicBasketResult>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum WIC for value: WIC
            /// </summary>
            [EnumMember(Value = "WIC")]
            WIC = 1,
            
            /// <summary>
            /// Enum NOWIC for value: NO_WIC
            /// </summary>
            [EnumMember(Value = "NO_WIC")]
            NOWIC = 2,
            
            /// <summary>
            /// Enum VOID for value: VOID
            /// </summary>
            [EnumMember(Value = "VOID")]
            VOID = 3
        }

        /// <summary>
        /// &lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public StatusEnum? Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceEwicEwicBasketResult" /> class.
        /// </summary>
        /// <param name="itemDescription">&lt;p&gt;String : Item description from master data&lt;/p&gt;.</param>
        /// <param name="quantity">&lt;p&gt;double : Quantity of item purchased&lt;/p&gt;.</param>
        /// <param name="uomDesc">&lt;p&gt;String : UOM description&lt;/p&gt;.</param>
        /// <param name="itemPrice">&lt;p&gt;double : Item extended amount&lt;/p&gt;.</param>
        /// <param name="categoryDesc">&lt;p&gt;String : eWIC category description&lt;/p&gt;.</param>
        /// <param name="subcategoryDesc">&lt;p&gt;String : eWIC sub-category description&lt;/p&gt;.</param>
        /// <param name="baseUOMCode">&lt;p&gt;String : UOM code&lt;/p&gt;.</param>
        /// <param name="category">&lt;p&gt;String : eWIC category code&lt;/p&gt;.</param>
        /// <param name="subcategory">&lt;p&gt;String : eWIC sub-category code&lt;/p&gt;.</param>
        /// <param name="upcPluNumber">&lt;p&gt;String : Item number&lt;/p&gt;.</param>
        /// <param name="lineNumber">&lt;p&gt;short: Item index&lt;/p&gt;.</param>
        /// <param name="benefitQuantity">&lt;p&gt;double: Quantity that is eligible to receive benefits, as obtained from the eWIC prescription&lt;/p&gt;.</param>
        /// <param name="ntePrice">&lt;p&gt;double: Not to exceed price&lt;/p&gt;.</param>
        /// <param name="status">&lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;.</param>
        /// <param name="wicPurchaseIndicator">&lt;p&gt;boolean: Specifies whether the item can be straddled&lt;/p&gt;.</param>
        /// <param name="splitEwicTender">&lt;p&gt;boolean: Specifies whether the item will be tendered partially with eWIC&lt;/p&gt;.</param>
        /// <param name="regularUnitPrice">&lt;p&gt;double: Item regular unit price&lt;/p&gt;.</param>
        /// <param name="extendedDiscountAmount">&lt;p&gt;double: Item extended discount amount&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;double: Item quantity multiply by item benefits quantity&lt;/p&gt;.</param>
        /// <param name="itemDisplayPrice">&lt;p&gt;double: Item price for confirmation screen&lt;/p&gt;.</param>
        /// <param name="itemVariance">&lt;p&gt;double: Item variance price for NTE&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceEwicEwicBasketResult(string itemDescription = default(string), double? quantity = default(double?), string uomDesc = default(string), double? itemPrice = default(double?), string categoryDesc = default(string), string subcategoryDesc = default(string), string baseUOMCode = default(string), string category = default(string), string subcategory = default(string), string upcPluNumber = default(string), int? lineNumber = default(int?), double? benefitQuantity = default(double?), double? ntePrice = default(double?), StatusEnum? status = default(StatusEnum?), bool? wicPurchaseIndicator = default(bool?), bool? splitEwicTender = default(bool?), double? regularUnitPrice = default(double?), double? extendedDiscountAmount = default(double?), double? amount = default(double?), double? itemDisplayPrice = default(double?), double? itemVariance = default(double?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.ItemDescription = itemDescription;
            this.Quantity = quantity;
            this.UomDesc = uomDesc;
            this.ItemPrice = itemPrice;
            this.CategoryDesc = categoryDesc;
            this.SubcategoryDesc = subcategoryDesc;
            this.BaseUOMCode = baseUOMCode;
            this.Category = category;
            this.Subcategory = subcategory;
            this.UpcPluNumber = upcPluNumber;
            this.LineNumber = lineNumber;
            this.BenefitQuantity = benefitQuantity;
            this.NtePrice = ntePrice;
            this.Status = status;
            this.WicPurchaseIndicator = wicPurchaseIndicator;
            this.SplitEwicTender = splitEwicTender;
            this.RegularUnitPrice = regularUnitPrice;
            this.ExtendedDiscountAmount = extendedDiscountAmount;
            this.Amount = amount;
            this.ItemDisplayPrice = itemDisplayPrice;
            this.ItemVariance = itemVariance;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;String : Item description from master data&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : Item description from master data&lt;/p&gt;</value>
        [DataMember(Name="itemDescription", EmitDefaultValue=false)]
        public string ItemDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;double : Quantity of item purchased&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : Quantity of item purchased&lt;/p&gt;</value>
        [DataMember(Name="quantity", EmitDefaultValue=false)]
        public double? Quantity { get; set; }

        /// <summary>
        /// &lt;p&gt;String : UOM description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : UOM description&lt;/p&gt;</value>
        [DataMember(Name="uomDesc", EmitDefaultValue=false)]
        public string UomDesc { get; set; }

        /// <summary>
        /// &lt;p&gt;double : Item extended amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : Item extended amount&lt;/p&gt;</value>
        [DataMember(Name="itemPrice", EmitDefaultValue=false)]
        public double? ItemPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;String : eWIC category description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC category description&lt;/p&gt;</value>
        [DataMember(Name="categoryDesc", EmitDefaultValue=false)]
        public string CategoryDesc { get; set; }

        /// <summary>
        /// &lt;p&gt;String : eWIC sub-category description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC sub-category description&lt;/p&gt;</value>
        [DataMember(Name="subcategoryDesc", EmitDefaultValue=false)]
        public string SubcategoryDesc { get; set; }

        /// <summary>
        /// &lt;p&gt;String : UOM code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : UOM code&lt;/p&gt;</value>
        [DataMember(Name="baseUOMCode", EmitDefaultValue=false)]
        public string BaseUOMCode { get; set; }

        /// <summary>
        /// &lt;p&gt;String : eWIC category code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC category code&lt;/p&gt;</value>
        [DataMember(Name="category", EmitDefaultValue=false)]
        public string Category { get; set; }

        /// <summary>
        /// &lt;p&gt;String : eWIC sub-category code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC sub-category code&lt;/p&gt;</value>
        [DataMember(Name="subcategory", EmitDefaultValue=false)]
        public string Subcategory { get; set; }

        /// <summary>
        /// &lt;p&gt;String : Item number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : Item number&lt;/p&gt;</value>
        [DataMember(Name="upcPluNumber", EmitDefaultValue=false)]
        public string UpcPluNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;short: Item index&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;short: Item index&lt;/p&gt;</value>
        [DataMember(Name="lineNumber", EmitDefaultValue=false)]
        public int? LineNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Quantity that is eligible to receive benefits, as obtained from the eWIC prescription&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Quantity that is eligible to receive benefits, as obtained from the eWIC prescription&lt;/p&gt;</value>
        [DataMember(Name="benefitQuantity", EmitDefaultValue=false)]
        public double? BenefitQuantity { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Not to exceed price&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Not to exceed price&lt;/p&gt;</value>
        [DataMember(Name="ntePrice", EmitDefaultValue=false)]
        public double? NtePrice { get; set; }


        /// <summary>
        /// &lt;p&gt;boolean: Specifies whether the item can be straddled&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies whether the item can be straddled&lt;/p&gt;</value>
        [DataMember(Name="wicPurchaseIndicator", EmitDefaultValue=false)]
        public bool? WicPurchaseIndicator { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean: Specifies whether the item will be tendered partially with eWIC&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies whether the item will be tendered partially with eWIC&lt;/p&gt;</value>
        [DataMember(Name="splitEwicTender", EmitDefaultValue=false)]
        public bool? SplitEwicTender { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Item regular unit price&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item regular unit price&lt;/p&gt;</value>
        [DataMember(Name="regularUnitPrice", EmitDefaultValue=false)]
        public double? RegularUnitPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Item extended discount amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item extended discount amount&lt;/p&gt;</value>
        [DataMember(Name="extendedDiscountAmount", EmitDefaultValue=false)]
        public double? ExtendedDiscountAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Item quantity multiply by item benefits quantity&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item quantity multiply by item benefits quantity&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Item price for confirmation screen&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item price for confirmation screen&lt;/p&gt;</value>
        [DataMember(Name="itemDisplayPrice", EmitDefaultValue=false)]
        public double? ItemDisplayPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;double: Item variance price for NTE&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item variance price for NTE&lt;/p&gt;</value>
        [DataMember(Name="itemVariance", EmitDefaultValue=false)]
        public double? ItemVariance { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceEwicEwicBasketResult {\n");
            sb.Append("  ItemDescription: ").Append(ItemDescription).Append("\n");
            sb.Append("  Quantity: ").Append(Quantity).Append("\n");
            sb.Append("  UomDesc: ").Append(UomDesc).Append("\n");
            sb.Append("  ItemPrice: ").Append(ItemPrice).Append("\n");
            sb.Append("  CategoryDesc: ").Append(CategoryDesc).Append("\n");
            sb.Append("  SubcategoryDesc: ").Append(SubcategoryDesc).Append("\n");
            sb.Append("  BaseUOMCode: ").Append(BaseUOMCode).Append("\n");
            sb.Append("  Category: ").Append(Category).Append("\n");
            sb.Append("  Subcategory: ").Append(Subcategory).Append("\n");
            sb.Append("  UpcPluNumber: ").Append(UpcPluNumber).Append("\n");
            sb.Append("  LineNumber: ").Append(LineNumber).Append("\n");
            sb.Append("  BenefitQuantity: ").Append(BenefitQuantity).Append("\n");
            sb.Append("  NtePrice: ").Append(NtePrice).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  WicPurchaseIndicator: ").Append(WicPurchaseIndicator).Append("\n");
            sb.Append("  SplitEwicTender: ").Append(SplitEwicTender).Append("\n");
            sb.Append("  RegularUnitPrice: ").Append(RegularUnitPrice).Append("\n");
            sb.Append("  ExtendedDiscountAmount: ").Append(ExtendedDiscountAmount).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  ItemDisplayPrice: ").Append(ItemDisplayPrice).Append("\n");
            sb.Append("  ItemVariance: ").Append(ItemVariance).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceEwicEwicBasketResult);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceEwicEwicBasketResult instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceEwicEwicBasketResult to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceEwicEwicBasketResult input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ItemDescription == input.ItemDescription ||
                    (this.ItemDescription != null &&
                    this.ItemDescription.Equals(input.ItemDescription))
                ) && 
                (
                    this.Quantity == input.Quantity ||
                    (this.Quantity != null &&
                    this.Quantity.Equals(input.Quantity))
                ) && 
                (
                    this.UomDesc == input.UomDesc ||
                    (this.UomDesc != null &&
                    this.UomDesc.Equals(input.UomDesc))
                ) && 
                (
                    this.ItemPrice == input.ItemPrice ||
                    (this.ItemPrice != null &&
                    this.ItemPrice.Equals(input.ItemPrice))
                ) && 
                (
                    this.CategoryDesc == input.CategoryDesc ||
                    (this.CategoryDesc != null &&
                    this.CategoryDesc.Equals(input.CategoryDesc))
                ) && 
                (
                    this.SubcategoryDesc == input.SubcategoryDesc ||
                    (this.SubcategoryDesc != null &&
                    this.SubcategoryDesc.Equals(input.SubcategoryDesc))
                ) && 
                (
                    this.BaseUOMCode == input.BaseUOMCode ||
                    (this.BaseUOMCode != null &&
                    this.BaseUOMCode.Equals(input.BaseUOMCode))
                ) && 
                (
                    this.Category == input.Category ||
                    (this.Category != null &&
                    this.Category.Equals(input.Category))
                ) && 
                (
                    this.Subcategory == input.Subcategory ||
                    (this.Subcategory != null &&
                    this.Subcategory.Equals(input.Subcategory))
                ) && 
                (
                    this.UpcPluNumber == input.UpcPluNumber ||
                    (this.UpcPluNumber != null &&
                    this.UpcPluNumber.Equals(input.UpcPluNumber))
                ) && 
                (
                    this.LineNumber == input.LineNumber ||
                    (this.LineNumber != null &&
                    this.LineNumber.Equals(input.LineNumber))
                ) && 
                (
                    this.BenefitQuantity == input.BenefitQuantity ||
                    (this.BenefitQuantity != null &&
                    this.BenefitQuantity.Equals(input.BenefitQuantity))
                ) && 
                (
                    this.NtePrice == input.NtePrice ||
                    (this.NtePrice != null &&
                    this.NtePrice.Equals(input.NtePrice))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.WicPurchaseIndicator == input.WicPurchaseIndicator ||
                    (this.WicPurchaseIndicator != null &&
                    this.WicPurchaseIndicator.Equals(input.WicPurchaseIndicator))
                ) && 
                (
                    this.SplitEwicTender == input.SplitEwicTender ||
                    (this.SplitEwicTender != null &&
                    this.SplitEwicTender.Equals(input.SplitEwicTender))
                ) && 
                (
                    this.RegularUnitPrice == input.RegularUnitPrice ||
                    (this.RegularUnitPrice != null &&
                    this.RegularUnitPrice.Equals(input.RegularUnitPrice))
                ) && 
                (
                    this.ExtendedDiscountAmount == input.ExtendedDiscountAmount ||
                    (this.ExtendedDiscountAmount != null &&
                    this.ExtendedDiscountAmount.Equals(input.ExtendedDiscountAmount))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.ItemDisplayPrice == input.ItemDisplayPrice ||
                    (this.ItemDisplayPrice != null &&
                    this.ItemDisplayPrice.Equals(input.ItemDisplayPrice))
                ) && 
                (
                    this.ItemVariance == input.ItemVariance ||
                    (this.ItemVariance != null &&
                    this.ItemVariance.Equals(input.ItemVariance))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ItemDescription != null)
                    hashCode = hashCode * 59 + this.ItemDescription.GetHashCode();
                if (this.Quantity != null)
                    hashCode = hashCode * 59 + this.Quantity.GetHashCode();
                if (this.UomDesc != null)
                    hashCode = hashCode * 59 + this.UomDesc.GetHashCode();
                if (this.ItemPrice != null)
                    hashCode = hashCode * 59 + this.ItemPrice.GetHashCode();
                if (this.CategoryDesc != null)
                    hashCode = hashCode * 59 + this.CategoryDesc.GetHashCode();
                if (this.SubcategoryDesc != null)
                    hashCode = hashCode * 59 + this.SubcategoryDesc.GetHashCode();
                if (this.BaseUOMCode != null)
                    hashCode = hashCode * 59 + this.BaseUOMCode.GetHashCode();
                if (this.Category != null)
                    hashCode = hashCode * 59 + this.Category.GetHashCode();
                if (this.Subcategory != null)
                    hashCode = hashCode * 59 + this.Subcategory.GetHashCode();
                if (this.UpcPluNumber != null)
                    hashCode = hashCode * 59 + this.UpcPluNumber.GetHashCode();
                if (this.LineNumber != null)
                    hashCode = hashCode * 59 + this.LineNumber.GetHashCode();
                if (this.BenefitQuantity != null)
                    hashCode = hashCode * 59 + this.BenefitQuantity.GetHashCode();
                if (this.NtePrice != null)
                    hashCode = hashCode * 59 + this.NtePrice.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.WicPurchaseIndicator != null)
                    hashCode = hashCode * 59 + this.WicPurchaseIndicator.GetHashCode();
                if (this.SplitEwicTender != null)
                    hashCode = hashCode * 59 + this.SplitEwicTender.GetHashCode();
                if (this.RegularUnitPrice != null)
                    hashCode = hashCode * 59 + this.RegularUnitPrice.GetHashCode();
                if (this.ExtendedDiscountAmount != null)
                    hashCode = hashCode * 59 + this.ExtendedDiscountAmount.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.ItemDisplayPrice != null)
                    hashCode = hashCode * 59 + this.ItemDisplayPrice.GetHashCode();
                if (this.ItemVariance != null)
                    hashCode = hashCode * 59 + this.ItemVariance.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
