/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ExternalCartData &lt;p&gt;Representation of an external cart provided by an external order service&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceExternalCartExternalCartData :  IEquatable<ComGkSoftwarePosApiServiceExternalCartExternalCartData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceExternalCartExternalCartData" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceExternalCartExternalCartData() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceExternalCartExternalCartData" /> class.
        /// </summary>
        /// <param name="cartId">&lt;p&gt;The cart ID.&lt;/p&gt; (required).</param>
        /// <param name="customerId">&lt;p&gt;The customer ID.&lt;/p&gt;.</param>
        /// <param name="totalItems">&lt;p&gt;The total item count of this cart.&lt;/p&gt;.</param>
        /// <param name="pickupItems">&lt;p&gt;The count of items to pick up in a store.&lt;/p&gt;.</param>
        /// <param name="deliveryItems">&lt;p&gt;The count of items to be delivered.&lt;/p&gt;.</param>
        /// <param name="totalPrice">&lt;p&gt;The total price of the whole cart, including discounts and delivery costs.&lt;/p&gt;.</param>
        /// <param name="deliveryCost">&lt;p&gt;The costs for delivery, usually calculated after the external service has all parameters, like delivery mode and delivery address.&lt;/p&gt;.</param>
        /// <param name="totalDiscounts">&lt;p&gt;The total amount of discounts applied to the cart by the external service.&lt;/p&gt;.</param>
        /// <param name="orderCalculated">&lt;p&gt;A flag signaling if the cart has been calculated and is ready for order.&lt;/p&gt;.</param>
        /// <param name="totalPriceWithTax">&lt;p&gt;The total price including taxes applied by the external service&lt;/p&gt;.</param>
        /// <param name="entries">&lt;p&gt;The line items of the cart.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceExternalCartExternalCartData(string cartId = default(string), string customerId = default(string), int? totalItems = default(int?), int? pickupItems = default(int?), int? deliveryItems = default(int?), ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice totalPrice = default(ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice), ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice deliveryCost = default(ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice), ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice totalDiscounts = default(ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice), bool? orderCalculated = default(bool?), ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice totalPriceWithTax = default(ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice), List<ComGkSoftwarePosApiServiceExternalCartExternalCartDataEntry> entries = default(List<ComGkSoftwarePosApiServiceExternalCartExternalCartDataEntry>), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "cartId" is required (not null)
            if (cartId == null)
            {
                throw new InvalidDataException("cartId is a required property for ComGkSoftwarePosApiServiceExternalCartExternalCartData and cannot be null");
            }
            else
            {
                this.CartId = cartId;
            }
            this.CustomerId = customerId;
            this.TotalItems = totalItems;
            this.PickupItems = pickupItems;
            this.DeliveryItems = deliveryItems;
            this.TotalPrice = totalPrice;
            this.DeliveryCost = deliveryCost;
            this.TotalDiscounts = totalDiscounts;
            this.OrderCalculated = orderCalculated;
            this.TotalPriceWithTax = totalPriceWithTax;
            this.Entries = entries;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The cart ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The cart ID.&lt;/p&gt;</value>
        [DataMember(Name="cartId", EmitDefaultValue=false)]
        public string CartId { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer ID.&lt;/p&gt;</value>
        [DataMember(Name="customerId", EmitDefaultValue=false)]
        public string CustomerId { get; set; }

        /// <summary>
        /// &lt;p&gt;The total item count of this cart.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total item count of this cart.&lt;/p&gt;</value>
        [DataMember(Name="totalItems", EmitDefaultValue=false)]
        public int? TotalItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The count of items to pick up in a store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The count of items to pick up in a store.&lt;/p&gt;</value>
        [DataMember(Name="pickupItems", EmitDefaultValue=false)]
        public int? PickupItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The count of items to be delivered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The count of items to be delivered.&lt;/p&gt;</value>
        [DataMember(Name="deliveryItems", EmitDefaultValue=false)]
        public int? DeliveryItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The total price of the whole cart, including discounts and delivery costs.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total price of the whole cart, including discounts and delivery costs.&lt;/p&gt;</value>
        [DataMember(Name="totalPrice", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice TotalPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;The costs for delivery, usually calculated after the external service has all parameters, like delivery mode and delivery address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The costs for delivery, usually calculated after the external service has all parameters, like delivery mode and delivery address.&lt;/p&gt;</value>
        [DataMember(Name="deliveryCost", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice DeliveryCost { get; set; }

        /// <summary>
        /// &lt;p&gt;The total amount of discounts applied to the cart by the external service.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total amount of discounts applied to the cart by the external service.&lt;/p&gt;</value>
        [DataMember(Name="totalDiscounts", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice TotalDiscounts { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag signaling if the cart has been calculated and is ready for order.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag signaling if the cart has been calculated and is ready for order.&lt;/p&gt;</value>
        [DataMember(Name="orderCalculated", EmitDefaultValue=false)]
        public bool? OrderCalculated { get; set; }

        /// <summary>
        /// &lt;p&gt;The total price including taxes applied by the external service&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total price including taxes applied by the external service&lt;/p&gt;</value>
        [DataMember(Name="totalPriceWithTax", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceExternalCartExternalCartDataPrice TotalPriceWithTax { get; set; }

        /// <summary>
        /// &lt;p&gt;The line items of the cart.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items of the cart.&lt;/p&gt;</value>
        [DataMember(Name="entries", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiServiceExternalCartExternalCartDataEntry> Entries { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceExternalCartExternalCartData {\n");
            sb.Append("  CartId: ").Append(CartId).Append("\n");
            sb.Append("  CustomerId: ").Append(CustomerId).Append("\n");
            sb.Append("  TotalItems: ").Append(TotalItems).Append("\n");
            sb.Append("  PickupItems: ").Append(PickupItems).Append("\n");
            sb.Append("  DeliveryItems: ").Append(DeliveryItems).Append("\n");
            sb.Append("  TotalPrice: ").Append(TotalPrice).Append("\n");
            sb.Append("  DeliveryCost: ").Append(DeliveryCost).Append("\n");
            sb.Append("  TotalDiscounts: ").Append(TotalDiscounts).Append("\n");
            sb.Append("  OrderCalculated: ").Append(OrderCalculated).Append("\n");
            sb.Append("  TotalPriceWithTax: ").Append(TotalPriceWithTax).Append("\n");
            sb.Append("  Entries: ").Append(Entries).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceExternalCartExternalCartData);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceExternalCartExternalCartData instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceExternalCartExternalCartData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceExternalCartExternalCartData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CartId == input.CartId ||
                    (this.CartId != null &&
                    this.CartId.Equals(input.CartId))
                ) && 
                (
                    this.CustomerId == input.CustomerId ||
                    (this.CustomerId != null &&
                    this.CustomerId.Equals(input.CustomerId))
                ) && 
                (
                    this.TotalItems == input.TotalItems ||
                    (this.TotalItems != null &&
                    this.TotalItems.Equals(input.TotalItems))
                ) && 
                (
                    this.PickupItems == input.PickupItems ||
                    (this.PickupItems != null &&
                    this.PickupItems.Equals(input.PickupItems))
                ) && 
                (
                    this.DeliveryItems == input.DeliveryItems ||
                    (this.DeliveryItems != null &&
                    this.DeliveryItems.Equals(input.DeliveryItems))
                ) && 
                (
                    this.TotalPrice == input.TotalPrice ||
                    (this.TotalPrice != null &&
                    this.TotalPrice.Equals(input.TotalPrice))
                ) && 
                (
                    this.DeliveryCost == input.DeliveryCost ||
                    (this.DeliveryCost != null &&
                    this.DeliveryCost.Equals(input.DeliveryCost))
                ) && 
                (
                    this.TotalDiscounts == input.TotalDiscounts ||
                    (this.TotalDiscounts != null &&
                    this.TotalDiscounts.Equals(input.TotalDiscounts))
                ) && 
                (
                    this.OrderCalculated == input.OrderCalculated ||
                    (this.OrderCalculated != null &&
                    this.OrderCalculated.Equals(input.OrderCalculated))
                ) && 
                (
                    this.TotalPriceWithTax == input.TotalPriceWithTax ||
                    (this.TotalPriceWithTax != null &&
                    this.TotalPriceWithTax.Equals(input.TotalPriceWithTax))
                ) && 
                (
                    this.Entries == input.Entries ||
                    this.Entries != null &&
                    this.Entries.SequenceEqual(input.Entries)
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CartId != null)
                    hashCode = hashCode * 59 + this.CartId.GetHashCode();
                if (this.CustomerId != null)
                    hashCode = hashCode * 59 + this.CustomerId.GetHashCode();
                if (this.TotalItems != null)
                    hashCode = hashCode * 59 + this.TotalItems.GetHashCode();
                if (this.PickupItems != null)
                    hashCode = hashCode * 59 + this.PickupItems.GetHashCode();
                if (this.DeliveryItems != null)
                    hashCode = hashCode * 59 + this.DeliveryItems.GetHashCode();
                if (this.TotalPrice != null)
                    hashCode = hashCode * 59 + this.TotalPrice.GetHashCode();
                if (this.DeliveryCost != null)
                    hashCode = hashCode * 59 + this.DeliveryCost.GetHashCode();
                if (this.TotalDiscounts != null)
                    hashCode = hashCode * 59 + this.TotalDiscounts.GetHashCode();
                if (this.OrderCalculated != null)
                    hashCode = hashCode * 59 + this.OrderCalculated.GetHashCode();
                if (this.TotalPriceWithTax != null)
                    hashCode = hashCode * 59 + this.TotalPriceWithTax.GetHashCode();
                if (this.Entries != null)
                    hashCode = hashCode * 59 + this.Entries.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
