/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AuthorizationRequest &lt;p&gt;Request object for the AuthorizationService&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceSecurityAuthorizationRequest :  IEquatable<ComGkSoftwarePosApiServiceSecurityAuthorizationRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceSecurityAuthorizationRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceSecurityAuthorizationRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceSecurityAuthorizationRequest" /> class.
        /// </summary>
        /// <param name="originalOperatorLoginName">&lt;p&gt;String : original operator login name&lt;/p&gt;.</param>
        /// <param name="authorizingOperatorLoginName">&lt;p&gt;String : authorizing operator login name&lt;/p&gt;.</param>
        /// <param name="authorizingOperatorPassword">&lt;p&gt;String : authorizing operator password&lt;/p&gt;.</param>
        /// <param name="rightId">&lt;p&gt;String : right id&lt;/p&gt;.</param>
        /// <param name="entryMethodCode">&lt;p&gt;String : entry method code. It specifies how the action was triggered (keyed, scanned, ...)&lt;/p&gt;.</param>
        /// <param name="lineItemRelevant">&lt;p&gt;Indicates that operation is related to line item.&lt;/p&gt;.</param>
        /// <param name="retailTransactionRelevant">&lt;p&gt;Indicates that operation is related to retail transaction.&lt;/p&gt;.</param>
        /// <param name="controlTransactionRelevant">&lt;p&gt;Indicates that operation is related to control transaction.&lt;/p&gt;.</param>
        /// <param name="tenderControlTransactionRelevant">&lt;p&gt;Indicates that operation is related to tender control transaction.&lt;/p&gt;.</param>
        /// <param name="authorizingOperatorMustHaveRights">&lt;p&gt;boolean : authorizing operator must have rights&lt;/p&gt; (required).</param>
        /// <param name="skipPasswordCheck">&lt;p&gt;boolean : skip password check&lt;/p&gt; (required).</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceSecurityAuthorizationRequest(string originalOperatorLoginName = default(string), string authorizingOperatorLoginName = default(string), string authorizingOperatorPassword = default(string), string rightId = default(string), string entryMethodCode = default(string), bool? lineItemRelevant = default(bool?), bool? retailTransactionRelevant = default(bool?), bool? controlTransactionRelevant = default(bool?), bool? tenderControlTransactionRelevant = default(bool?), bool? authorizingOperatorMustHaveRights = default(bool?), bool? skipPasswordCheck = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "authorizingOperatorMustHaveRights" is required (not null)
            if (authorizingOperatorMustHaveRights == null)
            {
                throw new InvalidDataException("authorizingOperatorMustHaveRights is a required property for ComGkSoftwarePosApiServiceSecurityAuthorizationRequest and cannot be null");
            }
            else
            {
                this.AuthorizingOperatorMustHaveRights = authorizingOperatorMustHaveRights;
            }
            // to ensure "skipPasswordCheck" is required (not null)
            if (skipPasswordCheck == null)
            {
                throw new InvalidDataException("skipPasswordCheck is a required property for ComGkSoftwarePosApiServiceSecurityAuthorizationRequest and cannot be null");
            }
            else
            {
                this.SkipPasswordCheck = skipPasswordCheck;
            }
            this.OriginalOperatorLoginName = originalOperatorLoginName;
            this.AuthorizingOperatorLoginName = authorizingOperatorLoginName;
            this.AuthorizingOperatorPassword = authorizingOperatorPassword;
            this.RightId = rightId;
            this.EntryMethodCode = entryMethodCode;
            this.LineItemRelevant = lineItemRelevant;
            this.RetailTransactionRelevant = retailTransactionRelevant;
            this.ControlTransactionRelevant = controlTransactionRelevant;
            this.TenderControlTransactionRelevant = tenderControlTransactionRelevant;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;String : original operator login name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : original operator login name&lt;/p&gt;</value>
        [DataMember(Name="originalOperatorLoginName", EmitDefaultValue=false)]
        public string OriginalOperatorLoginName { get; set; }

        /// <summary>
        /// &lt;p&gt;String : authorizing operator login name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : authorizing operator login name&lt;/p&gt;</value>
        [DataMember(Name="authorizingOperatorLoginName", EmitDefaultValue=false)]
        public string AuthorizingOperatorLoginName { get; set; }

        /// <summary>
        /// &lt;p&gt;String : authorizing operator password&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : authorizing operator password&lt;/p&gt;</value>
        [DataMember(Name="authorizingOperatorPassword", EmitDefaultValue=false)]
        public string AuthorizingOperatorPassword { get; set; }

        /// <summary>
        /// &lt;p&gt;String : right id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : right id&lt;/p&gt;</value>
        [DataMember(Name="rightId", EmitDefaultValue=false)]
        public string RightId { get; set; }

        /// <summary>
        /// &lt;p&gt;String : entry method code. It specifies how the action was triggered (keyed, scanned, ...)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : entry method code. It specifies how the action was triggered (keyed, scanned, ...)&lt;/p&gt;</value>
        [DataMember(Name="EntryMethodCode", EmitDefaultValue=false)]
        public string EntryMethodCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to line item.&lt;/p&gt;</value>
        [DataMember(Name="lineItemRelevant", EmitDefaultValue=false)]
        public bool? LineItemRelevant { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to retail transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to retail transaction.&lt;/p&gt;</value>
        [DataMember(Name="retailTransactionRelevant", EmitDefaultValue=false)]
        public bool? RetailTransactionRelevant { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to control transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to control transaction.&lt;/p&gt;</value>
        [DataMember(Name="controlTransactionRelevant", EmitDefaultValue=false)]
        public bool? ControlTransactionRelevant { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to tender control transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to tender control transaction.&lt;/p&gt;</value>
        [DataMember(Name="tenderControlTransactionRelevant", EmitDefaultValue=false)]
        public bool? TenderControlTransactionRelevant { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean : authorizing operator must have rights&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : authorizing operator must have rights&lt;/p&gt;</value>
        [DataMember(Name="authorizingOperatorMustHaveRights", EmitDefaultValue=false)]
        public bool? AuthorizingOperatorMustHaveRights { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean : skip password check&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : skip password check&lt;/p&gt;</value>
        [DataMember(Name="skipPasswordCheck", EmitDefaultValue=false)]
        public bool? SkipPasswordCheck { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceSecurityAuthorizationRequest {\n");
            sb.Append("  OriginalOperatorLoginName: ").Append(OriginalOperatorLoginName).Append("\n");
            sb.Append("  AuthorizingOperatorLoginName: ").Append(AuthorizingOperatorLoginName).Append("\n");
            sb.Append("  AuthorizingOperatorPassword: ").Append(AuthorizingOperatorPassword).Append("\n");
            sb.Append("  RightId: ").Append(RightId).Append("\n");
            sb.Append("  EntryMethodCode: ").Append(EntryMethodCode).Append("\n");
            sb.Append("  LineItemRelevant: ").Append(LineItemRelevant).Append("\n");
            sb.Append("  RetailTransactionRelevant: ").Append(RetailTransactionRelevant).Append("\n");
            sb.Append("  ControlTransactionRelevant: ").Append(ControlTransactionRelevant).Append("\n");
            sb.Append("  TenderControlTransactionRelevant: ").Append(TenderControlTransactionRelevant).Append("\n");
            sb.Append("  AuthorizingOperatorMustHaveRights: ").Append(AuthorizingOperatorMustHaveRights).Append("\n");
            sb.Append("  SkipPasswordCheck: ").Append(SkipPasswordCheck).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceSecurityAuthorizationRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceSecurityAuthorizationRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceSecurityAuthorizationRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceSecurityAuthorizationRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OriginalOperatorLoginName == input.OriginalOperatorLoginName ||
                    (this.OriginalOperatorLoginName != null &&
                    this.OriginalOperatorLoginName.Equals(input.OriginalOperatorLoginName))
                ) && 
                (
                    this.AuthorizingOperatorLoginName == input.AuthorizingOperatorLoginName ||
                    (this.AuthorizingOperatorLoginName != null &&
                    this.AuthorizingOperatorLoginName.Equals(input.AuthorizingOperatorLoginName))
                ) && 
                (
                    this.AuthorizingOperatorPassword == input.AuthorizingOperatorPassword ||
                    (this.AuthorizingOperatorPassword != null &&
                    this.AuthorizingOperatorPassword.Equals(input.AuthorizingOperatorPassword))
                ) && 
                (
                    this.RightId == input.RightId ||
                    (this.RightId != null &&
                    this.RightId.Equals(input.RightId))
                ) && 
                (
                    this.EntryMethodCode == input.EntryMethodCode ||
                    (this.EntryMethodCode != null &&
                    this.EntryMethodCode.Equals(input.EntryMethodCode))
                ) && 
                (
                    this.LineItemRelevant == input.LineItemRelevant ||
                    (this.LineItemRelevant != null &&
                    this.LineItemRelevant.Equals(input.LineItemRelevant))
                ) && 
                (
                    this.RetailTransactionRelevant == input.RetailTransactionRelevant ||
                    (this.RetailTransactionRelevant != null &&
                    this.RetailTransactionRelevant.Equals(input.RetailTransactionRelevant))
                ) && 
                (
                    this.ControlTransactionRelevant == input.ControlTransactionRelevant ||
                    (this.ControlTransactionRelevant != null &&
                    this.ControlTransactionRelevant.Equals(input.ControlTransactionRelevant))
                ) && 
                (
                    this.TenderControlTransactionRelevant == input.TenderControlTransactionRelevant ||
                    (this.TenderControlTransactionRelevant != null &&
                    this.TenderControlTransactionRelevant.Equals(input.TenderControlTransactionRelevant))
                ) && 
                (
                    this.AuthorizingOperatorMustHaveRights == input.AuthorizingOperatorMustHaveRights ||
                    (this.AuthorizingOperatorMustHaveRights != null &&
                    this.AuthorizingOperatorMustHaveRights.Equals(input.AuthorizingOperatorMustHaveRights))
                ) && 
                (
                    this.SkipPasswordCheck == input.SkipPasswordCheck ||
                    (this.SkipPasswordCheck != null &&
                    this.SkipPasswordCheck.Equals(input.SkipPasswordCheck))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OriginalOperatorLoginName != null)
                    hashCode = hashCode * 59 + this.OriginalOperatorLoginName.GetHashCode();
                if (this.AuthorizingOperatorLoginName != null)
                    hashCode = hashCode * 59 + this.AuthorizingOperatorLoginName.GetHashCode();
                if (this.AuthorizingOperatorPassword != null)
                    hashCode = hashCode * 59 + this.AuthorizingOperatorPassword.GetHashCode();
                if (this.RightId != null)
                    hashCode = hashCode * 59 + this.RightId.GetHashCode();
                if (this.EntryMethodCode != null)
                    hashCode = hashCode * 59 + this.EntryMethodCode.GetHashCode();
                if (this.LineItemRelevant != null)
                    hashCode = hashCode * 59 + this.LineItemRelevant.GetHashCode();
                if (this.RetailTransactionRelevant != null)
                    hashCode = hashCode * 59 + this.RetailTransactionRelevant.GetHashCode();
                if (this.ControlTransactionRelevant != null)
                    hashCode = hashCode * 59 + this.ControlTransactionRelevant.GetHashCode();
                if (this.TenderControlTransactionRelevant != null)
                    hashCode = hashCode * 59 + this.TenderControlTransactionRelevant.GetHashCode();
                if (this.AuthorizingOperatorMustHaveRights != null)
                    hashCode = hashCode * 59 + this.AuthorizingOperatorMustHaveRights.GetHashCode();
                if (this.SkipPasswordCheck != null)
                    hashCode = hashCode * 59 + this.SkipPasswordCheck.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
