/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// MDReplicationProgressEvent &lt;p&gt;Event object for master data replication progress.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent :  IEquatable<ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent" /> class.
        /// </summary>
        /// <param name="eventId">&lt;p&gt;The event id.&lt;/p&gt;.</param>
        /// <param name="type">&lt;p&gt;The retail store id.&lt;/p&gt;.</param>
        /// <param name="storeNumber">&lt;p&gt;The retail store id.&lt;/p&gt;.</param>
        /// <param name="currentStep">&lt;p&gt;Returns current step (or count for count event) of action. Exact meaning of step may be different for different actions.&lt;/p&gt;.</param>
        /// <param name="stepsCount">&lt;p&gt;Returns steps count of action. Exact meaning of step may be different for different actions.&lt;/p&gt;.</param>
        /// <param name="progress">&lt;p&gt;Translates progress to interval &amp;lt;0, 1&amp;gt; Values &amp;lt; 0 and &amp;gt; 1 indicates that this is before/after. For count event 1.0 is always returned.&lt;/p&gt;.</param>
        /// <param name="beforeEvent">&lt;p&gt;Indicates if this is event called before the action started.&lt;/p&gt;.</param>
        /// <param name="afterEvent">&lt;p&gt;Indicates if this is event called after the action was completed.&lt;/p&gt;.</param>
        /// <param name="progressEvent">&lt;p&gt;Indicates that this event is progress event&lt;/p&gt;.</param>
        /// <param name="countEvent">&lt;p&gt;Indicates that this event is count event (similar to progress, but with unknown stepsCount)&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent(string eventId = default(string), string type = default(string), string storeNumber = default(string), string currentStep = default(string), string stepsCount = default(string), double? progress = default(double?), bool? beforeEvent = default(bool?), bool? afterEvent = default(bool?), bool? progressEvent = default(bool?), bool? countEvent = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.EventId = eventId;
            this.Type = type;
            this.StoreNumber = storeNumber;
            this.CurrentStep = currentStep;
            this.StepsCount = stepsCount;
            this.Progress = progress;
            this.BeforeEvent = beforeEvent;
            this.AfterEvent = afterEvent;
            this.ProgressEvent = progressEvent;
            this.CountEvent = countEvent;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The event id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The event id.&lt;/p&gt;</value>
        [DataMember(Name="eventId", EmitDefaultValue=false)]
        public string EventId { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store id.&lt;/p&gt;</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store id.&lt;/p&gt;</value>
        [DataMember(Name="storeNumber", EmitDefaultValue=false)]
        public string StoreNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Returns current step (or count for count event) of action. Exact meaning of step may be different for different actions.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Returns current step (or count for count event) of action. Exact meaning of step may be different for different actions.&lt;/p&gt;</value>
        [DataMember(Name="currentStep", EmitDefaultValue=false)]
        public string CurrentStep { get; set; }

        /// <summary>
        /// &lt;p&gt;Returns steps count of action. Exact meaning of step may be different for different actions.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Returns steps count of action. Exact meaning of step may be different for different actions.&lt;/p&gt;</value>
        [DataMember(Name="stepsCount", EmitDefaultValue=false)]
        public string StepsCount { get; set; }

        /// <summary>
        /// &lt;p&gt;Translates progress to interval &amp;lt;0, 1&amp;gt; Values &amp;lt; 0 and &amp;gt; 1 indicates that this is before/after. For count event 1.0 is always returned.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translates progress to interval &amp;lt;0, 1&amp;gt; Values &amp;lt; 0 and &amp;gt; 1 indicates that this is before/after. For count event 1.0 is always returned.&lt;/p&gt;</value>
        [DataMember(Name="progress", EmitDefaultValue=false)]
        public double? Progress { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates if this is event called before the action started.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if this is event called before the action started.&lt;/p&gt;</value>
        [DataMember(Name="beforeEvent", EmitDefaultValue=false)]
        public bool? BeforeEvent { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates if this is event called after the action was completed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if this is event called after the action was completed.&lt;/p&gt;</value>
        [DataMember(Name="afterEvent", EmitDefaultValue=false)]
        public bool? AfterEvent { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that this event is progress event&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that this event is progress event&lt;/p&gt;</value>
        [DataMember(Name="progressEvent", EmitDefaultValue=false)]
        public bool? ProgressEvent { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates that this event is count event (similar to progress, but with unknown stepsCount)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that this event is count event (similar to progress, but with unknown stepsCount)&lt;/p&gt;</value>
        [DataMember(Name="countEvent", EmitDefaultValue=false)]
        public bool? CountEvent { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent {\n");
            sb.Append("  EventId: ").Append(EventId).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  StoreNumber: ").Append(StoreNumber).Append("\n");
            sb.Append("  CurrentStep: ").Append(CurrentStep).Append("\n");
            sb.Append("  StepsCount: ").Append(StepsCount).Append("\n");
            sb.Append("  Progress: ").Append(Progress).Append("\n");
            sb.Append("  BeforeEvent: ").Append(BeforeEvent).Append("\n");
            sb.Append("  AfterEvent: ").Append(AfterEvent).Append("\n");
            sb.Append("  ProgressEvent: ").Append(ProgressEvent).Append("\n");
            sb.Append("  CountEvent: ").Append(CountEvent).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.EventId == input.EventId ||
                    (this.EventId != null &&
                    this.EventId.Equals(input.EventId))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.StoreNumber == input.StoreNumber ||
                    (this.StoreNumber != null &&
                    this.StoreNumber.Equals(input.StoreNumber))
                ) && 
                (
                    this.CurrentStep == input.CurrentStep ||
                    (this.CurrentStep != null &&
                    this.CurrentStep.Equals(input.CurrentStep))
                ) && 
                (
                    this.StepsCount == input.StepsCount ||
                    (this.StepsCount != null &&
                    this.StepsCount.Equals(input.StepsCount))
                ) && 
                (
                    this.Progress == input.Progress ||
                    (this.Progress != null &&
                    this.Progress.Equals(input.Progress))
                ) && 
                (
                    this.BeforeEvent == input.BeforeEvent ||
                    (this.BeforeEvent != null &&
                    this.BeforeEvent.Equals(input.BeforeEvent))
                ) && 
                (
                    this.AfterEvent == input.AfterEvent ||
                    (this.AfterEvent != null &&
                    this.AfterEvent.Equals(input.AfterEvent))
                ) && 
                (
                    this.ProgressEvent == input.ProgressEvent ||
                    (this.ProgressEvent != null &&
                    this.ProgressEvent.Equals(input.ProgressEvent))
                ) && 
                (
                    this.CountEvent == input.CountEvent ||
                    (this.CountEvent != null &&
                    this.CountEvent.Equals(input.CountEvent))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EventId != null)
                    hashCode = hashCode * 59 + this.EventId.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.StoreNumber != null)
                    hashCode = hashCode * 59 + this.StoreNumber.GetHashCode();
                if (this.CurrentStep != null)
                    hashCode = hashCode * 59 + this.CurrentStep.GetHashCode();
                if (this.StepsCount != null)
                    hashCode = hashCode * 59 + this.StepsCount.GetHashCode();
                if (this.Progress != null)
                    hashCode = hashCode * 59 + this.Progress.GetHashCode();
                if (this.BeforeEvent != null)
                    hashCode = hashCode * 59 + this.BeforeEvent.GetHashCode();
                if (this.AfterEvent != null)
                    hashCode = hashCode * 59 + this.AfterEvent.GetHashCode();
                if (this.ProgressEvent != null)
                    hashCode = hashCode * 59 + this.ProgressEvent.GetHashCode();
                if (this.CountEvent != null)
                    hashCode = hashCode * 59 + this.CountEvent.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
