/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GiftCertificateRequest &lt;p&gt;Request object for the StoredValueServerService.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest :  IEquatable<ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest" /> class.
        /// </summary>
        /// <param name="serviceId">&lt;p&gt;Service identifier.&lt;/p&gt;.</param>
        /// <param name="giftCertificateType">&lt;p&gt;Specifies the gift certificate type.&lt;br /&gt; Possible values are:&lt;br /&gt; gift certificate as &#39;01&#39;&lt;br /&gt; gift card as &#39;02&#39;&lt;br /&gt; foreign gift certificate as &#39;03&#39;&lt;br /&gt; promotion gift certificate as &#39;04&#39;&lt;/p&gt;.</param>
        /// <param name="giftCertificateNumber">&lt;p&gt;Gift certificate number.&lt;/p&gt;.</param>
        /// <param name="giftTrack2">&lt;p&gt;Gift certificate track2 data.&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;Amount of the gift certificate, its meaning depends on the operation.&lt;/p&gt;.</param>
        /// <param name="expiryDate">&lt;p&gt;Expiration date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="gcsTransactionUUID">&lt;p&gt;Universally unique transaction ID.&lt;/p&gt;.</param>
        /// <param name="openPaymentAmount">&lt;p&gt;The remaining payment amount for the base currency.&lt;/p&gt; (required).</param>
        /// <param name="callingProcess">&lt;p&gt;Calling process identifier.&lt;/p&gt;.</param>
        /// <param name="additionalInfo">&lt;p&gt;List of additional info attributes and values.&lt;/p&gt;.</param>
        /// <param name="trainingMode">&lt;p&gt;Indicates whether service has been started on training mode.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest(string serviceId = default(string), string giftCertificateType = default(string), string giftCertificateNumber = default(string), string giftTrack2 = default(string), ComGkSoftwarePosApiModelDomAppAmountAmount amount = default(ComGkSoftwarePosApiModelDomAppAmountAmount), string expiryDate = default(string), string gcsTransactionUUID = default(string), double? openPaymentAmount = default(double?), string callingProcess = default(string), List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> additionalInfo = default(List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue>), bool? trainingMode = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "openPaymentAmount" is required (not null)
            if (openPaymentAmount == null)
            {
                throw new InvalidDataException("openPaymentAmount is a required property for ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest and cannot be null");
            }
            else
            {
                this.OpenPaymentAmount = openPaymentAmount;
            }
            this.ServiceId = serviceId;
            this.GiftCertificateType = giftCertificateType;
            this.GiftCertificateNumber = giftCertificateNumber;
            this.GiftTrack2 = giftTrack2;
            this.Amount = amount;
            this.ExpiryDate = expiryDate;
            this.GcsTransactionUUID = gcsTransactionUUID;
            this.CallingProcess = callingProcess;
            this.AdditionalInfo = additionalInfo;
            this.TrainingMode = trainingMode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Service identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Service identifier.&lt;/p&gt;</value>
        [DataMember(Name="serviceId", EmitDefaultValue=false)]
        public string ServiceId { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies the gift certificate type.&lt;br /&gt; Possible values are:&lt;br /&gt; gift certificate as &#39;01&#39;&lt;br /&gt; gift card as &#39;02&#39;&lt;br /&gt; foreign gift certificate as &#39;03&#39;&lt;br /&gt; promotion gift certificate as &#39;04&#39;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies the gift certificate type.&lt;br /&gt; Possible values are:&lt;br /&gt; gift certificate as &#39;01&#39;&lt;br /&gt; gift card as &#39;02&#39;&lt;br /&gt; foreign gift certificate as &#39;03&#39;&lt;br /&gt; promotion gift certificate as &#39;04&#39;&lt;/p&gt;</value>
        [DataMember(Name="giftCertificateType", EmitDefaultValue=false)]
        public string GiftCertificateType { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate number.&lt;/p&gt;</value>
        [DataMember(Name="giftCertificateNumber", EmitDefaultValue=false)]
        public string GiftCertificateNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate track2 data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate track2 data.&lt;/p&gt;</value>
        [DataMember(Name="giftTrack2", EmitDefaultValue=false)]
        public string GiftTrack2 { get; set; }

        /// <summary>
        /// &lt;p&gt;Amount of the gift certificate, its meaning depends on the operation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the gift certificate, its meaning depends on the operation.&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppAmountAmount Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;Expiration date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Expiration date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="expiryDate", EmitDefaultValue=false)]
        public string ExpiryDate { get; set; }

        /// <summary>
        /// &lt;p&gt;Universally unique transaction ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Universally unique transaction ID.&lt;/p&gt;</value>
        [DataMember(Name="gcsTransactionUUID", EmitDefaultValue=false)]
        public string GcsTransactionUUID { get; set; }

        /// <summary>
        /// &lt;p&gt;The remaining payment amount for the base currency.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The remaining payment amount for the base currency.&lt;/p&gt;</value>
        [DataMember(Name="openPaymentAmount", EmitDefaultValue=false)]
        public double? OpenPaymentAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;Calling process identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Calling process identifier.&lt;/p&gt;</value>
        [DataMember(Name="callingProcess", EmitDefaultValue=false)]
        public string CallingProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;List of additional info attributes and values.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of additional info attributes and values.&lt;/p&gt;</value>
        [DataMember(Name="additionalInfo", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> AdditionalInfo { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether service has been started on training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether service has been started on training mode.&lt;/p&gt;</value>
        [DataMember(Name="trainingMode", EmitDefaultValue=false)]
        public bool? TrainingMode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest {\n");
            sb.Append("  ServiceId: ").Append(ServiceId).Append("\n");
            sb.Append("  GiftCertificateType: ").Append(GiftCertificateType).Append("\n");
            sb.Append("  GiftCertificateNumber: ").Append(GiftCertificateNumber).Append("\n");
            sb.Append("  GiftTrack2: ").Append(GiftTrack2).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  ExpiryDate: ").Append(ExpiryDate).Append("\n");
            sb.Append("  GcsTransactionUUID: ").Append(GcsTransactionUUID).Append("\n");
            sb.Append("  OpenPaymentAmount: ").Append(OpenPaymentAmount).Append("\n");
            sb.Append("  CallingProcess: ").Append(CallingProcess).Append("\n");
            sb.Append("  AdditionalInfo: ").Append(AdditionalInfo).Append("\n");
            sb.Append("  TrainingMode: ").Append(TrainingMode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceStoredValueServerGiftCertificateRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ServiceId == input.ServiceId ||
                    (this.ServiceId != null &&
                    this.ServiceId.Equals(input.ServiceId))
                ) && 
                (
                    this.GiftCertificateType == input.GiftCertificateType ||
                    (this.GiftCertificateType != null &&
                    this.GiftCertificateType.Equals(input.GiftCertificateType))
                ) && 
                (
                    this.GiftCertificateNumber == input.GiftCertificateNumber ||
                    (this.GiftCertificateNumber != null &&
                    this.GiftCertificateNumber.Equals(input.GiftCertificateNumber))
                ) && 
                (
                    this.GiftTrack2 == input.GiftTrack2 ||
                    (this.GiftTrack2 != null &&
                    this.GiftTrack2.Equals(input.GiftTrack2))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.ExpiryDate == input.ExpiryDate ||
                    (this.ExpiryDate != null &&
                    this.ExpiryDate.Equals(input.ExpiryDate))
                ) && 
                (
                    this.GcsTransactionUUID == input.GcsTransactionUUID ||
                    (this.GcsTransactionUUID != null &&
                    this.GcsTransactionUUID.Equals(input.GcsTransactionUUID))
                ) && 
                (
                    this.OpenPaymentAmount == input.OpenPaymentAmount ||
                    (this.OpenPaymentAmount != null &&
                    this.OpenPaymentAmount.Equals(input.OpenPaymentAmount))
                ) && 
                (
                    this.CallingProcess == input.CallingProcess ||
                    (this.CallingProcess != null &&
                    this.CallingProcess.Equals(input.CallingProcess))
                ) && 
                (
                    this.AdditionalInfo == input.AdditionalInfo ||
                    this.AdditionalInfo != null &&
                    this.AdditionalInfo.SequenceEqual(input.AdditionalInfo)
                ) && 
                (
                    this.TrainingMode == input.TrainingMode ||
                    (this.TrainingMode != null &&
                    this.TrainingMode.Equals(input.TrainingMode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ServiceId != null)
                    hashCode = hashCode * 59 + this.ServiceId.GetHashCode();
                if (this.GiftCertificateType != null)
                    hashCode = hashCode * 59 + this.GiftCertificateType.GetHashCode();
                if (this.GiftCertificateNumber != null)
                    hashCode = hashCode * 59 + this.GiftCertificateNumber.GetHashCode();
                if (this.GiftTrack2 != null)
                    hashCode = hashCode * 59 + this.GiftTrack2.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.ExpiryDate != null)
                    hashCode = hashCode * 59 + this.ExpiryDate.GetHashCode();
                if (this.GcsTransactionUUID != null)
                    hashCode = hashCode * 59 + this.GcsTransactionUUID.GetHashCode();
                if (this.OpenPaymentAmount != null)
                    hashCode = hashCode * 59 + this.OpenPaymentAmount.GetHashCode();
                if (this.CallingProcess != null)
                    hashCode = hashCode * 59 + this.CallingProcess.GetHashCode();
                if (this.AdditionalInfo != null)
                    hashCode = hashCode * 59 + this.AdditionalInfo.GetHashCode();
                if (this.TrainingMode != null)
                    hashCode = hashCode * 59 + this.TrainingMode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
