/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CustomerAssignmentRequest &lt;p&gt;Request object for operation which assign customer to active transaction&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest" /> class.
        /// </summary>
        /// <param name="customerId">&lt;p&gt;String : customer id&lt;/p&gt;.</param>
        /// <param name="customerCardType">&lt;p&gt;String : customer card type&lt;/p&gt;.</param>
        /// <param name="customerCardTypeDescription">&lt;p&gt;String : customer card type description&lt;/p&gt;.</param>
        /// <param name="customerGroupId">&lt;p&gt;String : customer group id&lt;/p&gt;.</param>
        /// <param name="customerDO">&lt;p&gt;CustomerDO : customerDO&lt;/p&gt;.</param>
        /// <param name="customerTenderGroup">customerTenderGroup.</param>
        /// <param name="customerData">&lt;p&gt;CustomerData : customer data used for customer data entry process&lt;/p&gt;.</param>
        /// <param name="customerWebServiceData">&lt;p&gt;CustomerWebserviceResult : customer web service data&lt;/p&gt;.</param>
        /// <param name="searchForIdentificationNumber">&lt;p&gt;boolean : searchFor identification number&lt;/p&gt;.</param>
        /// <param name="customerIDEntryMethodCode">&lt;p&gt;String : customer iD entry method code&lt;/p&gt;.</param>
        /// <param name="preferredReceiptPrintoutTypeCode">&lt;p&gt;String : preferredReceiptPrintoutTypeCode&lt;br /&gt; It defines the preferred printout type code of the customer:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;CLIENT - Printout depends on client settings.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTONLY - Customer wants to have a printed receipt.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;MAILONLY - Customer wants to have the receipt per mail.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;NOTHING - Customer wants to have nothing.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTANDMAIL - Customer wants to have a printed receipt and a mail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="organizationName">&lt;p&gt;The organization name&lt;/p&gt;.</param>
        /// <param name="dataProvider">&lt;p&gt;The data provider id&lt;/p&gt;.</param>
        /// <param name="genericFlag">&lt;p&gt;It specifies if the customer is a dummy/unknown customer &lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest(string customerId = default(string), string customerCardType = default(string), string customerCardTypeDescription = default(string), string customerGroupId = default(string), ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO customerDO = default(ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO), ComGkSoftwareGkrApiServerMdCustomerTenderRuleDtoDomCustomerTenderGroupDO customerTenderGroup = default(ComGkSoftwareGkrApiServerMdCustomerTenderRuleDtoDomCustomerTenderGroupDO), ComGkSoftwarePosFlowLibsCustomerCustomerData customerData = default(ComGkSoftwarePosFlowLibsCustomerCustomerData), ComGkSoftwarePosApiServiceCommunicationWsCustomerByIdCustomerWebserviceResult customerWebServiceData = default(ComGkSoftwarePosApiServiceCommunicationWsCustomerByIdCustomerWebserviceResult), bool? searchForIdentificationNumber = default(bool?), string customerIDEntryMethodCode = default(string), string preferredReceiptPrintoutTypeCode = default(string), string organizationName = default(string), string dataProvider = default(string), bool? genericFlag = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.CustomerId = customerId;
            this.CustomerCardType = customerCardType;
            this.CustomerCardTypeDescription = customerCardTypeDescription;
            this.CustomerGroupId = customerGroupId;
            this.CustomerDO = customerDO;
            this.CustomerTenderGroup = customerTenderGroup;
            this.CustomerData = customerData;
            this.CustomerWebServiceData = customerWebServiceData;
            this.SearchForIdentificationNumber = searchForIdentificationNumber;
            this.CustomerIDEntryMethodCode = customerIDEntryMethodCode;
            this.PreferredReceiptPrintoutTypeCode = preferredReceiptPrintoutTypeCode;
            this.OrganizationName = organizationName;
            this.DataProvider = dataProvider;
            this.GenericFlag = genericFlag;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;String : customer id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer id&lt;/p&gt;</value>
        [DataMember(Name="customerId", EmitDefaultValue=false)]
        public string CustomerId { get; set; }

        /// <summary>
        /// &lt;p&gt;String : customer card type&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer card type&lt;/p&gt;</value>
        [DataMember(Name="customerCardType", EmitDefaultValue=false)]
        public string CustomerCardType { get; set; }

        /// <summary>
        /// &lt;p&gt;String : customer card type description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer card type description&lt;/p&gt;</value>
        [DataMember(Name="customerCardTypeDescription", EmitDefaultValue=false)]
        public string CustomerCardTypeDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;String : customer group id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer group id&lt;/p&gt;</value>
        [DataMember(Name="customerGroupId", EmitDefaultValue=false)]
        public string CustomerGroupId { get; set; }

        /// <summary>
        /// &lt;p&gt;CustomerDO : customerDO&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerDO : customerDO&lt;/p&gt;</value>
        [DataMember(Name="customerDO", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO CustomerDO { get; set; }

        /// <summary>
        /// Gets or Sets CustomerTenderGroup
        /// </summary>
        [DataMember(Name="customerTenderGroup", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdCustomerTenderRuleDtoDomCustomerTenderGroupDO CustomerTenderGroup { get; set; }

        /// <summary>
        /// &lt;p&gt;CustomerData : customer data used for customer data entry process&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerData : customer data used for customer data entry process&lt;/p&gt;</value>
        [DataMember(Name="customerData", EmitDefaultValue=false)]
        public ComGkSoftwarePosFlowLibsCustomerCustomerData CustomerData { get; set; }

        /// <summary>
        /// &lt;p&gt;CustomerWebserviceResult : customer web service data&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerWebserviceResult : customer web service data&lt;/p&gt;</value>
        [DataMember(Name="customerWebServiceData", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceCommunicationWsCustomerByIdCustomerWebserviceResult CustomerWebServiceData { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean : searchFor identification number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : searchFor identification number&lt;/p&gt;</value>
        [DataMember(Name="searchForIdentificationNumber", EmitDefaultValue=false)]
        public bool? SearchForIdentificationNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;String : customer iD entry method code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer iD entry method code&lt;/p&gt;</value>
        [DataMember(Name="customerIDEntryMethodCode", EmitDefaultValue=false)]
        public string CustomerIDEntryMethodCode { get; set; }

        /// <summary>
        /// &lt;p&gt;String : preferredReceiptPrintoutTypeCode&lt;br /&gt; It defines the preferred printout type code of the customer:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;CLIENT - Printout depends on client settings.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTONLY - Customer wants to have a printed receipt.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;MAILONLY - Customer wants to have the receipt per mail.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;NOTHING - Customer wants to have nothing.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTANDMAIL - Customer wants to have a printed receipt and a mail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : preferredReceiptPrintoutTypeCode&lt;br /&gt; It defines the preferred printout type code of the customer:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;CLIENT - Printout depends on client settings.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTONLY - Customer wants to have a printed receipt.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;MAILONLY - Customer wants to have the receipt per mail.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;NOTHING - Customer wants to have nothing.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTANDMAIL - Customer wants to have a printed receipt and a mail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="preferredReceiptPrintoutTypeCode", EmitDefaultValue=false)]
        public string PreferredReceiptPrintoutTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The organization name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The organization name&lt;/p&gt;</value>
        [DataMember(Name="organizationName", EmitDefaultValue=false)]
        public string OrganizationName { get; set; }

        /// <summary>
        /// &lt;p&gt;The data provider id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The data provider id&lt;/p&gt;</value>
        [DataMember(Name="dataProvider", EmitDefaultValue=false)]
        public string DataProvider { get; set; }

        /// <summary>
        /// &lt;p&gt;It specifies if the customer is a dummy/unknown customer &lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It specifies if the customer is a dummy/unknown customer &lt;/p&gt;</value>
        [DataMember(Name="genericFlag", EmitDefaultValue=false)]
        public bool? GenericFlag { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest {\n");
            sb.Append("  CustomerId: ").Append(CustomerId).Append("\n");
            sb.Append("  CustomerCardType: ").Append(CustomerCardType).Append("\n");
            sb.Append("  CustomerCardTypeDescription: ").Append(CustomerCardTypeDescription).Append("\n");
            sb.Append("  CustomerGroupId: ").Append(CustomerGroupId).Append("\n");
            sb.Append("  CustomerDO: ").Append(CustomerDO).Append("\n");
            sb.Append("  CustomerTenderGroup: ").Append(CustomerTenderGroup).Append("\n");
            sb.Append("  CustomerData: ").Append(CustomerData).Append("\n");
            sb.Append("  CustomerWebServiceData: ").Append(CustomerWebServiceData).Append("\n");
            sb.Append("  SearchForIdentificationNumber: ").Append(SearchForIdentificationNumber).Append("\n");
            sb.Append("  CustomerIDEntryMethodCode: ").Append(CustomerIDEntryMethodCode).Append("\n");
            sb.Append("  PreferredReceiptPrintoutTypeCode: ").Append(PreferredReceiptPrintoutTypeCode).Append("\n");
            sb.Append("  OrganizationName: ").Append(OrganizationName).Append("\n");
            sb.Append("  DataProvider: ").Append(DataProvider).Append("\n");
            sb.Append("  GenericFlag: ").Append(GenericFlag).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CustomerId == input.CustomerId ||
                    (this.CustomerId != null &&
                    this.CustomerId.Equals(input.CustomerId))
                ) && 
                (
                    this.CustomerCardType == input.CustomerCardType ||
                    (this.CustomerCardType != null &&
                    this.CustomerCardType.Equals(input.CustomerCardType))
                ) && 
                (
                    this.CustomerCardTypeDescription == input.CustomerCardTypeDescription ||
                    (this.CustomerCardTypeDescription != null &&
                    this.CustomerCardTypeDescription.Equals(input.CustomerCardTypeDescription))
                ) && 
                (
                    this.CustomerGroupId == input.CustomerGroupId ||
                    (this.CustomerGroupId != null &&
                    this.CustomerGroupId.Equals(input.CustomerGroupId))
                ) && 
                (
                    this.CustomerDO == input.CustomerDO ||
                    (this.CustomerDO != null &&
                    this.CustomerDO.Equals(input.CustomerDO))
                ) && 
                (
                    this.CustomerTenderGroup == input.CustomerTenderGroup ||
                    (this.CustomerTenderGroup != null &&
                    this.CustomerTenderGroup.Equals(input.CustomerTenderGroup))
                ) && 
                (
                    this.CustomerData == input.CustomerData ||
                    (this.CustomerData != null &&
                    this.CustomerData.Equals(input.CustomerData))
                ) && 
                (
                    this.CustomerWebServiceData == input.CustomerWebServiceData ||
                    (this.CustomerWebServiceData != null &&
                    this.CustomerWebServiceData.Equals(input.CustomerWebServiceData))
                ) && 
                (
                    this.SearchForIdentificationNumber == input.SearchForIdentificationNumber ||
                    (this.SearchForIdentificationNumber != null &&
                    this.SearchForIdentificationNumber.Equals(input.SearchForIdentificationNumber))
                ) && 
                (
                    this.CustomerIDEntryMethodCode == input.CustomerIDEntryMethodCode ||
                    (this.CustomerIDEntryMethodCode != null &&
                    this.CustomerIDEntryMethodCode.Equals(input.CustomerIDEntryMethodCode))
                ) && 
                (
                    this.PreferredReceiptPrintoutTypeCode == input.PreferredReceiptPrintoutTypeCode ||
                    (this.PreferredReceiptPrintoutTypeCode != null &&
                    this.PreferredReceiptPrintoutTypeCode.Equals(input.PreferredReceiptPrintoutTypeCode))
                ) && 
                (
                    this.OrganizationName == input.OrganizationName ||
                    (this.OrganizationName != null &&
                    this.OrganizationName.Equals(input.OrganizationName))
                ) && 
                (
                    this.DataProvider == input.DataProvider ||
                    (this.DataProvider != null &&
                    this.DataProvider.Equals(input.DataProvider))
                ) && 
                (
                    this.GenericFlag == input.GenericFlag ||
                    (this.GenericFlag != null &&
                    this.GenericFlag.Equals(input.GenericFlag))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CustomerId != null)
                    hashCode = hashCode * 59 + this.CustomerId.GetHashCode();
                if (this.CustomerCardType != null)
                    hashCode = hashCode * 59 + this.CustomerCardType.GetHashCode();
                if (this.CustomerCardTypeDescription != null)
                    hashCode = hashCode * 59 + this.CustomerCardTypeDescription.GetHashCode();
                if (this.CustomerGroupId != null)
                    hashCode = hashCode * 59 + this.CustomerGroupId.GetHashCode();
                if (this.CustomerDO != null)
                    hashCode = hashCode * 59 + this.CustomerDO.GetHashCode();
                if (this.CustomerTenderGroup != null)
                    hashCode = hashCode * 59 + this.CustomerTenderGroup.GetHashCode();
                if (this.CustomerData != null)
                    hashCode = hashCode * 59 + this.CustomerData.GetHashCode();
                if (this.CustomerWebServiceData != null)
                    hashCode = hashCode * 59 + this.CustomerWebServiceData.GetHashCode();
                if (this.SearchForIdentificationNumber != null)
                    hashCode = hashCode * 59 + this.SearchForIdentificationNumber.GetHashCode();
                if (this.CustomerIDEntryMethodCode != null)
                    hashCode = hashCode * 59 + this.CustomerIDEntryMethodCode.GetHashCode();
                if (this.PreferredReceiptPrintoutTypeCode != null)
                    hashCode = hashCode * 59 + this.PreferredReceiptPrintoutTypeCode.GetHashCode();
                if (this.OrganizationName != null)
                    hashCode = hashCode * 59 + this.OrganizationName.GetHashCode();
                if (this.DataProvider != null)
                    hashCode = hashCode * 59 + this.DataProvider.GetHashCode();
                if (this.GenericFlag != null)
                    hashCode = hashCode * 59 + this.GenericFlag.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
