/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PayInOutLineItemRequest &lt;p&gt;Domain object for CreatePayInOutLineItem Request&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;The PayInOutType&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The PayInOutType&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ItemTypeEnum
        {
            
            /// <summary>
            /// Enum INLINEITEM for value: PAY_IN_LINEITEM
            /// </summary>
            [EnumMember(Value = "PAY_IN_LINEITEM")]
            INLINEITEM = 1,
            
            /// <summary>
            /// Enum INRECEIPT for value: PAY_IN_RECEIPT
            /// </summary>
            [EnumMember(Value = "PAY_IN_RECEIPT")]
            INRECEIPT = 2,
            
            /// <summary>
            /// Enum OUTLINEITEM for value: PAY_OUT_LINEITEM
            /// </summary>
            [EnumMember(Value = "PAY_OUT_LINEITEM")]
            OUTLINEITEM = 3,
            
            /// <summary>
            /// Enum OUTRECEIPT for value: PAY_OUT_RECEIPT
            /// </summary>
            [EnumMember(Value = "PAY_OUT_RECEIPT")]
            OUTRECEIPT = 4
        }

        /// <summary>
        /// &lt;p&gt;The PayInOutType&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The PayInOutType&lt;/p&gt;</value>
        [DataMember(Name="itemType", EmitDefaultValue=false)]
        public ItemTypeEnum? ItemType { get; set; }
        /// <summary>
        /// &lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SellerRelationMethodEnum
        {
            
            /// <summary>
            /// Enum CurrentLineItemOnly for value: CurrentLineItemOnly
            /// </summary>
            [EnumMember(Value = "CurrentLineItemOnly")]
            CurrentLineItemOnly = 1,
            
            /// <summary>
            /// Enum CurrentAndFollowingLineItemsOfCurrentTransaction for value: CurrentAndFollowingLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "CurrentAndFollowingLineItemsOfCurrentTransaction")]
            CurrentAndFollowingLineItemsOfCurrentTransaction = 2,
            
            /// <summary>
            /// Enum CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions for value: CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions
            /// </summary>
            [EnumMember(Value = "CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions")]
            CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions = 3,
            
            /// <summary>
            /// Enum AllLineItemsOfCurrentTransaction for value: AllLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "AllLineItemsOfCurrentTransaction")]
            AllLineItemsOfCurrentTransaction = 4,
            
            /// <summary>
            /// Enum FollowingLineItemsOfCurrentTransaction for value: FollowingLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "FollowingLineItemsOfCurrentTransaction")]
            FollowingLineItemsOfCurrentTransaction = 5,
            
            /// <summary>
            /// Enum FollowingLineItemsOfCurrentAndFollowingTransactions for value: FollowingLineItemsOfCurrentAndFollowingTransactions
            /// </summary>
            [EnumMember(Value = "FollowingLineItemsOfCurrentAndFollowingTransactions")]
            FollowingLineItemsOfCurrentAndFollowingTransactions = 6
        }

        /// <summary>
        /// &lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;</value>
        [DataMember(Name="sellerRelationMethod", EmitDefaultValue=false)]
        public SellerRelationMethodEnum? SellerRelationMethod { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest" /> class.
        /// </summary>
        /// <param name="reason">&lt;p&gt;The reason&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;The amount&lt;/p&gt;.</param>
        /// <param name="taxGroupId">&lt;p&gt;The taxGroupId&lt;/p&gt;.</param>
        /// <param name="itemType">&lt;p&gt;The PayInOutType&lt;/p&gt;.</param>
        /// <param name="operationConfiguration">&lt;p&gt;The operationConfiguration&lt;/p&gt;.</param>
        /// <param name="receiptText">&lt;p&gt;The receiptText&lt;/p&gt;.</param>
        /// <param name="customerReceiptText">&lt;p&gt;The customerReceiptText&lt;/p&gt;.</param>
        /// <param name="reasonParams">&lt;p&gt;The PayInOutReasonParam&lt;/p&gt;.</param>
        /// <param name="alternativeTaxInfos">&lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;.</param>
        /// <param name="sellerId">&lt;p&gt;String to store seller Id&lt;/p&gt;.</param>
        /// <param name="sellerRelationMethod">&lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;.</param>
        /// <param name="entryMethodCode">&lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest(ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO reason = default(ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO), double? amount = default(double?), string taxGroupId = default(string), ItemTypeEnum? itemType = default(ItemTypeEnum?), ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), string receiptText = default(string), string customerReceiptText = default(string), ComGkSoftwarePosApiServiceTransactionPayInOutReasonParam reasonParams = default(ComGkSoftwarePosApiServiceTransactionPayInOutReasonParam), ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos alternativeTaxInfos = default(ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos), string sellerId = default(string), SellerRelationMethodEnum? sellerRelationMethod = default(SellerRelationMethodEnum?), string entryMethodCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.Reason = reason;
            this.Amount = amount;
            this.TaxGroupId = taxGroupId;
            this.ItemType = itemType;
            this.OperationConfiguration = operationConfiguration;
            this.ReceiptText = receiptText;
            this.CustomerReceiptText = customerReceiptText;
            this.ReasonParams = reasonParams;
            this.AlternativeTaxInfos = alternativeTaxInfos;
            this.SellerId = sellerId;
            this.SellerRelationMethod = sellerRelationMethod;
            this.EntryMethodCode = entryMethodCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The reason&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The reason&lt;/p&gt;</value>
        [DataMember(Name="reason", EmitDefaultValue=false)]
        public ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO Reason { get; set; }

        /// <summary>
        /// &lt;p&gt;The amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;The taxGroupId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The taxGroupId&lt;/p&gt;</value>
        [DataMember(Name="taxGroupId", EmitDefaultValue=false)]
        public string TaxGroupId { get; set; }


        /// <summary>
        /// &lt;p&gt;The operationConfiguration&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operationConfiguration&lt;/p&gt;</value>
        [DataMember(Name="operationConfiguration", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig OperationConfiguration { get; set; }

        /// <summary>
        /// &lt;p&gt;The receiptText&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The receiptText&lt;/p&gt;</value>
        [DataMember(Name="receiptText", EmitDefaultValue=false)]
        public string ReceiptText { get; set; }

        /// <summary>
        /// &lt;p&gt;The customerReceiptText&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customerReceiptText&lt;/p&gt;</value>
        [DataMember(Name="customerReceiptText", EmitDefaultValue=false)]
        public string CustomerReceiptText { get; set; }

        /// <summary>
        /// &lt;p&gt;The PayInOutReasonParam&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The PayInOutReasonParam&lt;/p&gt;</value>
        [DataMember(Name="reasonParams", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceTransactionPayInOutReasonParam ReasonParams { get; set; }

        /// <summary>
        /// &lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;</value>
        [DataMember(Name="alternativeTaxInfos", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos AlternativeTaxInfos { get; set; }

        /// <summary>
        /// &lt;p&gt;String to store seller Id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String to store seller Id&lt;/p&gt;</value>
        [DataMember(Name="sellerId", EmitDefaultValue=false)]
        public string SellerId { get; set; }


        /// <summary>
        /// &lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;</value>
        [DataMember(Name="entryMethodCode", EmitDefaultValue=false)]
        public string EntryMethodCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest {\n");
            sb.Append("  Reason: ").Append(Reason).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  TaxGroupId: ").Append(TaxGroupId).Append("\n");
            sb.Append("  ItemType: ").Append(ItemType).Append("\n");
            sb.Append("  OperationConfiguration: ").Append(OperationConfiguration).Append("\n");
            sb.Append("  ReceiptText: ").Append(ReceiptText).Append("\n");
            sb.Append("  CustomerReceiptText: ").Append(CustomerReceiptText).Append("\n");
            sb.Append("  ReasonParams: ").Append(ReasonParams).Append("\n");
            sb.Append("  AlternativeTaxInfos: ").Append(AlternativeTaxInfos).Append("\n");
            sb.Append("  SellerId: ").Append(SellerId).Append("\n");
            sb.Append("  SellerRelationMethod: ").Append(SellerRelationMethod).Append("\n");
            sb.Append("  EntryMethodCode: ").Append(EntryMethodCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionPayInOutLineItemRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Reason == input.Reason ||
                    (this.Reason != null &&
                    this.Reason.Equals(input.Reason))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.TaxGroupId == input.TaxGroupId ||
                    (this.TaxGroupId != null &&
                    this.TaxGroupId.Equals(input.TaxGroupId))
                ) && 
                (
                    this.ItemType == input.ItemType ||
                    (this.ItemType != null &&
                    this.ItemType.Equals(input.ItemType))
                ) && 
                (
                    this.OperationConfiguration == input.OperationConfiguration ||
                    (this.OperationConfiguration != null &&
                    this.OperationConfiguration.Equals(input.OperationConfiguration))
                ) && 
                (
                    this.ReceiptText == input.ReceiptText ||
                    (this.ReceiptText != null &&
                    this.ReceiptText.Equals(input.ReceiptText))
                ) && 
                (
                    this.CustomerReceiptText == input.CustomerReceiptText ||
                    (this.CustomerReceiptText != null &&
                    this.CustomerReceiptText.Equals(input.CustomerReceiptText))
                ) && 
                (
                    this.ReasonParams == input.ReasonParams ||
                    (this.ReasonParams != null &&
                    this.ReasonParams.Equals(input.ReasonParams))
                ) && 
                (
                    this.AlternativeTaxInfos == input.AlternativeTaxInfos ||
                    (this.AlternativeTaxInfos != null &&
                    this.AlternativeTaxInfos.Equals(input.AlternativeTaxInfos))
                ) && 
                (
                    this.SellerId == input.SellerId ||
                    (this.SellerId != null &&
                    this.SellerId.Equals(input.SellerId))
                ) && 
                (
                    this.SellerRelationMethod == input.SellerRelationMethod ||
                    (this.SellerRelationMethod != null &&
                    this.SellerRelationMethod.Equals(input.SellerRelationMethod))
                ) && 
                (
                    this.EntryMethodCode == input.EntryMethodCode ||
                    (this.EntryMethodCode != null &&
                    this.EntryMethodCode.Equals(input.EntryMethodCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Reason != null)
                    hashCode = hashCode * 59 + this.Reason.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.TaxGroupId != null)
                    hashCode = hashCode * 59 + this.TaxGroupId.GetHashCode();
                if (this.ItemType != null)
                    hashCode = hashCode * 59 + this.ItemType.GetHashCode();
                if (this.OperationConfiguration != null)
                    hashCode = hashCode * 59 + this.OperationConfiguration.GetHashCode();
                if (this.ReceiptText != null)
                    hashCode = hashCode * 59 + this.ReceiptText.GetHashCode();
                if (this.CustomerReceiptText != null)
                    hashCode = hashCode * 59 + this.CustomerReceiptText.GetHashCode();
                if (this.ReasonParams != null)
                    hashCode = hashCode * 59 + this.ReasonParams.GetHashCode();
                if (this.AlternativeTaxInfos != null)
                    hashCode = hashCode * 59 + this.AlternativeTaxInfos.GetHashCode();
                if (this.SellerId != null)
                    hashCode = hashCode * 59 + this.SellerId.GetHashCode();
                if (this.SellerRelationMethod != null)
                    hashCode = hashCode * 59 + this.SellerRelationMethod.GetHashCode();
                if (this.EntryMethodCode != null)
                    hashCode = hashCode * 59 + this.EntryMethodCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
