/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrintOutTransactionsRequest &lt;p&gt;Request object to search for printout transactions.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest" /> class.
        /// </summary>
        /// <param name="onlySalesReprintable">&lt;p&gt;A flag to indicate that only transaction of type code &#39;RETAIL&#39; and category code &#39;SALE&#39; should be searched.&lt;/p&gt;.</param>
        /// <param name="transactionTypeCode">&lt;p&gt;The transaction type code.&lt;/p&gt;.</param>
        /// <param name="retailTransactionTypeCode">&lt;p&gt;The retail transaction type code.&lt;/p&gt;.</param>
        /// <param name="transactionIsNotVoided">&lt;p&gt;A flag to indicate that only transactions that are not voided should be searched.&lt;/p&gt;.</param>
        /// <param name="cancelledFlag">&lt;p&gt;A flag to indicate that only transactions that are cancelled should be searched.&lt;/p&gt;.</param>
        /// <param name="suspendedFlag">&lt;p&gt;A flag to indicate that only transactions that are suspended should be searched.&lt;/p&gt;.</param>
        /// <param name="workstationID">&lt;p&gt;The workstation identifier.&lt;/p&gt;.</param>
        /// <param name="endWorkstationID">endWorkstationID.</param>
        /// <param name="businessUnitGroupID">&lt;p&gt;The business unit group identifier.&lt;/p&gt;.</param>
        /// <param name="receiptIsPrintable">&lt;p&gt;A flag to indicate that only transactions that are printable should be searched.&lt;/p&gt;.</param>
        /// <param name="maxReceiptCount">&lt;p&gt;Limits the number of found receipts to the given value.&lt;/p&gt;.</param>
        /// <param name="beginDateTimestampGreaterOrEquals">&lt;p&gt;The begin date timestamp greater or equals (as part of the search criteria).&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="parentCustomerIds">&lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;.</param>
        /// <param name="customerIds">&lt;p&gt;A list of customer identifiers.&lt;/p&gt;.</param>
        /// <param name="customerAddressTypeCode">&lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest(bool? onlySalesReprintable = default(bool?), string transactionTypeCode = default(string), string retailTransactionTypeCode = default(string), bool? transactionIsNotVoided = default(bool?), bool? cancelledFlag = default(bool?), bool? suspendedFlag = default(bool?), string workstationID = default(string), string endWorkstationID = default(string), string businessUnitGroupID = default(string), bool? receiptIsPrintable = default(bool?), int? maxReceiptCount = default(int?), string beginDateTimestampGreaterOrEquals = default(string), List<string> parentCustomerIds = default(List<string>), List<string> customerIds = default(List<string>), string customerAddressTypeCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.OnlySalesReprintable = onlySalesReprintable;
            this.TransactionTypeCode = transactionTypeCode;
            this.RetailTransactionTypeCode = retailTransactionTypeCode;
            this.TransactionIsNotVoided = transactionIsNotVoided;
            this.CancelledFlag = cancelledFlag;
            this.SuspendedFlag = suspendedFlag;
            this.WorkstationID = workstationID;
            this.EndWorkstationID = endWorkstationID;
            this.BusinessUnitGroupID = businessUnitGroupID;
            this.ReceiptIsPrintable = receiptIsPrintable;
            this.MaxReceiptCount = maxReceiptCount;
            this.BeginDateTimestampGreaterOrEquals = beginDateTimestampGreaterOrEquals;
            this.ParentCustomerIds = parentCustomerIds;
            this.CustomerIds = customerIds;
            this.CustomerAddressTypeCode = customerAddressTypeCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transaction of type code &#39;RETAIL&#39; and category code &#39;SALE&#39; should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transaction of type code &#39;RETAIL&#39; and category code &#39;SALE&#39; should be searched.&lt;/p&gt;</value>
        [DataMember(Name="onlySalesReprintable", EmitDefaultValue=false)]
        public bool? OnlySalesReprintable { get; set; }

        /// <summary>
        /// &lt;p&gt;The transaction type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction type code.&lt;/p&gt;</value>
        [DataMember(Name="TransactionTypeCode", EmitDefaultValue=false)]
        public string TransactionTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail transaction type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail transaction type code.&lt;/p&gt;</value>
        [DataMember(Name="RetailTransactionTypeCode", EmitDefaultValue=false)]
        public string RetailTransactionTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are not voided should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are not voided should be searched.&lt;/p&gt;</value>
        [DataMember(Name="transactionIsNotVoided", EmitDefaultValue=false)]
        public bool? TransactionIsNotVoided { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are cancelled should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are cancelled should be searched.&lt;/p&gt;</value>
        [DataMember(Name="CancelledFlag", EmitDefaultValue=false)]
        public bool? CancelledFlag { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are suspended should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are suspended should be searched.&lt;/p&gt;</value>
        [DataMember(Name="SuspendedFlag", EmitDefaultValue=false)]
        public bool? SuspendedFlag { get; set; }

        /// <summary>
        /// &lt;p&gt;The workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation identifier.&lt;/p&gt;</value>
        [DataMember(Name="workstationID", EmitDefaultValue=false)]
        public string WorkstationID { get; set; }

        /// <summary>
        /// Gets or Sets EndWorkstationID
        /// </summary>
        [DataMember(Name="endWorkstationID", EmitDefaultValue=false)]
        public string EndWorkstationID { get; set; }

        /// <summary>
        /// &lt;p&gt;The business unit group identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit group identifier.&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are printable should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are printable should be searched.&lt;/p&gt;</value>
        [DataMember(Name="receiptIsPrintable", EmitDefaultValue=false)]
        public bool? ReceiptIsPrintable { get; set; }

        /// <summary>
        /// &lt;p&gt;Limits the number of found receipts to the given value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Limits the number of found receipts to the given value.&lt;/p&gt;</value>
        [DataMember(Name="maxReceiptCount", EmitDefaultValue=false)]
        public int? MaxReceiptCount { get; set; }

        /// <summary>
        /// &lt;p&gt;The begin date timestamp greater or equals (as part of the search criteria).&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The begin date timestamp greater or equals (as part of the search criteria).&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="beginDateTimestampGreaterOrEquals", EmitDefaultValue=false)]
        public string BeginDateTimestampGreaterOrEquals { get; set; }

        /// <summary>
        /// &lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;</value>
        [DataMember(Name="parentCustomerIds", EmitDefaultValue=false)]
        public List<string> ParentCustomerIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A list of customer identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of customer identifiers.&lt;/p&gt;</value>
        [DataMember(Name="customerIds", EmitDefaultValue=false)]
        public List<string> CustomerIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;</value>
        [DataMember(Name="customerAddressTypeCode", EmitDefaultValue=false)]
        public string CustomerAddressTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest {\n");
            sb.Append("  OnlySalesReprintable: ").Append(OnlySalesReprintable).Append("\n");
            sb.Append("  TransactionTypeCode: ").Append(TransactionTypeCode).Append("\n");
            sb.Append("  RetailTransactionTypeCode: ").Append(RetailTransactionTypeCode).Append("\n");
            sb.Append("  TransactionIsNotVoided: ").Append(TransactionIsNotVoided).Append("\n");
            sb.Append("  CancelledFlag: ").Append(CancelledFlag).Append("\n");
            sb.Append("  SuspendedFlag: ").Append(SuspendedFlag).Append("\n");
            sb.Append("  WorkstationID: ").Append(WorkstationID).Append("\n");
            sb.Append("  EndWorkstationID: ").Append(EndWorkstationID).Append("\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  ReceiptIsPrintable: ").Append(ReceiptIsPrintable).Append("\n");
            sb.Append("  MaxReceiptCount: ").Append(MaxReceiptCount).Append("\n");
            sb.Append("  BeginDateTimestampGreaterOrEquals: ").Append(BeginDateTimestampGreaterOrEquals).Append("\n");
            sb.Append("  ParentCustomerIds: ").Append(ParentCustomerIds).Append("\n");
            sb.Append("  CustomerIds: ").Append(CustomerIds).Append("\n");
            sb.Append("  CustomerAddressTypeCode: ").Append(CustomerAddressTypeCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionPrintOutTransactionsRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnlySalesReprintable == input.OnlySalesReprintable ||
                    (this.OnlySalesReprintable != null &&
                    this.OnlySalesReprintable.Equals(input.OnlySalesReprintable))
                ) && 
                (
                    this.TransactionTypeCode == input.TransactionTypeCode ||
                    (this.TransactionTypeCode != null &&
                    this.TransactionTypeCode.Equals(input.TransactionTypeCode))
                ) && 
                (
                    this.RetailTransactionTypeCode == input.RetailTransactionTypeCode ||
                    (this.RetailTransactionTypeCode != null &&
                    this.RetailTransactionTypeCode.Equals(input.RetailTransactionTypeCode))
                ) && 
                (
                    this.TransactionIsNotVoided == input.TransactionIsNotVoided ||
                    (this.TransactionIsNotVoided != null &&
                    this.TransactionIsNotVoided.Equals(input.TransactionIsNotVoided))
                ) && 
                (
                    this.CancelledFlag == input.CancelledFlag ||
                    (this.CancelledFlag != null &&
                    this.CancelledFlag.Equals(input.CancelledFlag))
                ) && 
                (
                    this.SuspendedFlag == input.SuspendedFlag ||
                    (this.SuspendedFlag != null &&
                    this.SuspendedFlag.Equals(input.SuspendedFlag))
                ) && 
                (
                    this.WorkstationID == input.WorkstationID ||
                    (this.WorkstationID != null &&
                    this.WorkstationID.Equals(input.WorkstationID))
                ) && 
                (
                    this.EndWorkstationID == input.EndWorkstationID ||
                    (this.EndWorkstationID != null &&
                    this.EndWorkstationID.Equals(input.EndWorkstationID))
                ) && 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.ReceiptIsPrintable == input.ReceiptIsPrintable ||
                    (this.ReceiptIsPrintable != null &&
                    this.ReceiptIsPrintable.Equals(input.ReceiptIsPrintable))
                ) && 
                (
                    this.MaxReceiptCount == input.MaxReceiptCount ||
                    (this.MaxReceiptCount != null &&
                    this.MaxReceiptCount.Equals(input.MaxReceiptCount))
                ) && 
                (
                    this.BeginDateTimestampGreaterOrEquals == input.BeginDateTimestampGreaterOrEquals ||
                    (this.BeginDateTimestampGreaterOrEquals != null &&
                    this.BeginDateTimestampGreaterOrEquals.Equals(input.BeginDateTimestampGreaterOrEquals))
                ) && 
                (
                    this.ParentCustomerIds == input.ParentCustomerIds ||
                    this.ParentCustomerIds != null &&
                    this.ParentCustomerIds.SequenceEqual(input.ParentCustomerIds)
                ) && 
                (
                    this.CustomerIds == input.CustomerIds ||
                    this.CustomerIds != null &&
                    this.CustomerIds.SequenceEqual(input.CustomerIds)
                ) && 
                (
                    this.CustomerAddressTypeCode == input.CustomerAddressTypeCode ||
                    (this.CustomerAddressTypeCode != null &&
                    this.CustomerAddressTypeCode.Equals(input.CustomerAddressTypeCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnlySalesReprintable != null)
                    hashCode = hashCode * 59 + this.OnlySalesReprintable.GetHashCode();
                if (this.TransactionTypeCode != null)
                    hashCode = hashCode * 59 + this.TransactionTypeCode.GetHashCode();
                if (this.RetailTransactionTypeCode != null)
                    hashCode = hashCode * 59 + this.RetailTransactionTypeCode.GetHashCode();
                if (this.TransactionIsNotVoided != null)
                    hashCode = hashCode * 59 + this.TransactionIsNotVoided.GetHashCode();
                if (this.CancelledFlag != null)
                    hashCode = hashCode * 59 + this.CancelledFlag.GetHashCode();
                if (this.SuspendedFlag != null)
                    hashCode = hashCode * 59 + this.SuspendedFlag.GetHashCode();
                if (this.WorkstationID != null)
                    hashCode = hashCode * 59 + this.WorkstationID.GetHashCode();
                if (this.EndWorkstationID != null)
                    hashCode = hashCode * 59 + this.EndWorkstationID.GetHashCode();
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.ReceiptIsPrintable != null)
                    hashCode = hashCode * 59 + this.ReceiptIsPrintable.GetHashCode();
                if (this.MaxReceiptCount != null)
                    hashCode = hashCode * 59 + this.MaxReceiptCount.GetHashCode();
                if (this.BeginDateTimestampGreaterOrEquals != null)
                    hashCode = hashCode * 59 + this.BeginDateTimestampGreaterOrEquals.GetHashCode();
                if (this.ParentCustomerIds != null)
                    hashCode = hashCode * 59 + this.ParentCustomerIds.GetHashCode();
                if (this.CustomerIds != null)
                    hashCode = hashCode * 59 + this.CustomerIds.GetHashCode();
                if (this.CustomerAddressTypeCode != null)
                    hashCode = hashCode * 59 + this.CustomerAddressTypeCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
