/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RetrieveSuspendedRetailTransactionsByIdsRequest &lt;p&gt;Request object for retrieving suspended retail transactions&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest" /> class.
        /// </summary>
        /// <param name="transactionIds">&lt;p&gt;A list of transaction identifiers.&lt;/p&gt;.</param>
        /// <param name="onlySSCTransactions">&lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;.</param>
        /// <param name="overtakeCustomerFromOriginalReceipt">&lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;.</param>
        /// <param name="alternativeTaxInfos">&lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;.</param>
        /// <param name="allowOtherStores">&lt;p&gt;A flag to indicate whether transactions from other stores are allowed.&lt;/p&gt;.</param>
        /// <param name="promotionHandling">&lt;p&gt;The promotion handling. If set to &#39;OLDDISCOUNTS&#39; the retail price modifier for the retrieved item gets the flag externalSystemOriginatorFlag set to true.&lt;/p&gt;.</param>
        /// <param name="consolidateLineItemsRetrieve">&lt;p&gt;The parameter defines, if the consolidation of retrieving transactions should be executed.&lt;/p&gt;.</param>
        /// <param name="consolidateReturnItems">&lt;p&gt;The parameter controls, whether items with SaleReturnLineItem.ActionCode &#x3D; RI should be consolidated or not.&lt;/p&gt;.</param>
        /// <param name="rescanEnabled">&lt;p&gt;The parameter defines, if rescan feature is enabled.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest(List<string> transactionIds = default(List<string>), bool? onlySSCTransactions = default(bool?), bool? overtakeCustomerFromOriginalReceipt = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos alternativeTaxInfos = default(ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos), bool? allowOtherStores = default(bool?), string promotionHandling = default(string), bool? consolidateLineItemsRetrieve = default(bool?), bool? consolidateReturnItems = default(bool?), bool? rescanEnabled = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.TransactionIds = transactionIds;
            this.OnlySSCTransactions = onlySSCTransactions;
            this.OvertakeCustomerFromOriginalReceipt = overtakeCustomerFromOriginalReceipt;
            this.AlternativeTaxInfos = alternativeTaxInfos;
            this.AllowOtherStores = allowOtherStores;
            this.PromotionHandling = promotionHandling;
            this.ConsolidateLineItemsRetrieve = consolidateLineItemsRetrieve;
            this.ConsolidateReturnItems = consolidateReturnItems;
            this.RescanEnabled = rescanEnabled;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;A list of transaction identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of transaction identifiers.&lt;/p&gt;</value>
        [DataMember(Name="transactionIds", EmitDefaultValue=false)]
        public List<string> TransactionIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;</value>
        [DataMember(Name="onlySSCTransactions", EmitDefaultValue=false)]
        public bool? OnlySSCTransactions { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;</value>
        [DataMember(Name="overtakeCustomerFromOriginalReceipt", EmitDefaultValue=false)]
        public bool? OvertakeCustomerFromOriginalReceipt { get; set; }

        /// <summary>
        /// &lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;</value>
        [DataMember(Name="alternativeTaxInfos", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos AlternativeTaxInfos { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate whether transactions from other stores are allowed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether transactions from other stores are allowed.&lt;/p&gt;</value>
        [DataMember(Name="allowOtherStores", EmitDefaultValue=false)]
        public bool? AllowOtherStores { get; set; }

        /// <summary>
        /// &lt;p&gt;The promotion handling. If set to &#39;OLDDISCOUNTS&#39; the retail price modifier for the retrieved item gets the flag externalSystemOriginatorFlag set to true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion handling. If set to &#39;OLDDISCOUNTS&#39; the retail price modifier for the retrieved item gets the flag externalSystemOriginatorFlag set to true.&lt;/p&gt;</value>
        [DataMember(Name="promotionHandling", EmitDefaultValue=false)]
        public string PromotionHandling { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter defines, if the consolidation of retrieving transactions should be executed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines, if the consolidation of retrieving transactions should be executed.&lt;/p&gt;</value>
        [DataMember(Name="consolidateLineItemsRetrieve", EmitDefaultValue=false)]
        public bool? ConsolidateLineItemsRetrieve { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter controls, whether items with SaleReturnLineItem.ActionCode &#x3D; RI should be consolidated or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter controls, whether items with SaleReturnLineItem.ActionCode &#x3D; RI should be consolidated or not.&lt;/p&gt;</value>
        [DataMember(Name="consolidateReturnItems", EmitDefaultValue=false)]
        public bool? ConsolidateReturnItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The parameter defines, if rescan feature is enabled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines, if rescan feature is enabled.&lt;/p&gt;</value>
        [DataMember(Name="rescanEnabled", EmitDefaultValue=false)]
        public bool? RescanEnabled { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest {\n");
            sb.Append("  TransactionIds: ").Append(TransactionIds).Append("\n");
            sb.Append("  OnlySSCTransactions: ").Append(OnlySSCTransactions).Append("\n");
            sb.Append("  OvertakeCustomerFromOriginalReceipt: ").Append(OvertakeCustomerFromOriginalReceipt).Append("\n");
            sb.Append("  AlternativeTaxInfos: ").Append(AlternativeTaxInfos).Append("\n");
            sb.Append("  AllowOtherStores: ").Append(AllowOtherStores).Append("\n");
            sb.Append("  PromotionHandling: ").Append(PromotionHandling).Append("\n");
            sb.Append("  ConsolidateLineItemsRetrieve: ").Append(ConsolidateLineItemsRetrieve).Append("\n");
            sb.Append("  ConsolidateReturnItems: ").Append(ConsolidateReturnItems).Append("\n");
            sb.Append("  RescanEnabled: ").Append(RescanEnabled).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TransactionIds == input.TransactionIds ||
                    this.TransactionIds != null &&
                    this.TransactionIds.SequenceEqual(input.TransactionIds)
                ) && 
                (
                    this.OnlySSCTransactions == input.OnlySSCTransactions ||
                    (this.OnlySSCTransactions != null &&
                    this.OnlySSCTransactions.Equals(input.OnlySSCTransactions))
                ) && 
                (
                    this.OvertakeCustomerFromOriginalReceipt == input.OvertakeCustomerFromOriginalReceipt ||
                    (this.OvertakeCustomerFromOriginalReceipt != null &&
                    this.OvertakeCustomerFromOriginalReceipt.Equals(input.OvertakeCustomerFromOriginalReceipt))
                ) && 
                (
                    this.AlternativeTaxInfos == input.AlternativeTaxInfos ||
                    (this.AlternativeTaxInfos != null &&
                    this.AlternativeTaxInfos.Equals(input.AlternativeTaxInfos))
                ) && 
                (
                    this.AllowOtherStores == input.AllowOtherStores ||
                    (this.AllowOtherStores != null &&
                    this.AllowOtherStores.Equals(input.AllowOtherStores))
                ) && 
                (
                    this.PromotionHandling == input.PromotionHandling ||
                    (this.PromotionHandling != null &&
                    this.PromotionHandling.Equals(input.PromotionHandling))
                ) && 
                (
                    this.ConsolidateLineItemsRetrieve == input.ConsolidateLineItemsRetrieve ||
                    (this.ConsolidateLineItemsRetrieve != null &&
                    this.ConsolidateLineItemsRetrieve.Equals(input.ConsolidateLineItemsRetrieve))
                ) && 
                (
                    this.ConsolidateReturnItems == input.ConsolidateReturnItems ||
                    (this.ConsolidateReturnItems != null &&
                    this.ConsolidateReturnItems.Equals(input.ConsolidateReturnItems))
                ) && 
                (
                    this.RescanEnabled == input.RescanEnabled ||
                    (this.RescanEnabled != null &&
                    this.RescanEnabled.Equals(input.RescanEnabled))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TransactionIds != null)
                    hashCode = hashCode * 59 + this.TransactionIds.GetHashCode();
                if (this.OnlySSCTransactions != null)
                    hashCode = hashCode * 59 + this.OnlySSCTransactions.GetHashCode();
                if (this.OvertakeCustomerFromOriginalReceipt != null)
                    hashCode = hashCode * 59 + this.OvertakeCustomerFromOriginalReceipt.GetHashCode();
                if (this.AlternativeTaxInfos != null)
                    hashCode = hashCode * 59 + this.AlternativeTaxInfos.GetHashCode();
                if (this.AllowOtherStores != null)
                    hashCode = hashCode * 59 + this.AllowOtherStores.GetHashCode();
                if (this.PromotionHandling != null)
                    hashCode = hashCode * 59 + this.PromotionHandling.GetHashCode();
                if (this.ConsolidateLineItemsRetrieve != null)
                    hashCode = hashCode * 59 + this.ConsolidateLineItemsRetrieve.GetHashCode();
                if (this.ConsolidateReturnItems != null)
                    hashCode = hashCode * 59 + this.ConsolidateReturnItems.GetHashCode();
                if (this.RescanEnabled != null)
                    hashCode = hashCode * 59 + this.RescanEnabled.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
