/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SearchSuspendedTransactionsRequest &lt;p&gt;Request object for the search suspended transactions operation.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest" /> class.
        /// </summary>
        /// <param name="businessUnitId">&lt;p&gt;The business unit identifier.&lt;/p&gt;.</param>
        /// <param name="suspendNumber">&lt;p&gt;The suspend number.&lt;/p&gt;.</param>
        /// <param name="parentCustomerIds">&lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;.</param>
        /// <param name="customerIds">&lt;p&gt;A list of customer identifiers.&lt;/p&gt;.</param>
        /// <param name="customerRequired">&lt;p&gt;A flag to indicate if a customer assignment is required. If the list of customer identifiers is not used but this flag is set to true, then the customer assignment of the current active transaction is used (if there is one).&lt;/p&gt;.</param>
        /// <param name="onlySSCTransactions">&lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;.</param>
        /// <param name="overtakeCustomerFromOriginalReceipt">&lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;.</param>
        /// <param name="endDateTimestampFrom">&lt;p&gt;The end date timestamp from. If set only suspended transactions with matching criteria are searched.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="customerAddressTypeCode">&lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;.</param>
        /// <param name="iSOCurrencyCode">&lt;p&gt;The ISO currency code. If set only suspended transactions with matching criteria are searched.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest(string businessUnitId = default(string), string suspendNumber = default(string), List<string> parentCustomerIds = default(List<string>), List<string> customerIds = default(List<string>), bool? customerRequired = default(bool?), bool? onlySSCTransactions = default(bool?), bool? overtakeCustomerFromOriginalReceipt = default(bool?), string endDateTimestampFrom = default(string), string customerAddressTypeCode = default(string), string iSOCurrencyCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.BusinessUnitId = businessUnitId;
            this.SuspendNumber = suspendNumber;
            this.ParentCustomerIds = parentCustomerIds;
            this.CustomerIds = customerIds;
            this.CustomerRequired = customerRequired;
            this.OnlySSCTransactions = onlySSCTransactions;
            this.OvertakeCustomerFromOriginalReceipt = overtakeCustomerFromOriginalReceipt;
            this.EndDateTimestampFrom = endDateTimestampFrom;
            this.CustomerAddressTypeCode = customerAddressTypeCode;
            this.ISOCurrencyCode = iSOCurrencyCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The business unit identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit identifier.&lt;/p&gt;</value>
        [DataMember(Name="businessUnitId", EmitDefaultValue=false)]
        public string BusinessUnitId { get; set; }

        /// <summary>
        /// &lt;p&gt;The suspend number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The suspend number.&lt;/p&gt;</value>
        [DataMember(Name="suspendNumber", EmitDefaultValue=false)]
        public string SuspendNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of parent customer identifiers.&lt;/p&gt;</value>
        [DataMember(Name="parentCustomerIds", EmitDefaultValue=false)]
        public List<string> ParentCustomerIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A list of customer identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of customer identifiers.&lt;/p&gt;</value>
        [DataMember(Name="customerIds", EmitDefaultValue=false)]
        public List<string> CustomerIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate if a customer assignment is required. If the list of customer identifiers is not used but this flag is set to true, then the customer assignment of the current active transaction is used (if there is one).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate if a customer assignment is required. If the list of customer identifiers is not used but this flag is set to true, then the customer assignment of the current active transaction is used (if there is one).&lt;/p&gt;</value>
        [DataMember(Name="customerRequired", EmitDefaultValue=false)]
        public bool? CustomerRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;</value>
        [DataMember(Name="onlySSCTransactions", EmitDefaultValue=false)]
        public bool? OnlySSCTransactions { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;</value>
        [DataMember(Name="overtakeCustomerFromOriginalReceipt", EmitDefaultValue=false)]
        public bool? OvertakeCustomerFromOriginalReceipt { get; set; }

        /// <summary>
        /// &lt;p&gt;The end date timestamp from. If set only suspended transactions with matching criteria are searched.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The end date timestamp from. If set only suspended transactions with matching criteria are searched.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="endDateTimestampFrom", EmitDefaultValue=false)]
        public string EndDateTimestampFrom { get; set; }

        /// <summary>
        /// &lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A card type which has to be used for the customer identification.&lt;/p&gt;</value>
        [DataMember(Name="customerAddressTypeCode", EmitDefaultValue=false)]
        public string CustomerAddressTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The ISO currency code. If set only suspended transactions with matching criteria are searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The ISO currency code. If set only suspended transactions with matching criteria are searched.&lt;/p&gt;</value>
        [DataMember(Name="iSOCurrencyCode", EmitDefaultValue=false)]
        public string ISOCurrencyCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest {\n");
            sb.Append("  BusinessUnitId: ").Append(BusinessUnitId).Append("\n");
            sb.Append("  SuspendNumber: ").Append(SuspendNumber).Append("\n");
            sb.Append("  ParentCustomerIds: ").Append(ParentCustomerIds).Append("\n");
            sb.Append("  CustomerIds: ").Append(CustomerIds).Append("\n");
            sb.Append("  CustomerRequired: ").Append(CustomerRequired).Append("\n");
            sb.Append("  OnlySSCTransactions: ").Append(OnlySSCTransactions).Append("\n");
            sb.Append("  OvertakeCustomerFromOriginalReceipt: ").Append(OvertakeCustomerFromOriginalReceipt).Append("\n");
            sb.Append("  EndDateTimestampFrom: ").Append(EndDateTimestampFrom).Append("\n");
            sb.Append("  CustomerAddressTypeCode: ").Append(CustomerAddressTypeCode).Append("\n");
            sb.Append("  ISOCurrencyCode: ").Append(ISOCurrencyCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionSearchSuspendedTransactionsRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitId == input.BusinessUnitId ||
                    (this.BusinessUnitId != null &&
                    this.BusinessUnitId.Equals(input.BusinessUnitId))
                ) && 
                (
                    this.SuspendNumber == input.SuspendNumber ||
                    (this.SuspendNumber != null &&
                    this.SuspendNumber.Equals(input.SuspendNumber))
                ) && 
                (
                    this.ParentCustomerIds == input.ParentCustomerIds ||
                    this.ParentCustomerIds != null &&
                    this.ParentCustomerIds.SequenceEqual(input.ParentCustomerIds)
                ) && 
                (
                    this.CustomerIds == input.CustomerIds ||
                    this.CustomerIds != null &&
                    this.CustomerIds.SequenceEqual(input.CustomerIds)
                ) && 
                (
                    this.CustomerRequired == input.CustomerRequired ||
                    (this.CustomerRequired != null &&
                    this.CustomerRequired.Equals(input.CustomerRequired))
                ) && 
                (
                    this.OnlySSCTransactions == input.OnlySSCTransactions ||
                    (this.OnlySSCTransactions != null &&
                    this.OnlySSCTransactions.Equals(input.OnlySSCTransactions))
                ) && 
                (
                    this.OvertakeCustomerFromOriginalReceipt == input.OvertakeCustomerFromOriginalReceipt ||
                    (this.OvertakeCustomerFromOriginalReceipt != null &&
                    this.OvertakeCustomerFromOriginalReceipt.Equals(input.OvertakeCustomerFromOriginalReceipt))
                ) && 
                (
                    this.EndDateTimestampFrom == input.EndDateTimestampFrom ||
                    (this.EndDateTimestampFrom != null &&
                    this.EndDateTimestampFrom.Equals(input.EndDateTimestampFrom))
                ) && 
                (
                    this.CustomerAddressTypeCode == input.CustomerAddressTypeCode ||
                    (this.CustomerAddressTypeCode != null &&
                    this.CustomerAddressTypeCode.Equals(input.CustomerAddressTypeCode))
                ) && 
                (
                    this.ISOCurrencyCode == input.ISOCurrencyCode ||
                    (this.ISOCurrencyCode != null &&
                    this.ISOCurrencyCode.Equals(input.ISOCurrencyCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitId != null)
                    hashCode = hashCode * 59 + this.BusinessUnitId.GetHashCode();
                if (this.SuspendNumber != null)
                    hashCode = hashCode * 59 + this.SuspendNumber.GetHashCode();
                if (this.ParentCustomerIds != null)
                    hashCode = hashCode * 59 + this.ParentCustomerIds.GetHashCode();
                if (this.CustomerIds != null)
                    hashCode = hashCode * 59 + this.CustomerIds.GetHashCode();
                if (this.CustomerRequired != null)
                    hashCode = hashCode * 59 + this.CustomerRequired.GetHashCode();
                if (this.OnlySSCTransactions != null)
                    hashCode = hashCode * 59 + this.OnlySSCTransactions.GetHashCode();
                if (this.OvertakeCustomerFromOriginalReceipt != null)
                    hashCode = hashCode * 59 + this.OvertakeCustomerFromOriginalReceipt.GetHashCode();
                if (this.EndDateTimestampFrom != null)
                    hashCode = hashCode * 59 + this.EndDateTimestampFrom.GetHashCode();
                if (this.CustomerAddressTypeCode != null)
                    hashCode = hashCode * 59 + this.CustomerAddressTypeCode.GetHashCode();
                if (this.ISOCurrencyCode != null)
                    hashCode = hashCode * 59 + this.ISOCurrencyCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
