/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionOperationResultEntry &lt;p&gt;An entity describing an operation result entry.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry :  IEquatable<ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry" /> class.
        /// </summary>
        /// <param name="transaction">&lt;p&gt;The resulting transaction after a service execution.&lt;/p&gt;.</param>
        /// <param name="addedOrModifiedLineItems">&lt;p&gt;The line items added or modified by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="deletedLineItems">&lt;p&gt;The line items deleted by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="closedLineItems">&lt;p&gt;The line items closed during a service execution.&lt;/p&gt; (required).</param>
        /// <param name="promotionInputRequests">&lt;p&gt;The promotion input requests resulting from a service execution.&lt;/p&gt; (required).</param>
        /// <param name="addedOrModifiedTransactionExtensions">&lt;p&gt;The transaction extensions added or modified by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="addedTransactionAdditionalPrintouts">&lt;p&gt;The transaction additional printouts added or modified by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="addedPriceDerivationRules">&lt;p&gt;The price derivation rules added by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="addedOrModifiedSaleReturnLineItemPrices">&lt;p&gt;The sale return line item prices added or modified by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="deletedTransactionAdditionalPrintouts">&lt;p&gt;The transaction additional printouts deleted by a service execution.&lt;/p&gt; (required).</param>
        /// <param name="priceModificationResultCode">&lt;p&gt;This parameter defines the price difference limit exceed action for positive items (warn, authorize, forbid, unchecked) if a set or change price operation is attempted.&lt;/p&gt;.</param>
        /// <param name="serialNumberModificationResultCode">&lt;p&gt;The serial number set to a line item.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry(ComGkSoftwareGkrApiTxpoolDtoTransaction transaction = default(ComGkSoftwareGkrApiTxpoolDtoTransaction), List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem> addedOrModifiedLineItems = default(List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem>), List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> deletedLineItems = default(List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey>), List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> closedLineItems = default(List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey>), List<ComGkSoftwarePosApiModelDomAppPromotionInputRequestPromotionInputRequest> promotionInputRequests = default(List<ComGkSoftwarePosApiModelDomAppPromotionInputRequestPromotionInputRequest>), List<ComGkSoftwareGkrApiTxpoolDtoTransactionExtension> addedOrModifiedTransactionExtensions = default(List<ComGkSoftwareGkrApiTxpoolDtoTransactionExtension>), List<ComGkSoftwareGkrApiTxpoolDtoTransactionAdditionalPrintout> addedTransactionAdditionalPrintouts = default(List<ComGkSoftwareGkrApiTxpoolDtoTransactionAdditionalPrintout>), List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionPriceDerivationRule> addedPriceDerivationRules = default(List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionPriceDerivationRule>), List<ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPrice> addedOrModifiedSaleReturnLineItemPrices = default(List<ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPrice>), List<ComGkSoftwarePosApiModelDomAppServicesTransactionTransactionAdditionalPrintoutKey> deletedTransactionAdditionalPrintouts = default(List<ComGkSoftwarePosApiModelDomAppServicesTransactionTransactionAdditionalPrintoutKey>), string priceModificationResultCode = default(string), string serialNumberModificationResultCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "addedOrModifiedLineItems" is required (not null)
            if (addedOrModifiedLineItems == null)
            {
                throw new InvalidDataException("addedOrModifiedLineItems is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.AddedOrModifiedLineItems = addedOrModifiedLineItems;
            }
            // to ensure "deletedLineItems" is required (not null)
            if (deletedLineItems == null)
            {
                throw new InvalidDataException("deletedLineItems is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.DeletedLineItems = deletedLineItems;
            }
            // to ensure "closedLineItems" is required (not null)
            if (closedLineItems == null)
            {
                throw new InvalidDataException("closedLineItems is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.ClosedLineItems = closedLineItems;
            }
            // to ensure "promotionInputRequests" is required (not null)
            if (promotionInputRequests == null)
            {
                throw new InvalidDataException("promotionInputRequests is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.PromotionInputRequests = promotionInputRequests;
            }
            // to ensure "addedOrModifiedTransactionExtensions" is required (not null)
            if (addedOrModifiedTransactionExtensions == null)
            {
                throw new InvalidDataException("addedOrModifiedTransactionExtensions is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.AddedOrModifiedTransactionExtensions = addedOrModifiedTransactionExtensions;
            }
            // to ensure "addedTransactionAdditionalPrintouts" is required (not null)
            if (addedTransactionAdditionalPrintouts == null)
            {
                throw new InvalidDataException("addedTransactionAdditionalPrintouts is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.AddedTransactionAdditionalPrintouts = addedTransactionAdditionalPrintouts;
            }
            // to ensure "addedPriceDerivationRules" is required (not null)
            if (addedPriceDerivationRules == null)
            {
                throw new InvalidDataException("addedPriceDerivationRules is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.AddedPriceDerivationRules = addedPriceDerivationRules;
            }
            // to ensure "addedOrModifiedSaleReturnLineItemPrices" is required (not null)
            if (addedOrModifiedSaleReturnLineItemPrices == null)
            {
                throw new InvalidDataException("addedOrModifiedSaleReturnLineItemPrices is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.AddedOrModifiedSaleReturnLineItemPrices = addedOrModifiedSaleReturnLineItemPrices;
            }
            // to ensure "deletedTransactionAdditionalPrintouts" is required (not null)
            if (deletedTransactionAdditionalPrintouts == null)
            {
                throw new InvalidDataException("deletedTransactionAdditionalPrintouts is a required property for ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry and cannot be null");
            }
            else
            {
                this.DeletedTransactionAdditionalPrintouts = deletedTransactionAdditionalPrintouts;
            }
            this.Transaction = transaction;
            this.PriceModificationResultCode = priceModificationResultCode;
            this.SerialNumberModificationResultCode = serialNumberModificationResultCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The resulting transaction after a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The resulting transaction after a service execution.&lt;/p&gt;</value>
        [DataMember(Name="transaction", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiTxpoolDtoTransaction Transaction { get; set; }

        /// <summary>
        /// &lt;p&gt;The line items added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items added or modified by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="addedOrModifiedLineItems", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem> AddedOrModifiedLineItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The line items deleted by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items deleted by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="deletedLineItems", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> DeletedLineItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The line items closed during a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items closed during a service execution.&lt;/p&gt;</value>
        [DataMember(Name="closedLineItems", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> ClosedLineItems { get; set; }

        /// <summary>
        /// &lt;p&gt;The promotion input requests resulting from a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion input requests resulting from a service execution.&lt;/p&gt;</value>
        [DataMember(Name="promotionInputRequests", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppPromotionInputRequestPromotionInputRequest> PromotionInputRequests { get; set; }

        /// <summary>
        /// &lt;p&gt;The transaction extensions added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction extensions added or modified by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="addedOrModifiedTransactionExtensions", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoTransactionExtension> AddedOrModifiedTransactionExtensions { get; set; }

        /// <summary>
        /// &lt;p&gt;The transaction additional printouts added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction additional printouts added or modified by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="addedTransactionAdditionalPrintouts", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoTransactionAdditionalPrintout> AddedTransactionAdditionalPrintouts { get; set; }

        /// <summary>
        /// &lt;p&gt;The price derivation rules added by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price derivation rules added by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="addedPriceDerivationRules", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionPriceDerivationRule> AddedPriceDerivationRules { get; set; }

        /// <summary>
        /// &lt;p&gt;The sale return line item prices added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sale return line item prices added or modified by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="addedOrModifiedSaleReturnLineItemPrices", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPrice> AddedOrModifiedSaleReturnLineItemPrices { get; set; }

        /// <summary>
        /// &lt;p&gt;The transaction additional printouts deleted by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction additional printouts deleted by a service execution.&lt;/p&gt;</value>
        [DataMember(Name="deletedTransactionAdditionalPrintouts", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppServicesTransactionTransactionAdditionalPrintoutKey> DeletedTransactionAdditionalPrintouts { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit exceed action for positive items (warn, authorize, forbid, unchecked) if a set or change price operation is attempted.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit exceed action for positive items (warn, authorize, forbid, unchecked) if a set or change price operation is attempted.&lt;/p&gt;</value>
        [DataMember(Name="priceModificationResultCode", EmitDefaultValue=false)]
        public string PriceModificationResultCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The serial number set to a line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The serial number set to a line item.&lt;/p&gt;</value>
        [DataMember(Name="serialNumberModificationResultCode", EmitDefaultValue=false)]
        public string SerialNumberModificationResultCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry {\n");
            sb.Append("  Transaction: ").Append(Transaction).Append("\n");
            sb.Append("  AddedOrModifiedLineItems: ").Append(AddedOrModifiedLineItems).Append("\n");
            sb.Append("  DeletedLineItems: ").Append(DeletedLineItems).Append("\n");
            sb.Append("  ClosedLineItems: ").Append(ClosedLineItems).Append("\n");
            sb.Append("  PromotionInputRequests: ").Append(PromotionInputRequests).Append("\n");
            sb.Append("  AddedOrModifiedTransactionExtensions: ").Append(AddedOrModifiedTransactionExtensions).Append("\n");
            sb.Append("  AddedTransactionAdditionalPrintouts: ").Append(AddedTransactionAdditionalPrintouts).Append("\n");
            sb.Append("  AddedPriceDerivationRules: ").Append(AddedPriceDerivationRules).Append("\n");
            sb.Append("  AddedOrModifiedSaleReturnLineItemPrices: ").Append(AddedOrModifiedSaleReturnLineItemPrices).Append("\n");
            sb.Append("  DeletedTransactionAdditionalPrintouts: ").Append(DeletedTransactionAdditionalPrintouts).Append("\n");
            sb.Append("  PriceModificationResultCode: ").Append(PriceModificationResultCode).Append("\n");
            sb.Append("  SerialNumberModificationResultCode: ").Append(SerialNumberModificationResultCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Transaction == input.Transaction ||
                    (this.Transaction != null &&
                    this.Transaction.Equals(input.Transaction))
                ) && 
                (
                    this.AddedOrModifiedLineItems == input.AddedOrModifiedLineItems ||
                    this.AddedOrModifiedLineItems != null &&
                    this.AddedOrModifiedLineItems.SequenceEqual(input.AddedOrModifiedLineItems)
                ) && 
                (
                    this.DeletedLineItems == input.DeletedLineItems ||
                    this.DeletedLineItems != null &&
                    this.DeletedLineItems.SequenceEqual(input.DeletedLineItems)
                ) && 
                (
                    this.ClosedLineItems == input.ClosedLineItems ||
                    this.ClosedLineItems != null &&
                    this.ClosedLineItems.SequenceEqual(input.ClosedLineItems)
                ) && 
                (
                    this.PromotionInputRequests == input.PromotionInputRequests ||
                    this.PromotionInputRequests != null &&
                    this.PromotionInputRequests.SequenceEqual(input.PromotionInputRequests)
                ) && 
                (
                    this.AddedOrModifiedTransactionExtensions == input.AddedOrModifiedTransactionExtensions ||
                    this.AddedOrModifiedTransactionExtensions != null &&
                    this.AddedOrModifiedTransactionExtensions.SequenceEqual(input.AddedOrModifiedTransactionExtensions)
                ) && 
                (
                    this.AddedTransactionAdditionalPrintouts == input.AddedTransactionAdditionalPrintouts ||
                    this.AddedTransactionAdditionalPrintouts != null &&
                    this.AddedTransactionAdditionalPrintouts.SequenceEqual(input.AddedTransactionAdditionalPrintouts)
                ) && 
                (
                    this.AddedPriceDerivationRules == input.AddedPriceDerivationRules ||
                    this.AddedPriceDerivationRules != null &&
                    this.AddedPriceDerivationRules.SequenceEqual(input.AddedPriceDerivationRules)
                ) && 
                (
                    this.AddedOrModifiedSaleReturnLineItemPrices == input.AddedOrModifiedSaleReturnLineItemPrices ||
                    this.AddedOrModifiedSaleReturnLineItemPrices != null &&
                    this.AddedOrModifiedSaleReturnLineItemPrices.SequenceEqual(input.AddedOrModifiedSaleReturnLineItemPrices)
                ) && 
                (
                    this.DeletedTransactionAdditionalPrintouts == input.DeletedTransactionAdditionalPrintouts ||
                    this.DeletedTransactionAdditionalPrintouts != null &&
                    this.DeletedTransactionAdditionalPrintouts.SequenceEqual(input.DeletedTransactionAdditionalPrintouts)
                ) && 
                (
                    this.PriceModificationResultCode == input.PriceModificationResultCode ||
                    (this.PriceModificationResultCode != null &&
                    this.PriceModificationResultCode.Equals(input.PriceModificationResultCode))
                ) && 
                (
                    this.SerialNumberModificationResultCode == input.SerialNumberModificationResultCode ||
                    (this.SerialNumberModificationResultCode != null &&
                    this.SerialNumberModificationResultCode.Equals(input.SerialNumberModificationResultCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Transaction != null)
                    hashCode = hashCode * 59 + this.Transaction.GetHashCode();
                if (this.AddedOrModifiedLineItems != null)
                    hashCode = hashCode * 59 + this.AddedOrModifiedLineItems.GetHashCode();
                if (this.DeletedLineItems != null)
                    hashCode = hashCode * 59 + this.DeletedLineItems.GetHashCode();
                if (this.ClosedLineItems != null)
                    hashCode = hashCode * 59 + this.ClosedLineItems.GetHashCode();
                if (this.PromotionInputRequests != null)
                    hashCode = hashCode * 59 + this.PromotionInputRequests.GetHashCode();
                if (this.AddedOrModifiedTransactionExtensions != null)
                    hashCode = hashCode * 59 + this.AddedOrModifiedTransactionExtensions.GetHashCode();
                if (this.AddedTransactionAdditionalPrintouts != null)
                    hashCode = hashCode * 59 + this.AddedTransactionAdditionalPrintouts.GetHashCode();
                if (this.AddedPriceDerivationRules != null)
                    hashCode = hashCode * 59 + this.AddedPriceDerivationRules.GetHashCode();
                if (this.AddedOrModifiedSaleReturnLineItemPrices != null)
                    hashCode = hashCode * 59 + this.AddedOrModifiedSaleReturnLineItemPrices.GetHashCode();
                if (this.DeletedTransactionAdditionalPrintouts != null)
                    hashCode = hashCode * 59 + this.DeletedTransactionAdditionalPrintouts.GetHashCode();
                if (this.PriceModificationResultCode != null)
                    hashCode = hashCode * 59 + this.PriceModificationResultCode.GetHashCode();
                if (this.SerialNumberModificationResultCode != null)
                    hashCode = hashCode * 59 + this.SerialNumberModificationResultCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
