/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ReasonTranslationSO &lt;p&gt;Translation of reason texts in a specific language&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO :  IEquatable<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO" /> class.
        /// </summary>
        /// <param name="languageID">&lt;p&gt;Language ISO code identification&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="reasonDescription">&lt;p&gt;Reason description in the given language.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonShortText">&lt;p&gt;Reason short text in the given language&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO(string languageID = default(string), string reasonDescription = default(string), string reasonShortText = default(string))
        {
            // to ensure "languageID" is required (not null)
            if (languageID == null)
            {
                throw new InvalidDataException("languageID is a required property for ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO and cannot be null");
            }
            else
            {
                this.LanguageID = languageID;
            }
            this.ReasonDescription = reasonDescription;
            this.ReasonShortText = reasonShortText;
        }
        
        /// <summary>
        /// &lt;p&gt;Language ISO code identification&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Language ISO code identification&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="languageID", EmitDefaultValue=false)]
        public string LanguageID { get; set; }

        /// <summary>
        /// &lt;p&gt;Reason description in the given language.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reason description in the given language.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonDescription", EmitDefaultValue=false)]
        public string ReasonDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;Reason short text in the given language&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reason short text in the given language&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonShortText", EmitDefaultValue=false)]
        public string ReasonShortText { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO {\n");
            sb.Append("  LanguageID: ").Append(LanguageID).Append("\n");
            sb.Append("  ReasonDescription: ").Append(ReasonDescription).Append("\n");
            sb.Append("  ReasonShortText: ").Append(ReasonShortText).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.LanguageID == input.LanguageID ||
                    (this.LanguageID != null &&
                    this.LanguageID.Equals(input.LanguageID))
                ) && 
                (
                    this.ReasonDescription == input.ReasonDescription ||
                    (this.ReasonDescription != null &&
                    this.ReasonDescription.Equals(input.ReasonDescription))
                ) && 
                (
                    this.ReasonShortText == input.ReasonShortText ||
                    (this.ReasonShortText != null &&
                    this.ReasonShortText.Equals(input.ReasonShortText))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LanguageID != null)
                    hashCode = hashCode * 59 + this.LanguageID.GetHashCode();
                if (this.ReasonDescription != null)
                    hashCode = hashCode * 59 + this.ReasonDescription.GetHashCode();
                if (this.ReasonShortText != null)
                    hashCode = hashCode * 59 + this.ReasonShortText.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
