namespace POSGkSwaggerModel
{
    /// <summary>
    /// CustomerContactView &lt;p&gt;View for displaying customer contact&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareGkrApiServerMdCustomerDtoDomCustomerContactView	{
        /// <summary>
        /// &lt;ul&gt;&lt;br /&gt; &lt;li&gt;PERSON - if table person is filled&lt;/li&gt;&lt;br /&gt; &lt;li&gt;ORGANIZATION - if table orgabnization is filled&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;ul&gt;&lt;br /&gt; &lt;li&gt;PERSON - if table person is filled&lt;/li&gt;&lt;br /&gt; &lt;li&gt;ORGANIZATION - if table orgabnization is filled&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public customerTypeEnum? customerType { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier for the customer.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for the customer.&lt;br /&gt;&lt;/p&gt;</value>
        public string customerID { get; init; }
        /// <summary>
        /// Gets or Sets Salutation
        /// </summary>
        public string salutation { get; init; }
        /// <summary>
        /// &lt;p&gt;A customer name.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A customer name.&lt;br /&gt;&lt;/p&gt;</value>
        public string name { get; init; }
        /// <summary>
        /// &lt;p&gt;The street name and number&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The street name and number&lt;br /&gt;&lt;/p&gt;</value>
        public string street { get; init; }
        /// <summary>
        /// &lt;p&gt;The city, town or village component of the address.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The city, town or village component of the address.&lt;br /&gt;&lt;/p&gt;</value>
        public string city { get; init; }
        /// <summary>
        /// &lt;p&gt;The postal or zip code of the address.&lt;br /&gt; Used also for postalCodeOfPOBox.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The postal or zip code of the address.&lt;br /&gt; Used also for postalCodeOfPOBox.&lt;br /&gt;&lt;/p&gt;</value>
        public string postalCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The ISO country code&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The ISO country code&lt;br /&gt;&lt;/p&gt;</value>
        public string isoCountryCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Name of the region.&lt;br /&gt; Used also for district.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of the region.&lt;br /&gt; Used also for district.&lt;br /&gt;&lt;/p&gt;</value>
        public string territoryName { get; init; }
        /// <summary>
        /// &lt;p&gt;The complete telephone number including the country code, area code, telephone number and extension number.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The complete telephone number including the country code, area code, telephone number and extension number.&lt;br /&gt;&lt;/p&gt;</value>
        public string completeTelephoneNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;</value>
        public string emailAddress { get; init; }
        /// <summary>
        /// &lt;p&gt;The data protection code being used for the evaluation of the data protection requirements.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The data protection code being used for the evaluation of the data protection requirements.&lt;br /&gt;&lt;/p&gt;</value>
        public string dataProtectCode { get; init; }
	}
}
