namespace POSGkSwaggerModel
{
    /// <summary>
    /// PosUOMItemSellingPriceDO.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey	{
        /// <summary>
        /// &lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;</value>
        public priceTypeCodeEnum priceTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;A unique retailer assigned identifier for the business unit group&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique retailer assigned identifier for the business unit group&lt;br /&gt;&lt;/p&gt;</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;</value>
        public string itemID { get; init; }
        /// <summary>
        /// &lt;p&gt;Unit of measure code&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Unit of measure code&lt;br /&gt;&lt;/p&gt;</value>
        public string uomCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Effective (start) time stamp of the price&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Effective (start) time stamp of the price&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string priceEffectiveDate { get; init; }
	}
}
