namespace POSGkSwaggerModel
{
    /// <summary>
    /// PartyIdentification &lt;p&gt;An official number that may be used to identify the Party. People have multiple forms of such identification: Drivers License number , Passport number, Credit / Debit Card number, Social Security number, Tax number, etc... Businesses may also have multiple identifiers to prove that they are a legal entity: Company Incorporation number, Tax number, etc...&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentification	{
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationkey key { get; init; }
        /// <summary>
        /// &lt;p&gt;The number on the Identification that identifies the Party, e. g. BusinessNumber, SalesTaxNumber..&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The number on the Identification that identifies the Party, e. g. BusinessNumber, SalesTaxNumber..&lt;br /&gt;&lt;/p&gt;</value>
        public string identifier { get; init; }
        /// <summary>
        /// &lt;p&gt;A retailer assigned code denoting the official body that issued the PartyIdentification to the Party. Used for information about customer cards.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A retailer assigned code denoting the official body that issued the PartyIdentification to the Party. Used for information about customer cards.&lt;br /&gt;&lt;/p&gt;</value>
        public string externalPartyIdentificationProviderID { get; init; }
        /// <summary>
        /// &lt;p&gt;Defines why this identifier is locked. Used for information about customer cards.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines why this identifier is locked. Used for information about customer cards.&lt;br /&gt;&lt;/p&gt;</value>
        public string lockingTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
