namespace POSGkSwaggerModel
{
    /// <summary>
    /// PersonDO &lt;p&gt;A individual of interest to the retail store or retail enterprise.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareGkrApiServerMdPersonDtoDomPersonDO	{
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdPersonDtoDomPersonDOkey key { get; init; }
        /// <summary>
        /// &lt;p&gt;A combination of ISO-639-1 and ISO-3661-1 to denote a language as spoken in a particular country. &lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A combination of ISO-639-1 and ISO-3661-1 to denote a language as spoken in a particular country. &lt;br /&gt;&lt;/p&gt;</value>
        public string languageID { get; init; }
        /// <summary>
        /// &lt;p&gt;Extra words that don&#39;t form part of the person&#39;s name but are normally printed before the FirstName as a courtesy title. For instance, Mr. Ms., Miss, Dr., Prof. etc. This represents the primary salutation for this Person.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Extra words that don&#39;t form part of the person&#39;s name but are normally printed before the FirstName as a courtesy title. For instance, Mr. Ms., Miss, Dr., Prof. etc. This represents the primary salutation for this Person.&lt;br /&gt;&lt;/p&gt;</value>
        public string salutation { get; init; }
        /// <summary>
        /// &lt;p&gt;A person&#39;s first name. In western cultures, this is the given name, in other cultures it may be the family name.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A person&#39;s first name. In western cultures, this is the given name, in other cultures it may be the family name.&lt;br /&gt;&lt;/p&gt;</value>
        public string firstName { get; init; }
        /// <summary>
        /// &lt;p&gt;A person&#39;s last name. In western cultures, this is the family (or patronymic) name, in other cultures it may be the given name.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A person&#39;s last name. In western cultures, this is the family (or patronymic) name, in other cultures it may be the given name.&lt;br /&gt;&lt;/p&gt;</value>
        public string lastName { get; init; }
        /// <summary>
        /// &lt;p&gt;The year part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The year part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthYearNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;A number in the range 1-12 denoting the month part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A number in the range 1-12 denoting the month part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthMonthNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;A number in the range 1-31denoting the day of the month part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A number in the range 1-31denoting the day of the month part of the Person&#39;s date of birth.&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthDayNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;A code for specifying a person&#39;s gender.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code for specifying a person&#39;s gender.&lt;br /&gt;&lt;/p&gt;</value>
        public string genderType { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
