namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionCustomerContactMethod.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionCustomerContactMethodKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// A unique system assigned identifier for the Customer. 
        /// </summary>
        /// <value>A unique system assigned identifier for the Customer. </value>
        public string customerID { get; init; }
        /// <summary>
        /// The customer type code
        /// </summary>
        /// <value>The customer type code</value>
        public string addressTypeCode { get; init; }
        /// <summary>
        /// A retailer defined code denoting a reason for contacting a Party. 
        /// </summary>
        /// <value>A retailer defined code denoting a reason for contacting a Party. </value>
        public string contactPurposeTypeCode { get; init; }
        /// <summary>
        /// A retailer assigned code denoting a method of contacting a Party.
        /// </summary>
        /// <value>A retailer assigned code denoting a method of contacting a Party.</value>
        public string contactMethodTypeCode { get; init; }
	}
}
