namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionExternalTrigger.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionExternalTriggerKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The type of the TriggerValue, e.g. 00 - turnover of the (current) year 01 - rebate amount which was granted during the (current) year 
        /// </summary>
        /// <value>The type of the TriggerValue, e.g. 00 - turnover of the (current) year 01 - rebate amount which was granted during the (current) year </value>
        public string triggerTypeCode { get; init; }
	}
}
