namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionGenericAttribute.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionGenericAttributeKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The sequence number of generic attribute within the scope of the transaction.
        /// </summary>
        /// <value>The sequence number of generic attribute within the scope of the transaction.</value>
        public int? genericAttributeSequenceNumber { get; init; }
	}
}
