namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionManufacturerCouponSummary.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The barcode on the manufacturer coupon in GS1 interface format. In case that the manufacturer coupon was key entered this information is assembled by the entered information (ManufacturerCompanyCode, ManufacturerOfferCode, TotalAmount) by using the GS1 interface format.
        /// </summary>
        /// <value>The barcode on the manufacturer coupon in GS1 interface format. In case that the manufacturer coupon was key entered this information is assembled by the entered information (ManufacturerCompanyCode, ManufacturerOfferCode, TotalAmount) by using the GS1 interface format.</value>
        public string manufacturerCouponScanCode { get; init; }
	}
}
