namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionTotal.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionTotalKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// A unique assigned mnemonic identifier that identifies the TransactionTotalType 
        /// </summary>
        /// <value>A unique assigned mnemonic identifier that identifies the TransactionTotalType </value>
        public string transactionTotalTypeCode { get; init; }
	}
}
