namespace POSGkSwaggerModel
{
    /// <summary>
    /// SaleReturnLineItem &lt;emph&gt;undocumented&lt;/emph&gt;
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItem	{
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemkey key { get; init; }
        /// <summary>
        /// A unique identifier for the item
        /// </summary>
        /// <value>A unique identifier for the item</value>
        public string itemID { get; init; }
        /// <summary>
        /// The code used to specify the unit of the item
        /// </summary>
        /// <value>The code used to specify the unit of the item</value>
        public string unitOfMeasureCode { get; init; }
        /// <summary>
        /// The type code of the line item
        /// </summary>
        /// <value>The type code of the line item</value>
        public string itemType { get; init; }
        /// <summary>
        /// The sub type code of the line item
        /// </summary>
        /// <value>The sub type code of the line item</value>
        public string subItemType { get; init; }
        /// <summary>
        /// The regular per-unit price
        /// </summary>
        /// <value>The regular per-unit price</value>
        public double? regularUnitPrice { get; init; }
        /// <summary>
        /// The number of items the regular price is defined for, i.e. 3 for $1.00&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The number of items the regular price is defined for, i.e. 3 for $1.00&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? regularUnitPriceQuantity { get; init; }
        /// <summary>
        /// The actual per-unit price&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!
        /// </summary>
        /// <value>The actual per-unit price&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!</value>
        public double? actualUnitPrice { get; init; }
        /// <summary>
        /// The number of items the actual price is defined for, i.e. 3 for $1.00&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The number of items the actual price is defined for, i.e. 3 for $1.00&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? actualUnitPriceQuantity { get; init; }
        /// <summary>
        /// The single quantity of a line itemPiece Item:3 * itemQuantity &#x3D; 3Units &#x3D; 1Weight item:3 * 1.234kg * itemQuantity &#x3D; 3Units &#x3D; 1.234Item with deposit:3 * six-pack (1 six-pack has 6 * deposit item)six-pack: Quantity &#x3D; 3, Units &#x3D; 1deposit: Quantity &#x3D; 3, Units &#x3D; 6
        /// </summary>
        /// <value>The single quantity of a line itemPiece Item:3 * itemQuantity &#x3D; 3Units &#x3D; 1Weight item:3 * 1.234kg * itemQuantity &#x3D; 3Units &#x3D; 1.234Item with deposit:3 * six-pack (1 six-pack has 6 * deposit item)six-pack: Quantity &#x3D; 3, Units &#x3D; 1deposit: Quantity &#x3D; 3, Units &#x3D; 6</value>
        public int? quantity { get; init; }
        /// <summary>
        /// The units of the line itemPiece Item:3 * itemQuantity &#x3D; 3Units &#x3D; 1Weight item:3 * 1.234kg * itemQuantity &#x3D; 3Units &#x3D; 1.234Item with deposit:3 * six-pack (1 six-pack has 6 * deposit item)six-pack: Quantity &#x3D; 3, Units &#x3D; 1deposit: Quantity &#x3D; 3, Units &#x3D; 6&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The units of the line itemPiece Item:3 * itemQuantity &#x3D; 3Units &#x3D; 1Weight item:3 * 1.234kg * itemQuantity &#x3D; 3Units &#x3D; 1.234Item with deposit:3 * six-pack (1 six-pack has 6 * deposit item)six-pack: Quantity &#x3D; 3, Units &#x3D; 1deposit: Quantity &#x3D; 3, Units &#x3D; 6&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? units { get; init; }
        /// <summary>
        /// The product of multiplying Quantity, Units and ActualUnitPrice.Different calculation rule for ExtendedAmount in case of package prices (see Transaction Calculation Rules).
        /// </summary>
        /// <value>The product of multiplying Quantity, Units and ActualUnitPrice.Different calculation rule for ExtendedAmount in case of package prices (see Transaction Calculation Rules).</value>
        public double? extendedAmount { get; init; }
        /// <summary>
        /// The monetary total of all line item discounts that were applied to this Item.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!
        /// </summary>
        /// <value>The monetary total of all line item discounts that were applied to this Item.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!</value>
        public double? extendedDiscountAmount { get; init; }
        /// <summary>
        /// A code that describes how this line item&#39;s retail selling unit price is being entered.
        /// </summary>
        /// <value>A code that describes how this line item&#39;s retail selling unit price is being entered.</value>
        public string sellUnitRetailPriceEntryMethodCode { get; init; }
        /// <summary>
        /// A code denoting the sign of the line item.
        /// </summary>
        /// <value>A code denoting the sign of the line item.</value>
        public string actionCode { get; init; }
        /// <summary>
        /// A unique retailer defined reason code (e.g. reason for Pay In / Pay Out)
        /// </summary>
        /// <value>A unique retailer defined reason code (e.g. reason for Pay In / Pay Out)</value>
        public string reasonCode { get; init; }
        /// <summary>
        /// A universally unique identifier used to identify an instance of a distinguishable instance of a retail item. The item traceable unit ID is similar to a serial number in that it allows each selling unit to be explicitly identified and distinguished from other selling units of the same Item.
        /// </summary>
        /// <value>A universally unique identifier used to identify an instance of a distinguishable instance of a retail item. The item traceable unit ID is similar to a serial number in that it allows each selling unit to be explicitly identified and distinguished from other selling units of the same Item.</value>
        public string itemTraceableUnitID { get; init; }
        /// <summary>
        /// Determines how the input of quantity was done on POS.
        /// </summary>
        /// <value>Determines how the input of quantity was done on POS.</value>
        public string quantityInputMethod { get; init; }
        /// <summary>
        /// The registered length &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The registered length &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? length { get; init; }
        /// <summary>
        /// The registered width &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The registered width &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? width { get; init; }
        /// <summary>
        /// The registered height &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The registered height &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(11, 3). Be aware of this and round value!</value>
        public double? height { get; init; }
        /// <summary>
        /// Describes how the weight was registered 
        /// </summary>
        /// <value>Describes how the weight was registered </value>
        public bool? manualWeightInputFlag { get; init; }
        /// <summary>
        /// The receipt printout text 
        /// </summary>
        /// <value>The receipt printout text </value>
        public string receiptText { get; init; }
        /// <summary>
        /// The item description
        /// </summary>
        /// <value>The item description</value>
        public string receiptDescription { get; init; }
        /// <summary>
        /// A flag to indicate whether food stamps can be tendered for this item. 
        /// </summary>
        /// <value>A flag to indicate whether food stamps can be tendered for this item. </value>
        public bool? allowFoodStampFlag { get; init; }
        /// <summary>
        /// The complete number which was registered on the POS originally 
        /// </summary>
        /// <value>The complete number which was registered on the POS originally </value>
        public string registrationNumber { get; init; }
        /// <summary>
        /// If this flag is set to true, automatically a negative line item is created when registering this item. Corresponds to ItemSellingRule.NegativeLineItemFlag
        /// </summary>
        /// <value>If this flag is set to true, automatically a negative line item is created when registering this item. Corresponds to ItemSellingRule.NegativeLineItemFlag</value>
        public bool? negativeLineItemFlag { get; init; }
        /// <summary>
        /// A flag to indicate whether this ITEM can be discounted. Corresponds to Item.DiscountFlag 
        /// </summary>
        /// <value>A flag to indicate whether this ITEM can be discounted. Corresponds to Item.DiscountFlag </value>
        public bool? discountFlag { get; init; }
        /// <summary>
        /// A flag to denote that the Item is eligible for frequent shopper points. Corresponds to ItemSellingRule.FrequentShopperPointsEligibilityFlag 
        /// </summary>
        /// <value>A flag to denote that the Item is eligible for frequent shopper points. Corresponds to ItemSellingRule.FrequentShopperPointsEligibilityFlag </value>
        public bool? frequentShopperPointsEligibilityFlag { get; init; }
        /// <summary>
        /// A code which is used by the loyalty engine in order to determine whether the item can get rebate/points; possible values: 0..9 Corresponds to ItemSellingRule.DiscountTypeCode
        /// </summary>
        /// <value>A code which is used by the loyalty engine in order to determine whether the item can get rebate/points; possible values: 0..9 Corresponds to ItemSellingRule.DiscountTypeCode</value>
        public string discountTypeCode { get; init; }
        /// <summary>
        /// Describes how the price of the item can be changed on POS.Corresponds to ItemSellingRule.PriceChangeTypeCode
        /// </summary>
        /// <value>Describes how the price of the item can be changed on POS.Corresponds to ItemSellingRule.PriceChangeTypeCode</value>
        public string priceChangeTypeCode { get; init; }
        /// <summary>
        /// The price type code.
        /// </summary>
        /// <value>The price type code.</value>
        public string priceTypeCode { get; init; }
        /// <summary>
        /// The line item total including taxes and discounts 
        /// </summary>
        /// <value>The line item total including taxes and discounts </value>
        public double? grandExtendedAmount { get; init; }
        /// <summary>
        /// A retailer assigned code denoting the family of related reason codes for classifying data and actions within the systems of the retail enterprise. 
        /// </summary>
        /// <value>A retailer assigned code denoting the family of related reason codes for classifying data and actions within the systems of the retail enterprise. </value>
        public string reasonCodeGroupCode { get; init; }
        /// <summary>
        /// A narrative description describing the use of the retailer assigned reason code. 
        /// </summary>
        /// <value>A narrative description describing the use of the retailer assigned reason code. </value>
        public string reasonDescription { get; init; }
        /// <summary>
        /// Determines whether the loyalty engine should care about the line item as a trigger; this information is needed because it may happen that another process (e.g. a return regarding to an existing transaction) applies rules for the line item which the loyalty engine is not allowed to change 
        /// </summary>
        /// <value>Determines whether the loyalty engine should care about the line item as a trigger; this information is needed because it may happen that another process (e.g. a return regarding to an existing transaction) applies rules for the line item which the loyalty engine is not allowed to change </value>
        public bool? notConsideredByLoyaltyEngineFlag { get; init; }
        /// <summary>
        /// The business name for the merchandise structure. 
        /// </summary>
        /// <value>The business name for the merchandise structure. </value>
        public string merchandiseHierarchyGroupName { get; init; }
        /// <summary>
        /// A description of the merchandise structure. 
        /// </summary>
        /// <value>A description of the merchandise structure. </value>
        public string merchandiseHierarchyGroupDescription { get; init; }
        /// <summary>
        /// Item class code 
        /// </summary>
        /// <value>Item class code </value>
        public string itemClassCode { get; init; }
        /// <summary>
        /// If this flag is set to true, no tax exemption is allowed for the line item 
        /// </summary>
        /// <value>If this flag is set to true, no tax exemption is allowed for the line item </value>
        public bool? prohibitTaxExemptFlag { get; init; }
        /// <summary>
        /// A flag to denote whether or not this item may be returned.
        /// </summary>
        /// <value>A flag to denote whether or not this item may be returned.</value>
        public bool? prohibitReturnFlag { get; init; }
        /// <summary>
        /// The duration of the item&#39;s warranty (in months) &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(18, 0). Be aware of this and round value!
        /// </summary>
        /// <value>The duration of the item&#39;s warranty (in months) &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(18, 0). Be aware of this and round value!</value>
        public double? warrantyDuration { get; init; }
        /// <summary>
        /// Deposit type of the item
        /// </summary>
        /// <value>Deposit type of the item</value>
        public string depositTypeCode { get; init; }
        /// <summary>
        /// A code to denote the tax exemption status from sales and use tax.
        /// </summary>
        /// <value>A code to denote the tax exemption status from sales and use tax.</value>
        public string taxExemptCode { get; init; }
        /// <summary>
        /// The ident of the invoice which is related to this line item 
        /// </summary>
        /// <value>The ident of the invoice which is related to this line item </value>
        public string invoiceID { get; init; }
        /// <summary>
        /// The main pos item id
        /// </summary>
        /// <value>The main pos item id</value>
        public string mainPOSItemID { get; init; }
        /// <summary>
        /// A qualifier which is used to differ between MerchandiseHierarchyGroup&#39;s belonging to different functions but having the same id 
        /// </summary>
        /// <value>A qualifier which is used to differ between MerchandiseHierarchyGroup&#39;s belonging to different functions but having the same id </value>
        public string mainMerchandiseHierarchyGroupIDQualifier { get; init; }
        /// <summary>
        /// Unique system assigned identifier for the merchandise group.
        /// </summary>
        /// <value>Unique system assigned identifier for the merchandise group.</value>
        public string mainMerchandiseHierarchyGroupID { get; init; }
        /// <summary>
        /// The amount that reduces the taxable amount of a line item.
        /// </summary>
        /// <value>The amount that reduces the taxable amount of a line item.</value>
        public double? taxReductionAmount { get; init; }
        /// <summary>
        /// The id of the taxable TaxableGroup
        /// </summary>
        /// <value>The id of the taxable TaxableGroup</value>
        public string taxGroupID { get; init; }
        /// <summary>
        /// A short code that is printed on a receipt to denote items that are in this TaxableGroup.
        /// </summary>
        /// <value>A short code that is printed on a receipt to denote items that are in this TaxableGroup.</value>
        public string taxReceiptPrintCode { get; init; }
        /// <summary>
        /// The tare weight of the item.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 3). Be aware of this and round value!
        /// </summary>
        /// <value>The tare weight of the item.&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 3). Be aware of this and round value!</value>
        public double? tareCount { get; init; }
        /// <summary>
        /// The original id of the taxable group.
        /// </summary>
        /// <value>The original id of the taxable group.</value>
        public string originalTaxGroupID { get; init; }
        /// <summary>
        /// The GS1 designated three digit coupon family code for the manufacturer item
        /// </summary>
        /// <value>The GS1 designated three digit coupon family code for the manufacturer item</value>
        public string manufacturerFamilyCode { get; init; }
        /// <summary>
        /// The GS1 designated 6 through 12 digit company prefix for the manufacturer of the item
        /// </summary>
        /// <value>The GS1 designated 6 through 12 digit company prefix for the manufacturer of the item</value>
        public string manufacturerCompanyCode { get; init; }
        /// <summary>
        /// The ident of the price group the item belongs to in terms of split pricing
        /// </summary>
        /// <value>The ident of the price group the item belongs to in terms of split pricing</value>
        public string priceGroupID { get; init; }
        /// <summary>
        /// A flag to denote that the price of the line item was fixed/cannot be changed. One possible reason is that this price was calculated by a legally certified system such as a scale. Another possibility is that it was retrieved from a barcode.See also SellUnitRetailPriceEntryMethodCode.
        /// </summary>
        /// <value>A flag to denote that the price of the line item was fixed/cannot be changed. One possible reason is that this price was calculated by a legally certified system such as a scale. Another possibility is that it was retrieved from a barcode.See also SellUnitRetailPriceEntryMethodCode.</value>
        public bool? fixedPriceFlag { get; init; }
        /// <summary>
        /// reference to the root item
        /// </summary>
        /// <value>reference to the root item</value>
        public string rootItemID { get; init; }
        /// <summary>
        /// list of line item extensions
        /// </summary>
        /// <value>list of line item extensions</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemExtension> SaleReturnLineItemExtensionList { get; init; }
        /// <summary>
        /// list of related set items
        /// </summary>
        /// <value>list of related set items</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollection> SaleReturnLineItemCollectionList { get; init; }
        /// <summary>
        /// list of prices
        /// </summary>
        /// <value>list of prices</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPrice> SaleReturnLineItemPriceList { get; init; }
        /// <summary>
        /// list of line item related taxes
        /// </summary>
        /// <value>list of line item related taxes</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnTaxLineItem> SaleReturnTaxLineItemList { get; init; }
        /// <summary>
        /// list of line item discounts
        /// </summary>
        /// <value>list of line item discounts</value>
        public List<comGkSoftwareGkrApiTxpoolDtoRetailPriceModifier> RetailPriceModifierList { get; init; }
        /// <summary>
        /// list of line item points discounts
        /// </summary>
        /// <value>list of line item points discounts</value>
        public List<comGkSoftwareGkrApiTxpoolDtoFrequentShopperPointsModifier> FrequentShopperPointsModifierList { get; init; }
        /// <summary>
        /// line of line item promotion triggers
        /// </summary>
        /// <value>line of line item promotion triggers</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPromotionTrigger> SaleReturnLineItemPromotionTriggerList { get; init; }
        /// <summary>
        /// list of characteristics
        /// </summary>
        /// <value>list of characteristics</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCharacteristic> SaleReturnLineItemCharacteristicList { get; init; }
        /// <summary>
        /// list of used coupons
        /// </summary>
        /// <value>list of used coupons</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCoupon> SaleReturnLineItemModifierCouponList { get; init; }
        /// <summary>
        /// list of line items that caused a condition
        /// </summary>
        /// <value>list of line items that caused a condition</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierReference> SaleReturnLineItemModifierReferenceList { get; init; }
        /// <summary>
        /// list of merchandise groups that are directly linked to the item
        /// </summary>
        /// <value>list of merchandise groups that are directly linked to the item</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemMerchandiseHierarchyGroup> SaleReturnLineItemMerchandiseHierarchyGroupList { get; init; }
        /// <summary>
        /// External reference number. In case of selling a fuel item, this is the FuelingTransactionID
        /// </summary>
        /// <value>External reference number. In case of selling a fuel item, this is the FuelingTransactionID</value>
        public string externalReferenceID { get; init; }
        /// <summary>
        /// line item with additional fuel data
        /// </summary>
        /// <value>line item with additional fuel data</value>
        public ComGkSoftwareGkrApiTxpoolDtofuelSalesLineItem fuelSalesLineItem { get; init; }
        /// <summary>
        /// list of additional prices
        /// </summary>
        /// <value>list of additional prices</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemAdditionalPrice> SaleReturnLineItemAdditionalPriceList { get; init; }
        /// <summary>
        /// A list of prices used to calculate the line items extended amount out of a package price.i.e. 3 items with price 3/$1.00 will result in 1@ $0.34 and 2@ $0.33
        /// </summary>
        /// <value>A list of prices used to calculate the line items extended amount out of a package price.i.e. 3 items with price 3/$1.00 will result in 1@ $0.34 and 2@ $0.33</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemSplitPackage> SaleReturnLineItemSplitPackageList { get; init; }
        /// <summary>
        /// list of generic attributes being valid for the line item
        /// </summary>
        /// <value>list of generic attributes being valid for the line item</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemGenericAttribute> SaleReturnLineItemGenericAttributeList { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom08 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom10 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom09 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom07 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom06 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom11 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom12 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom13 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom14 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom15 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// The ID used to identify the item.
        /// </summary>
        /// <value>The ID used to identify the item.</value>
        public string positemID { get; init; }
        /// <summary>
        /// A unique identifier for the POS department 
        /// </summary>
        /// <value>A unique identifier for the POS department </value>
        public string posdepartmentID { get; init; }
        /// <summary>
        /// A flag denoting if this Item is allowed in a WIC transaction 
        /// </summary>
        /// <value>A flag denoting if this Item is allowed in a WIC transaction </value>
        public bool? wicflag { get; init; }
        /// <summary>
        /// additional return data
        /// </summary>
        /// <value>additional return data</value>
        public List<comGkSoftwareGkrApiTxpoolDtoReturnLineItem> ReturnLineItemList { get; init; }
        /// <summary>
        /// additional data for sales order
        /// </summary>
        /// <value>additional data for sales order</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemSalesOrder> SaleReturnLineItemSalesOrderList { get; init; }
        /// <summary>
        /// serial number
        /// </summary>
        /// <value>serial number</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSerializedUnitModifer> SerializedUnitModiferList { get; init; }
        /// <summary>
        /// line item associate
        /// </summary>
        /// <value>line item associate</value>
        public List<comGkSoftwareGkrApiTxpoolDtoLineItemAssociate> LineItemAssociateList { get; init; }
        /// <summary>
        /// tax exempt data
        /// </summary>
        /// <value>tax exempt data</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnTaxExemptTrigger> SaleReturnTaxExemptTriggerList { get; init; }
        /// <summary>
        /// Data for additional bonus items which were added to the transaction by the client based on the recommendation of PCE (AdditionalBonusDiscountLineItem). PCE cannot use such line items nor as trigger neither for granting a benefit to it.
        /// </summary>
        /// <value>Data for additional bonus items which were added to the transaction by the client based on the recommendation of PCE (AdditionalBonusDiscountLineItem). PCE cannot use such line items nor as trigger neither for granting a benefit to it.</value>
        public List<comGkSoftwareGkrApiTxpoolDtoAdditionalBonusLineItem> AdditionalBonusLineItemList { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom01 { get; init; }
	}
}
