namespace POSGkSwaggerModel
{
    /// <summary>
    /// SaleReturnLineItemAdditionalPrice.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemAdditionalPriceKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        public int? retailTransactionLineItemSequenceNumber { get; init; }
        /// <summary>
        /// The price type code 
        /// </summary>
        /// <value>The price type code </value>
        public string priceTypeCode { get; init; }
	}
}
