namespace POSGkSwaggerModel
{
    /// <summary>
    /// SaleReturnLineItemModifierCoupon.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemModifierCouponKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        public int? retailTransactionLineItemSequenceNumber { get; init; }
        /// <summary>
        /// The sequence number of the related FrequentShopperPointsModifier resp. RetailPriceModifier 
        /// </summary>
        /// <value>The sequence number of the related FrequentShopperPointsModifier resp. RetailPriceModifier </value>
        public int? modifierSequenceNumber { get; init; }
        /// <summary>
        /// The unique identifier of the promotion.
        /// </summary>
        /// <value>The unique identifier of the promotion.</value>
        public string promotionID { get; init; }
        /// <summary>
        /// The unique identifier of the price derivation rule. 
        /// </summary>
        /// <value>The unique identifier of the price derivation rule. </value>
        public string priceDerivationRuleID { get; init; }
        /// <summary>
        /// The unique identifier of the root eligibility.
        /// </summary>
        /// <value>The unique identifier of the root eligibility.</value>
        public string priceDerivationRuleEligibilityID { get; init; }
        /// <summary>
        /// The sequential number of the coupon entry (starting with 1), in case there was more than one coupon registered for one modifier 
        /// </summary>
        /// <value>The sequential number of the coupon entry (starting with 1), in case there was more than one coupon registered for one modifier </value>
        public int? couponSequenceNumber { get; init; }
	}
}
