namespace POSGkSwaggerModel
{
    /// <summary>
    /// TenderAuthorization.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoTenderAuthorizationKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// A unique sequence number for this TenderAuthorization. Required because a particular TenderLineItem may have more than one TenderAuthorization attempt. 
        /// </summary>
        /// <value>A unique sequence number for this TenderAuthorization. Required because a particular TenderLineItem may have more than one TenderAuthorization attempt. </value>
        public int? tenderAuthorizationSequenceNumber { get; init; }
	}
}
