namespace POSGkSwaggerModel
{
    /// <summary>
    /// TransactionAdditionalPrintout.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoTransactionAdditionalPrintoutKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// Line number (incremental counter) of the printout 
        /// </summary>
        /// <value>Line number (incremental counter) of the printout </value>
        public int? printoutSequenceNumber { get; init; }
	}
}
