namespace POSGkSwaggerModel
{
    /// <summary>
    /// TransactionBinaryData.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoTransactionBinaryDataKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// A unique identifier (within the context of the Transaction) for this binary data entry. 
        /// </summary>
        /// <value>A unique identifier (within the context of the Transaction) for this binary data entry. </value>
        public int? binaryDataSequenceNumber { get; init; }
	}
}
