namespace POSGkSwaggerModel
{
    /// <summary>
    /// PackagePricingSession &lt;p&gt;Session to store context of Package Pricing Engine calculation.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePackagePricingPosApiCalculationPackagePricingSession	{
        /// <summary>
        /// &lt;p&gt;Session identifier for a given package pricing calculation context.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Session identifier for a given package pricing calculation context.&lt;br /&gt;&lt;/p&gt;</value>
        public string sessionId { get; init; }
        /// <summary>
        /// &lt;p&gt;The Package Pricing Context stores all data needed for the processing of package prices.&lt;br /&gt; This attribute can be used during recalculation of a Transaction on an already initialized session.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The Package Pricing Context stores all data needed for the processing of package prices.&lt;br /&gt; This attribute can be used during recalculation of a Transaction on an already initialized session.&lt;br /&gt;&lt;/p&gt;</value>
        public Object context { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information.&lt;br /&gt;&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
