namespace POSGkSwaggerModel
{
    /// <summary>
    /// PositionOperationConfig &lt;p&gt;This configuration entity defines position related operations.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig	{
        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit exceed action for positive items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit exceed action for positive items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public priceDifferenceLimitExceedActionEnum priceDifferenceLimitExceedAction { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit exceed action for negative items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit exceed action for negative items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public priceNegDifferenceLimitExceedActionEnum priceNegDifferenceLimitExceedAction { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the close current position.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: ClosePositionAction [REQUIRED, IFPOSSIBLE, DISABLED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Required as &#39;required&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;IfPossible as &#39;ifPossible&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Disabled as &#39;disabled&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the close current position.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: ClosePositionAction [REQUIRED, IFPOSSIBLE, DISABLED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Required as &#39;required&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;IfPossible as &#39;ifPossible&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Disabled as &#39;disabled&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public closeCurrentEnum closeCurrent { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the close previous position.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: ClosePositionAction [REQUIRED, IFPOSSIBLE, DISABLED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Required as &#39;required&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;IfPossible as &#39;ifPossible&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Disabled as &#39;disabled&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the close previous position.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: ClosePositionAction [REQUIRED, IFPOSSIBLE, DISABLED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Required as &#39;required&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;IfPossible as &#39;ifPossible&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Disabled as &#39;disabled&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public closePreviousEnum closePrevious { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates the input order for quantities.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: InputOrder [BEFOREORAFTER, BEFORE, AFTER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;BeforeOrAfter as &#39;beforeOrAfter&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Before as &#39;before&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;After as &#39;after&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates the input order for quantities.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: InputOrder [BEFOREORAFTER, BEFORE, AFTER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;BeforeOrAfter as &#39;beforeOrAfter&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Before as &#39;before&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;After as &#39;after&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public quantityInputOrderEnum quantityInputOrder { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates the input order for prices.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: InputOrder [BEFOREORAFTER, BEFORE, AFTER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;BeforeOrAfter as &#39;beforeOrAfter&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Before as &#39;before&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;After as &#39;after&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates the input order for prices.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: InputOrder [BEFOREORAFTER, BEFORE, AFTER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;BeforeOrAfter as &#39;beforeOrAfter&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Before as &#39;before&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;After as &#39;after&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public priceInputOrderEnum priceInputOrder { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the quantity limit exceed action.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the quantity limit exceed action.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public quantityLimitExceedActionEnum quantityLimitExceedAction { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the amount limit exceed action.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the amount limit exceed action.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: LimitExceedAction [WARN, AUTHORIZE, FORBID, UNCHECKED]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Warn as &#39;warn&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Authorize as &#39;authorize&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Forbid as &#39;forbid&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Unchecked as &#39;unchecked&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public amountLimitExceedActionEnum amountLimitExceedAction { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the deviation with respect to the previously valid price in case of sales line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: DeviationType [ALL, EQUALORLESS, EQUALORGREATER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;All as &#39;all&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrLess as &#39;equalOrLess&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrGreater as &#39;equalOrGreater&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the deviation with respect to the previously valid price in case of sales line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: DeviationType [ALL, EQUALORLESS, EQUALORGREATER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;All as &#39;all&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrLess as &#39;equalOrLess&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrGreater as &#39;equalOrGreater&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public priceDeviationTypeEnum priceDeviationType { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the deviation with respect to the previously valid price in case of return line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: DeviationType [ALL, EQUALORLESS, EQUALORGREATER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;All as &#39;all&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrLess as &#39;equalOrLess&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrGreater as &#39;equalOrGreater&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the deviation with respect to the previously valid price in case of return line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;value: DeviationType [ALL, EQUALORLESS, EQUALORGREATER]&lt;br /&gt;&lt;/pre&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;All as &#39;all&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrLess as &#39;equalOrLess&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;EqualOrGreater as &#39;equalOrGreater&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public priceNegDeviationTypeEnum priceNegDeviationType { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the quantity input for each item is forced.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the quantity input for each item is forced.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? forceQuantityInput { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price position limit. Default set to 100,000.00. -1 means disabled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price position limit. Default set to 100,000.00. -1 means disabled.&lt;/p&gt;</value>
        public double? pricePositionLimit { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines whether positions with zero price are allowed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines whether positions with zero price are allowed.&lt;/p&gt;</value>
        public bool? pricePositionZeroAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price transaction limit. Default set to 100,000.00. -1 means disabled.&lt;br /&gt; @deprecated since 5.20.0 - is not longer used.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price transaction limit. Default set to 100,000.00. -1 means disabled.&lt;br /&gt; @deprecated since 5.20.0 - is not longer used.&lt;/p&gt;</value>
        public double? priceTransactionLimit { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit in percent.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit in percent.&lt;/p&gt;</value>
        public double? priceDifferencePercentPositionLimit { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit as an absolute value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit as an absolute value.&lt;/p&gt;</value>
        public double? priceDifferenceAbsolutePositionLimit { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether results can be filtered.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether results can be filtered.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? filterResult { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the single quantity for a weight item is allowed. It has the flag &#39;ALLOWED_WITH_WEIGHT&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the single quantity for a weight item is allowed. It has the flag &#39;ALLOWED_WITH_WEIGHT&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? allowedWithWeight { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the single quantity for a length item is allowed. It has the flag &#39;ALLOWED_WITH_LENGTH&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the single quantity for a length item is allowed. It has the flag &#39;ALLOWED_WITH_LENGTH&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? allowedWithLength { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the single quantity for an area item is allowed. It has the flag &#39;ALLOWED_WITH_AREA&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the single quantity for an area item is allowed. It has the flag &#39;ALLOWED_WITH_AREA&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? allowedWithArea { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the single quantity for a volume item is allowed. It has the flag &#39;ALLOWED_WITH_VOLUME&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the single quantity for a volume item is allowed. It has the flag &#39;ALLOWED_WITH_VOLUME&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? allowedWithVolume { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter indicates whether the single quantity for a measure item is allowed. It has the flag &#39;ALLOWED_WITH_MEASURE&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter indicates whether the single quantity for a measure item is allowed. It has the flag &#39;ALLOWED_WITH_MEASURE&#39;.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? allowedWithMeasure { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the maximum single quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the maximum single quantity.&lt;/p&gt;</value>
        public int? maximumQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the minimum single quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the minimum single quantity.&lt;/p&gt;</value>
        public int? minimumQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the multiplication factor for weight quantities.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the multiplication factor for weight quantities.&lt;/p&gt;</value>
        public double? weightUnitFactor { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the multiplication factor for dimensions quantities.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the multiplication factor for dimensions quantities.&lt;/p&gt;</value>
        public double? measureUnitFactor { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
