namespace POSGkSwaggerModel
{
    /// <summary>
    /// ConditionSplitRoundingConfig &lt;p&gt;The condition split rounding config.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessFlowsConditionSplitRoundingConfig	{
        /// <summary>
        /// &lt;p&gt;It defines the rounding method for money discounts.&lt;br /&gt;&lt;ul&gt;&lt;br /&gt;&lt;li&gt;Down &#x3D; Round down&lt;/li&gt;&lt;br /&gt;&lt;li&gt;Up &#x3D; Round up&lt;/li&gt;&lt;br /&gt;&lt;li&gt;Commercial &#x3D; Commercial rounding&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;One value from the list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the rounding method for money discounts.&lt;br /&gt;&lt;ul&gt;&lt;br /&gt;&lt;li&gt;Down &#x3D; Round down&lt;/li&gt;&lt;br /&gt;&lt;li&gt;Up &#x3D; Round up&lt;/li&gt;&lt;br /&gt;&lt;li&gt;Commercial &#x3D; Commercial rounding&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;One value from the list.&lt;/p&gt;</value>
        public roundingMethodEnum roundingMethod { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of decimal places used for rounding of money discounts&lt;br /&gt;&lt;p&gt;&lt;br /&gt; Possible values: 0 - 4&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of decimal places used for rounding of money discounts&lt;br /&gt;&lt;p&gt;&lt;br /&gt; Possible values: 0 - 4&lt;/p&gt;</value>
        public int? decimalPlacesCount { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the rounding destination value for money discounts, which are used to round the value to the proper denomination.&lt;br /&gt;&lt;p&gt;&lt;br /&gt; Additional rounding information:&lt;br /&gt;&lt;ul&gt;&lt;br /&gt;&lt;li&gt;1 &#x3D; There is no further handling of the rounding result.&lt;/li&gt;&lt;br /&gt;&lt;li&gt;5 &#x3D; The rounding result is adjusted to correspond to the preceding or subsequent multiple of 5.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;One value from the list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the rounding destination value for money discounts, which are used to round the value to the proper denomination.&lt;br /&gt;&lt;p&gt;&lt;br /&gt; Additional rounding information:&lt;br /&gt;&lt;ul&gt;&lt;br /&gt;&lt;li&gt;1 &#x3D; There is no further handling of the rounding result.&lt;/li&gt;&lt;br /&gt;&lt;li&gt;5 &#x3D; The rounding result is adjusted to correspond to the preceding or subsequent multiple of 5.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;One value from the list.&lt;/p&gt;</value>
        public int? destinationValue { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
