namespace POSGkSwaggerModel
{
    /// <summary>
    /// MerchandiseHierarchyGroupPrinterAssignmentConfig &lt;p&gt;The configuration entity defines the MHG to printer assignment.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessFlowsMerchandiseHierarchyGroupPrinterAssignmentConfig	{
        /// <summary>
        /// &lt;p&gt;The parameter defines a list of merchandise hierarchy groups IDs separated by semicolon. All line items of the order with the merchandise hierarchy group defined in this list, are printed on the printer which has a reference to this parameter.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines a list of merchandise hierarchy groups IDs separated by semicolon. All line items of the order with the merchandise hierarchy group defined in this list, are printed on the printer which has a reference to this parameter.&lt;/p&gt;</value>
        public string merchandiseHierarchyGroupIdSet { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter defines the qualifier of the merchandise hierarchy group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines the qualifier of the merchandise hierarchy group.&lt;/p&gt;</value>
        public string merchandiseHierarchyGroupIdQualifier { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter defined the report ID which should be used for the printout.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defined the report ID which should be used for the printout.&lt;/p&gt;</value>
        public string reportId { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter defines an external merchandise hierarchy group ID list as integer, which is used on the KDS system to display the ordered items on the corresponding screens (e.g. food items on kitchen display, drinks on the bar display).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines an external merchandise hierarchy group ID list as integer, which is used on the KDS system to display the ordered items on the corresponding screens (e.g. food items on kitchen display, drinks on the bar display).&lt;/p&gt;</value>
        public string externalMerchandiseHierarchyGroupId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
