namespace POSGkSwaggerModel
{
    /// <summary>
    /// TransactionPreviewContextConfig &lt;p&gt;This configuration entity defines the transaction preview. The config parameters will be passed to the transaction preview component, controller, report and datasource.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessUiTransactionPreviewContextConfig	{
        /// <summary>
        /// &lt;p&gt;The language scope for the transaction preview report translations. Leave empty (null) to set the Transaction scope (with the system default locale) as default.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The language scope for the transaction preview report translations. Leave empty (null) to set the Transaction scope (with the system default locale) as default.&lt;/p&gt;</value>
        public languageScopeEnum? languageScope { get; init; }
        /// <summary>
        /// Gets or Sets HorizontalPositioningType
        /// </summary>
        public horizontalPositioningTypeEnum horizontalPositioningType { get; init; }
        /// <summary>
        /// &lt;p&gt;Name of the report template.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of the report template.&lt;/p&gt;</value>
        public string templateName { get; init; }
        /// <summary>
        /// Gets or Sets VerticalLinePadding
        /// </summary>
        public int? verticalLinePadding { get; init; }
        /// <summary>
        /// Gets or Sets VerticalLineSpacing
        /// </summary>
        public int? verticalLineSpacing { get; init; }
        /// <summary>
        /// Gets or Sets ConsiderScopeTransactions
        /// </summary>
        public bool? considerScopeTransactions { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the header should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the header should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showHeader { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the total should be displayed or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the total should be displayed or not.&lt;/p&gt;</value>
        public List<string> ShowTotals { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a row selection is allowed in general.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a row selection is allowed in general.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? rowSelectionAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether inline cell editing is allowed in general.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether inline cell editing is allowed in general.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? cellEditAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;Not supported.&lt;br /&gt; @deprecated - never implemented in any release.&lt;br /&gt; This parameter specifies whether the returnable quantity for a line item should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;Not supported.&lt;br /&gt; @deprecated - never implemented in any release.&lt;br /&gt; This parameter specifies whether the returnable quantity for a line item should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showReturnableQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the last changed row should be made visible.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the last changed row should be made visible.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showLastChangedRow { get; init; }
        /// <summary>
        /// Gets or Sets SelectLastChangedRow
        /// </summary>
        public bool? selectLastChangedRow { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the last changed row should be edited.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the last changed row should be edited.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? editLastChangedRow { get; init; }
        /// <summary>
        /// Gets or Sets ClearSelectionsForLastChangedRow
        /// </summary>
        public bool? clearSelectionsForLastChangedRow { get; init; }
        /// <summary>
        /// Gets or Sets AdvancedSelectionMode
        /// </summary>
        public bool? advancedSelectionMode { get; init; }
        /// <summary>
        /// Gets or Sets ShowVoidedLineItems
        /// </summary>
        public bool? showVoidedLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the sub total rounding should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the sub total rounding should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showSubtotalRounding { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the change rounding should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the change rounding should be displayed or not.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showChangeRounding { get; init; }
        /// <summary>
        /// Gets or Sets ShowInlinePanel
        /// </summary>
        public bool? showInlinePanel { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the line items for the given type codes should be displayed or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the line items for the given type codes should be displayed or not.&lt;/p&gt;</value>
        public List<string> ShowLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether line items for the given type codes are selectable or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether line items for the given type codes are selectable or not.&lt;/p&gt;</value>
        public List<string> SelectableLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether sale return line items for the given type codes are selectable or not. Has no effect if selectableLineItems does not include sale return line items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether sale return line items for the given type codes are selectable or not. Has no effect if selectableLineItems does not include sale return line items.&lt;/p&gt;</value>
        public List<string> SelectableSaleReturnLineItems { get; init; }
        /// <summary>
        /// Gets or Sets SaleReturnLineItemReturnTypes
        /// </summary>
        public List<string> SaleReturnLineItemReturnTypes { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether line items for the given type codes are inline editable (cell editors) or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether line items for the given type codes are inline editable (cell editors) or not.&lt;/p&gt;</value>
        public List<string> EditableLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;Set whether the footer should be displayed or not. Default value is false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;Set whether the footer should be displayed or not. Default value is false.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? showFooter { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
