namespace POSGkSwaggerModel
{
    /// <summary>
    /// GiftCertServiceResult &lt;p&gt;A data object which is returned as a result of gift certificate operations.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertServiceResult	{
        /// <summary>
        /// &lt;p&gt;Gift certificate number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate number.&lt;/p&gt;</value>
        public string gcNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount of the gift certificate before the transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the gift certificate before the transaction.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppAmountAmount oldAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount of the gift certificate after the transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the gift certificate after the transaction.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppAmountAmount newAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;Start of gift certificate validity period.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Start of gift certificate validity period.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string validFrom { get; init; }
        /// <summary>
        /// &lt;p&gt;End of gift certificate validity period&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;End of gift certificate validity period&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string validTo { get; init; }
        /// <summary>
        /// &lt;p&gt;List of additional attributes of the gift certificate.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of additional attributes of the gift certificate.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> AdditionalInfo { get; init; }
        /// <summary>
        /// &lt;p&gt;An unique transaction ID for the requested operation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;An unique transaction ID for the requested operation.&lt;/p&gt;</value>
        public string uuid { get; init; }
        /// <summary>
        /// &lt;p&gt;Gift certificate track2 data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate track2 data.&lt;/p&gt;</value>
        public string track2 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
