namespace POSGkSwaggerModel
{
    /// <summary>
    /// Price &lt;p&gt;List of prices / price modifications.&lt;br /&gt; It contains entries for regular and actual price plus entries for each price modifier.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppItemInformationPrice	{
        /// <summary>
        /// &lt;p&gt;The price entry sequence number. It defines the order (ascending)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price entry sequence number. It defines the order (ascending)&lt;/p&gt;</value>
        public int? sequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The description of the price.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The description of the price.&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;The price for the unit.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price for the unit.&lt;/p&gt;</value>
        public double? unitPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;In case of price modification this contains the discount amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;In case of price modification this contains the discount amount.&lt;/p&gt;</value>
        public double? discountAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;It contains the price after price modification or in case of regular/actual price the amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains the price after price modification or in case of regular/actual price the amount.&lt;/p&gt;</value>
        public double? newPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;The price quantity (the number of items the price is defined for, i.e. 3 for $1.00).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price quantity (the number of items the price is defined for, i.e. 3 for $1.00).&lt;/p&gt;</value>
        public int? priceQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The item quantity which was used to calculate some value for this price entity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item quantity which was used to calculate some value for this price entity.&lt;/p&gt;</value>
        public int? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The unit price with currency attached.&lt;br /&gt; Price.PriceQuantity &#39;/&#39; Price.UnitPrice, if Price.PriceQuantity &amp;lt;&amp;gt; 1&lt;br /&gt; Price.UnitPrice otherwise&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unit price with currency attached.&lt;br /&gt; Price.PriceQuantity &#39;/&#39; Price.UnitPrice, if Price.PriceQuantity &amp;lt;&amp;gt; 1&lt;br /&gt; Price.UnitPrice otherwise&lt;/p&gt;</value>
        public string unitPriceWithCurrency { get; init; }
        /// <summary>
        /// &lt;p&gt;The discount amount with currency attached. As existing field is a double type, this one was added to accommodate currency.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The discount amount with currency attached. As existing field is a double type, this one was added to accommodate currency.&lt;/p&gt;</value>
        public string discountWithCurrency { get; init; }
        /// <summary>
        /// &lt;p&gt;The new price amount with currency attached. As existing field is a double type, this one was added to accommodate currency.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The new price amount with currency attached. As existing field is a double type, this one was added to accommodate currency.&lt;/p&gt;</value>
        public string newPriceWithCurrency { get; init; }
        /// <summary>
        /// &lt;p&gt;The price group id if exists.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price group id if exists.&lt;/p&gt;</value>
        public string priceGroupId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
