namespace POSGkSwaggerModel
{
    /// <summary>
    /// PromotionInputRequest &lt;p&gt;A data object for request from promotion service to set additional input&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppPromotionInputRequestPromotionInputRequest	{
        /// <summary>
        /// &lt;p&gt;The promotion description.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion description.&lt;/p&gt;</value>
        public string promotionDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion trigger value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion trigger value.&lt;/p&gt;</value>
        public string triggerValue { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion threshold value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion threshold value.&lt;/p&gt;</value>
        public double? thresholdValue { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion interval value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion interval value.&lt;/p&gt;</value>
        public double? intervalValue { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion limit value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion limit value.&lt;/p&gt;</value>
        public double? limitValue { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion privilege type.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion privilege type.&lt;/p&gt;</value>
        public string privilegeType { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate promotion points.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate promotion points.&lt;/p&gt;</value>
        public bool? pointsFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;The line item sequence number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item sequence number.&lt;/p&gt;</value>
        public int? lineItemSequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion privilege value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion privilege value.&lt;/p&gt;</value>
        public double? privilegeValue { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
