namespace POSGkSwaggerModel
{
    /// <summary>
    /// SalesOrderExtendedItemDataV3 &lt;p&gt;Sales order extended item data based on sales order common data.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderByIdSalesOrderExtendedItemDataV3	{
        /// <summary>
        /// &lt;p&gt;The id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id&lt;/p&gt;</value>
        public string id { get; init; }
        /// <summary>
        /// &lt;p&gt;The description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The description&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;The productInternalId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The productInternalId&lt;/p&gt;</value>
        public string productInternalId { get; init; }
        /// <summary>
        /// &lt;p&gt;The productSalesMeasureUnitCode&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The productSalesMeasureUnitCode&lt;/p&gt;</value>
        public string productSalesMeasureUnitCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The requestDate&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The requestDate&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string requestDate { get; init; }
        /// <summary>
        /// &lt;p&gt;The deliveryTermsDeliveryPlantId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The deliveryTermsDeliveryPlantId&lt;/p&gt;</value>
        public string deliveryTermsDeliveryPlantId { get; init; }
        /// <summary>
        /// &lt;p&gt;The requestedQuantity&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The requestedQuantity&lt;/p&gt;</value>
        public double? requestedQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The receivingPointId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The receivingPointId&lt;/p&gt;</value>
        public string receivingPointId { get; init; }
        /// <summary>
        /// &lt;p&gt;The product standard id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product standard id&lt;/p&gt;</value>
        public string productStandardId { get; init; }
        /// <summary>
        /// &lt;p&gt;The product rejection reason code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product rejection reason code.&lt;/p&gt;</value>
        public string productRejectionReasonCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The item price component list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item price component list.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderPriceComponentV3> ItemPriceComponents { get; init; }
        /// <summary>
        /// &lt;p&gt;The requested quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The requested quantity.&lt;/p&gt;</value>
        public double? totalValuesRequestedQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The confirmed quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The confirmed quantity.&lt;/p&gt;</value>
        public double? totalValuesConfirmedQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The delivered quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The delivered quantity.&lt;/p&gt;</value>
        public double? totalValuesDeliveredQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The total net amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total net amount.&lt;/p&gt;</value>
        public double? totalValuesNetAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The total net price.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total net price.&lt;/p&gt;</value>
        public double? totalValuesNetPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;The total tax amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total tax amount.&lt;/p&gt;</value>
        public double? totalValuesTaxAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The schedule line list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The schedule line list.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceTransactionSalesOrderCommonScheduleLine> ScheduleLines { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
