namespace POSGkSwaggerModel
{
    /// <summary>
    /// ChangeConfirmationRequestItem &lt;p&gt;Request object of the Change Confirmation Item&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem	{
        /// <summary>
        /// &lt;p&gt;The item id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item id.&lt;/p&gt;</value>
        public string id { get; init; }
        /// <summary>
        /// &lt;p&gt;The item receipt text description.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item receipt text description.&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;The product internal id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product internal id.&lt;/p&gt;</value>
        public string productInternalId { get; init; }
        /// <summary>
        /// &lt;p&gt;The product sales measure unit code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product sales measure unit code.&lt;/p&gt;</value>
        public string productSalesMeasureUnitCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string dateTermsRequestDate { get; init; }
        /// <summary>
        /// &lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;</value>
        public string deliveryTermsDeliveryPlantId { get; init; }
        /// <summary>
        /// &lt;p&gt;The requested quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The requested quantity.&lt;/p&gt;</value>
        public double? totalValuesRequestedQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;Rejection reason (Token 0-2) for reversal of sales orders or order items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Rejection reason (Token 0-2) for reversal of sales orders or order items.&lt;/p&gt;</value>
        public string salesTermsRejectionReasonCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Pick up destination. This field describes the receiving point party for the items.&lt;br /&gt; For example, it is the current store id if it is an immediate pickup, &lt;br /&gt; or another store&#39;s id if the sales order will be retrieved in a different store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Pick up destination. This field describes the receiving point party for the items.&lt;br /&gt; For example, it is the current store id if it is an immediate pickup, &lt;br /&gt; or another store&#39;s id if the sales order will be retrieved in a different store.&lt;/p&gt;</value>
        public string receivingPointPartyInternalId { get; init; }
        /// <summary>
        /// &lt;p&gt;Price component condition data for the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Price component condition data for the item.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItemPriceComponent> PriceComponents { get; init; }
        /// <summary>
        /// &lt;p&gt;Buyer document id (Token 1-35). &lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Buyer document id (Token 1-35). &lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string buyerDocumentId { get; init; }
        /// <summary>
        /// &lt;p&gt;Action code for the request (Token 2).&lt;br /&gt; Possible values: &lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;01 – insert record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;02 – update record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;03 – delete record&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Action code for the request (Token 2).&lt;br /&gt; Possible values: &lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;01 – insert record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;02 – update record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;03 – delete record&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string actionCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
