namespace POSGkSwaggerModel
{
    /// <summary>
    /// SalesOrderCreateCheckRequest &lt;p&gt;Request object for the SalesOrderCreateCheckWebService.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest	{
        /// <summary>
        /// &lt;p&gt;The buyer document id.&lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;The buyer document id.&lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string buyerDocumentId { get; init; }
        /// <summary>
        /// &lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string processingTypecode { get; init; }
        /// <summary>
        /// &lt;p&gt;Store number (Token of length 1-20).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store number (Token of length 1-20).&lt;/p&gt;</value>
        public string salesOrganisationID { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the code of the distribution channel in the SAP ERP system (Token of length 1-2). E.g.: &#39;V1&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the code of the distribution channel in the SAP ERP system (Token of length 1-2). E.g.: &#39;V1&#39;.&lt;/p&gt;</value>
        public string distributionChannelCode { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the division/section in the SAP ERP system (Token of length 1-2). E.g.: &#39;R1&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the division/section in the SAP ERP system (Token of length 1-2). E.g.: &#39;R1&#39;.&lt;/p&gt;</value>
        public string divisionCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer address type (e.g.: the customer card type from customer identification configuration is used in the POS client).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer address type (e.g.: the customer card type from customer identification configuration is used in the POS client).&lt;/p&gt;</value>
        public string customerAdrType { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer id.&lt;/p&gt;</value>
        public string customerId { get; init; }
        /// <summary>
        /// &lt;p&gt;The store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The store id.&lt;/p&gt;</value>
        public string storeId { get; init; }
        /// <summary>
        /// &lt;p&gt;The item list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item list.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderCommonRequestItemData> Items { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether the service call should be performed in training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the service call should be performed in training mode.&lt;/p&gt;</value>
        public bool? trainingMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
