namespace POSGkSwaggerModel
{
    /// <summary>
    /// CouponingRequestHeaderData &lt;p&gt;Entity for the request header data.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCouponCouponingRequestHeaderData	{
        /// <summary>
        /// &lt;p&gt;Business unit of the requesting client&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Business unit of the requesting client&lt;/p&gt;</value>
        public string businessUnitId { get; init; }
        /// <summary>
        /// &lt;p&gt;Workstation id of the requesting client&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Workstation id of the requesting client&lt;/p&gt;</value>
        public string workstationId { get; init; }
        /// <summary>
        /// &lt;p&gt;Transaction id of the client transaction&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction id of the client transaction&lt;/p&gt;</value>
        public string transactionId { get; init; }
        /// <summary>
        /// &lt;p&gt;Software version of the requesting client&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Software version of the requesting client&lt;/p&gt;</value>
        public string softwareVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;Address of the requesting client&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Address of the requesting client&lt;/p&gt;</value>
        public string clientAddress { get; init; }
        /// <summary>
        /// &lt;p&gt;Country code where requesting client is located&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Country code where requesting client is located&lt;/p&gt;</value>
        public string iSOCountryCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
