namespace POSGkSwaggerModel
{
    /// <summary>
    /// EwicBasketResult &lt;p&gt;Result object for the EwicBasketResult.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceEwicEwicBasketResult	{
        /// <summary>
        /// &lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;EwicItemStatusType: Whether to apply WIC benefits for this item&lt;/p&gt;</value>
        public statusEnum? status { get; init; }
        /// <summary>
        /// &lt;p&gt;String : Item description from master data&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : Item description from master data&lt;/p&gt;</value>
        public string itemDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;double : Quantity of item purchased&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : Quantity of item purchased&lt;/p&gt;</value>
        public double? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;String : UOM description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : UOM description&lt;/p&gt;</value>
        public string uomDesc { get; init; }
        /// <summary>
        /// &lt;p&gt;double : Item extended amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : Item extended amount&lt;/p&gt;</value>
        public double? itemPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;String : eWIC category description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC category description&lt;/p&gt;</value>
        public string categoryDesc { get; init; }
        /// <summary>
        /// &lt;p&gt;String : eWIC sub-category description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC sub-category description&lt;/p&gt;</value>
        public string subcategoryDesc { get; init; }
        /// <summary>
        /// &lt;p&gt;String : UOM code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : UOM code&lt;/p&gt;</value>
        public string baseUOMCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String : eWIC category code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC category code&lt;/p&gt;</value>
        public string category { get; init; }
        /// <summary>
        /// &lt;p&gt;String : eWIC sub-category code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : eWIC sub-category code&lt;/p&gt;</value>
        public string subcategory { get; init; }
        /// <summary>
        /// &lt;p&gt;String : Item number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : Item number&lt;/p&gt;</value>
        public string upcPluNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;short: Item index&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;short: Item index&lt;/p&gt;</value>
        public int? lineNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Quantity that is eligible to receive benefits, as obtained from the eWIC prescription&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Quantity that is eligible to receive benefits, as obtained from the eWIC prescription&lt;/p&gt;</value>
        public double? benefitQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Not to exceed price&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Not to exceed price&lt;/p&gt;</value>
        public double? ntePrice { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: Specifies whether the item can be straddled&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies whether the item can be straddled&lt;/p&gt;</value>
        public bool? wicPurchaseIndicator { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: Specifies whether the item will be tendered partially with eWIC&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies whether the item will be tendered partially with eWIC&lt;/p&gt;</value>
        public bool? splitEwicTender { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Item regular unit price&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item regular unit price&lt;/p&gt;</value>
        public double? regularUnitPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Item extended discount amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item extended discount amount&lt;/p&gt;</value>
        public double? extendedDiscountAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Item quantity multiply by item benefits quantity&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item quantity multiply by item benefits quantity&lt;/p&gt;</value>
        public double? amount { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Item price for confirmation screen&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item price for confirmation screen&lt;/p&gt;</value>
        public double? itemDisplayPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;double: Item variance price for NTE&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: Item variance price for NTE&lt;/p&gt;</value>
        public double? itemVariance { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
