namespace POSGkSwaggerModel
{
    /// <summary>
    /// Address &lt;p&gt;Address object for deliveries and invoices used by the external order service&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceExternalOrderAddress	{
        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        public string title { get; init; }
        /// <summary>
        /// &lt;p&gt;First name of the customer&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;First name of the customer&lt;/p&gt;</value>
        public string firstName { get; init; }
        /// <summary>
        /// &lt;p&gt;Last name of the customer&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Last name of the customer&lt;/p&gt;</value>
        public string lastName { get; init; }
        /// <summary>
        /// &lt;p&gt;Address line 1&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Address line 1&lt;/p&gt;</value>
        public string line1 { get; init; }
        /// <summary>
        /// &lt;p&gt;Address line 2&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Address line 2&lt;/p&gt;</value>
        public string line2 { get; init; }
        /// <summary>
        /// &lt;p&gt;The city&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The city&lt;/p&gt;</value>
        public string town { get; init; }
        /// <summary>
        /// &lt;p&gt;The zipcode&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The zipcode&lt;/p&gt;</value>
        public string postalCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The country to deliver to.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;   Check the implementation for valid options.&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;The country to deliver to.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;   Check the implementation for valid options.&lt;br /&gt;&lt;/pre&gt;</value>
        public string country { get; init; }
        /// <summary>
        /// &lt;p&gt;The region to deliver to.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;   Check the implementation for valid options.&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;The region to deliver to.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;   Check the implementation for valid options.&lt;br /&gt;&lt;/pre&gt;</value>
        public string region { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
