namespace POSGkSwaggerModel
{
    /// <summary>
    /// DeliveryAddressRequest &lt;p&gt;Request object for creating a delivery address on the external order service&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceExternalOrderDeliveryAddressRequest	{
        /// <summary>
        /// &lt;p&gt;The customers&#39; ID&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customers&#39; ID&lt;/p&gt;</value>
        public string customerID { get; init; }
        /// <summary>
        /// &lt;p&gt;The cart ID to set the address to&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The cart ID to set the address to&lt;/p&gt;</value>
        public string cartID { get; init; }
        /// <summary>
        /// &lt;p&gt;First name of the customer&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;First name of the customer&lt;/p&gt;</value>
        public string firstName { get; init; }
        /// <summary>
        /// &lt;p&gt;Last name of the customer&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Last name of the customer&lt;/p&gt;</value>
        public string lastName { get; init; }
        /// <summary>
        /// &lt;p&gt;Address line 1&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Address line 1&lt;/p&gt;</value>
        public string line1 { get; init; }
        /// <summary>
        /// &lt;p&gt;Address line 2&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Address line 2&lt;/p&gt;</value>
        public string line2 { get; init; }
        /// <summary>
        /// &lt;p&gt;The city&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The city&lt;/p&gt;</value>
        public string town { get; init; }
        /// <summary>
        /// &lt;p&gt;The zipcode&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The zipcode&lt;/p&gt;</value>
        public string postalCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The country to deliver to. Check the implementation for valid options.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The country to deliver to. Check the implementation for valid options.&lt;/p&gt;</value>
        public string country { get; init; }
        /// <summary>
        /// &lt;p&gt;The region to deliver to. Check the implementation for valid options.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The region to deliver to. Check the implementation for valid options.&lt;/p&gt;</value>
        public string region { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
