namespace POSGkSwaggerModel
{
    /// <summary>
    /// BelatedVoidLineItemRequest &lt;p&gt;Request entity for &#39;BelatedVoidLineItem&#39; service.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceHospitalityBelatedVoidLineItemRequest	{
        /// <summary>
        /// &lt;p&gt;The operation configuration&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operation configuration&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration { get; init; }
        /// <summary>
        /// &lt;p&gt;The key of the line item to void&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The key of the line item to void&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionlineItemKey lineItemKey { get; init; }
        /// <summary>
        /// &lt;p&gt;The key of the tender authorization related to voided line item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The key of the tender authorization related to voided line item&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactiontenderAuthorizationKey tenderAuthorizationKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;</value>
        public string voidTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag indicating whether to copy the line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag indicating whether to copy the line item.&lt;/p&gt;</value>
        public bool? copyVoidedLineItem { get; init; }
        /// <summary>
        /// &lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;</value>
        public string giftCertCancellationId { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether the transaction should be stored.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the transaction should be stored.&lt;/p&gt;</value>
        public bool? storeTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;The offline mode&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The offline mode&lt;/p&gt;</value>
        public bool? offlineMode { get; init; }
        /// <summary>
        /// &lt;p&gt;The keyed on line state.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The keyed on line state.&lt;/p&gt;</value>
        public bool? keyedOnline { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether the POS is in service scale mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the POS is in service scale mode.&lt;/p&gt;</value>
        public bool? serviceScaleMode { get; init; }
        /// <summary>
        /// &lt;p&gt;The reason for the void.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The reason for the void.&lt;/p&gt;</value>
        public ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO voidReason { get; init; }
        /// <summary>
        /// Gets or Sets RecalculateTransaction
        /// </summary>
        public bool? recalculateTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;The quantity which should be voided from the line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The quantity which should be voided from the line item.&lt;/p&gt;</value>
        public int? toVoidQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
