namespace POSGkSwaggerModel
{
    /// <summary>
    /// CreateOrRetrieveTransactionRequest &lt;p&gt;Request entity for &#39;CreateOrRetrieveTransaction&#39; service.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceHospitalityCreateOrRetrieveTransactionRequest	{
        /// <summary>
        /// &lt;p&gt;Transaction type code of the transaction which is created or retrieved. &lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction type code of the transaction which is created or retrieved. &lt;/p&gt;</value>
        public transactionTypeCodeEnum? transactionTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Table name of a new table&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Table name of a new table&lt;/p&gt;</value>
        public string tableName { get; init; }
        /// <summary>
        /// &lt;p&gt;TransactionId of the last transaction of the table&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;TransactionId of the last transaction of the table&lt;/p&gt;</value>
        public string lastTransactionId { get; init; }
        /// <summary>
        /// &lt;p&gt;Transaction DO of the last transaction of the table&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction DO of the last transaction of the table&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTransaction lastTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Defines if the created or retrieved transaction should be a scoped transaction (default: false)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines if the created or retrieved transaction should be a scoped transaction (default: false)&lt;/p&gt;</value>
        public bool? scopedTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
