namespace POSGkSwaggerModel
{
    /// <summary>
    /// ItemSearchRequest &lt;p&gt;Request object for searching specified item.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceMasterdataItemBlItemSearchRequest	{
        /// <summary>
        /// &lt;p&gt;long: The unique identifier of the business unit group (store number).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;long: The unique identifier of the business unit group (store number).&lt;/p&gt;</value>
        public string businessUnitGroupId { get; init; }
        /// <summary>
        /// &lt;p&gt;PosUOMItemSearchFilter: Filter for search view&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;PosUOMItemSearchFilter: Filter for search view&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSearchfilter filter { get; init; }
        /// <summary>
        /// &lt;p&gt;int: Limits the search by number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;int: Limits the search by number&lt;/p&gt;</value>
        public int? recordCount { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: It specifies whether search is limited to package items only.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: It specifies whether search is limited to package items only.&lt;/p&gt;</value>
        public bool? packageSelection { get; init; }
        /// <summary>
        /// &lt;p&gt;String: It defines the required unit of measure code of the displayed package units.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: It defines the required unit of measure code of the displayed package units.&lt;/p&gt;</value>
        public string requiredUomCode { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: Specifies whether the entered item is excluded from the selection.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies whether the entered item is excluded from the selection.&lt;/p&gt;</value>
        public bool? skipEnteredItem { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the text class Id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the text class Id.&lt;/p&gt;</value>
        public string textClassId { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: Specifies, whether the item search results should be cached globally (until replication data changes) in case global master data caching is activated via configuration. (check GlobalMasterDataCacheServiceConfig.cacheSize)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies, whether the item search results should be cached globally (until replication data changes) in case global master data caching is activated via configuration. (check GlobalMasterDataCacheServiceConfig.cacheSize)&lt;/p&gt;</value>
        public bool? cacheEnabled { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the text itemName.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the text itemName.&lt;/p&gt;</value>
        public string itemName { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemId.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemId.&lt;/p&gt;</value>
        public string itemId { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemMerchandiseHierarchyGroup.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemMerchandiseHierarchyGroup.&lt;/p&gt;</value>
        public string itemMerchandiseHierarchyGroup { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemNormalPrice.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemNormalPrice.&lt;/p&gt;</value>
        public string itemNormalPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: Specifies the setsOnly flag.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: Specifies the setsOnly flag.&lt;/p&gt;</value>
        public bool? setsOnly { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemColor.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemColor.&lt;/p&gt;</value>
        public string itemColor { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemSize.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemSize.&lt;/p&gt;</value>
        public string itemSize { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemLength.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemLength.&lt;/p&gt;</value>
        public string itemLength { get; init; }
        /// <summary>
        /// &lt;p&gt;String: Specifies the itemSeason.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: Specifies the itemSeason.&lt;/p&gt;</value>
        public string itemSeason { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
