namespace POSGkSwaggerModel
{
    /// <summary>
    /// ItemInformationRequest &lt;p&gt;Request object for item information&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceMasterdataItemItemInformationRequest	{
        /// <summary>
        /// &lt;p&gt;String: pos item id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: pos item id&lt;/p&gt;</value>
        public string posItemId { get; init; }
        /// <summary>
        /// &lt;p&gt;List String: additional text info text type codes&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List String: additional text info text type codes&lt;/p&gt;</value>
        public List<string> AdditionalTextInfoTextTypeCodes { get; init; }
        /// <summary>
        /// &lt;p&gt;String: system language&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: system language&lt;/p&gt;</value>
        public string systemLanguage { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines if the discount info should be displayed in transaction preview.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the discount info should be displayed in transaction preview.&lt;/p&gt;</value>
        public bool? discountInfoEnabled { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines if the item info should be displayed in transaction preview.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the item info should be displayed in transaction preview.&lt;/p&gt;</value>
        public bool? itemInfoEnabled { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines a list of text type codes that should be displayed as icon sales info.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines a list of text type codes that should be displayed as icon sales info.&lt;/p&gt;</value>
        public List<string> IconSalesInfoTextTypeCodes { get; init; }
        /// <summary>
        /// &lt;p&gt;the clients current buId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;the clients current buId&lt;/p&gt;</value>
        public string buId { get; init; }
        /// <summary>
        /// &lt;p&gt;Specifies that promotion prices should be calculated for the item.&lt;br /&gt; It is calculated based on actual basket.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies that promotion prices should be calculated for the item.&lt;br /&gt; It is calculated based on actual basket.&lt;/p&gt;</value>
        public bool? displayPromotionPrices { get; init; }
        /// <summary>
        /// &lt;p&gt;It specifies whether the group price is additionally displayed if a single item price is valid.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It specifies whether the group price is additionally displayed if a single item price is valid.&lt;/p&gt;</value>
        public bool? displayGroupPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;Specifies treating of posItemID for item look-up. If true then is checked the posItemID in case sensitive mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies treating of posItemID for item look-up. If true then is checked the posItemID in case sensitive mode.&lt;/p&gt;</value>
        public bool? itemIDCaseSensitive { get; init; }
        /// <summary>
        /// &lt;p&gt;Specifies if item stock information should be requested from stock information system. Default value is true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies if item stock information should be requested from stock information system. Default value is true.&lt;/p&gt;</value>
        public bool? requestStock { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the unit price which should be used for the price calculation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the unit price which should be used for the price calculation.&lt;/p&gt;</value>
        public double? price { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the unit price quantity which should be used for the price calculation (i.e. &#39;3 for $1.00&#39;).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the unit price quantity which should be used for the price calculation (i.e. &#39;3 for $1.00&#39;).&lt;/p&gt;</value>
        public int? priceQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the quantity of the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the quantity of the item.&lt;/p&gt;</value>
        public int? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;It defines the units of the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the units of the item.&lt;/p&gt;</value>
        public double? unit { get; init; }
        /// <summary>
        /// Gets or Sets ItemInformationLoadConfig
        /// </summary>
        public ComGkSoftwarePosApiServiceMasterdataItemitemInformationLoadConfig itemInformationLoadConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
