namespace POSGkSwaggerModel
{
    /// <summary>
    /// CheckAvailabilityAndCleanupRequest &lt;p&gt;Request object for the checking service availability and cleaning up sessions and transactions on an active service instance.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSmartposCheckAvailabilityAndCleanupRequest	{
        /// <summary>
        /// &lt;p&gt;The store identifier (business unit id).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The store identifier (business unit id).&lt;/p&gt;</value>
        public string retailStoreId { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation id.&lt;/p&gt;</value>
        public string workstationId { get; init; }
        /// <summary>
        /// &lt;p&gt;The client application version.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The client application version.&lt;/p&gt;</value>
        public string clientVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;The main transaction currently in client transaction context.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The main transaction currently in client transaction context.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTransaction mainTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Complete last finalized transaction object.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Complete last finalized transaction object.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTransaction lastFinalizedTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Complete last finalized retail transaction object.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Complete last finalized retail transaction object.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTransaction lastFinalizedRetailTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
