namespace POSGkSwaggerModel
{
    /// <summary>
    /// MDReplicationProgressEvent &lt;p&gt;Event object for master data replication progress.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSmartposMDReplicationProgressEvent	{
        /// <summary>
        /// &lt;p&gt;The event id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The event id.&lt;/p&gt;</value>
        public string eventId { get; init; }
        /// <summary>
        /// &lt;p&gt;The retail store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store id.&lt;/p&gt;</value>
        public string type { get; init; }
        /// <summary>
        /// &lt;p&gt;The retail store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store id.&lt;/p&gt;</value>
        public string storeNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Returns current step (or count for count event) of action. Exact meaning of step may be different for different actions.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Returns current step (or count for count event) of action. Exact meaning of step may be different for different actions.&lt;/p&gt;</value>
        public string currentStep { get; init; }
        /// <summary>
        /// &lt;p&gt;Returns steps count of action. Exact meaning of step may be different for different actions.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Returns steps count of action. Exact meaning of step may be different for different actions.&lt;/p&gt;</value>
        public string stepsCount { get; init; }
        /// <summary>
        /// &lt;p&gt;Translates progress to interval &amp;lt;0, 1&amp;gt; Values &amp;lt; 0 and &amp;gt; 1 indicates that this is before/after. For count event 1.0 is always returned.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translates progress to interval &amp;lt;0, 1&amp;gt; Values &amp;lt; 0 and &amp;gt; 1 indicates that this is before/after. For count event 1.0 is always returned.&lt;/p&gt;</value>
        public double? progress { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if this is event called before the action started.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if this is event called before the action started.&lt;/p&gt;</value>
        public bool? beforeEvent { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if this is event called after the action was completed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if this is event called after the action was completed.&lt;/p&gt;</value>
        public bool? afterEvent { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that this event is progress event&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that this event is progress event&lt;/p&gt;</value>
        public bool? progressEvent { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that this event is count event (similar to progress, but with unknown stepsCount)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that this event is count event (similar to progress, but with unknown stepsCount)&lt;/p&gt;</value>
        public bool? countEvent { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
