namespace POSGkSwaggerModel
{
    /// <summary>
    /// AddTransactionTimerRequest &lt;p&gt;Request object to add transaction timer to transaction.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionAddTransactionTimerRequest	{
        /// <summary>
        /// &lt;p&gt;ID of the timer.&lt;br /&gt; 1 ... Registration timer&lt;br /&gt; 2 ... Payment timer&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ID of the timer.&lt;br /&gt; 1 ... Registration timer&lt;br /&gt; 2 ... Payment timer&lt;/p&gt;</value>
        public string timerID { get; init; }
        /// <summary>
        /// &lt;p&gt;Start time of the timer.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Start time of the timer.&lt;/p&gt;</value>
        public string startTime { get; init; }
        /// <summary>
        /// &lt;p&gt;Stop time of the timer.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Stop time of the timer.&lt;/p&gt;</value>
        public string stopTime { get; init; }
        /// <summary>
        /// &lt;p&gt;Origin of the timer.&lt;br /&gt; 00 ... Current transaction&lt;br /&gt; 01 ... taken over from suspended transaction&lt;br /&gt; 02 ... taken over from food order / table movement transaction&lt;br /&gt; 03 ... taken over from scale transaction&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Origin of the timer.&lt;br /&gt; 00 ... Current transaction&lt;br /&gt; 01 ... taken over from suspended transaction&lt;br /&gt; 02 ... taken over from food order / table movement transaction&lt;br /&gt; 03 ... taken over from scale transaction&lt;/p&gt;</value>
        public string timerOriginTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
