namespace POSGkSwaggerModel
{
    /// <summary>
    /// CheckTransactionVoidableRequest &lt;p&gt;Request object to check if a transaction is voidable.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionCheckTransactionVoidableRequest	{
        /// <summary>
        /// &lt;p&gt;The identifier of transaction to void.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier of transaction to void.&lt;/p&gt;</value>
        public string transactionToVoidId { get; init; }
        /// <summary>
        /// &lt;p&gt;The allowed age of the transaction to void in days. If a receipt is older than allowed it is not voidable anymore.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The allowed age of the transaction to void in days. If a receipt is older than allowed it is not voidable anymore.&lt;/p&gt;</value>
        public int? receiptAgeAllowedInDays { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if cancellation of gift certificates is allowed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if cancellation of gift certificates is allowed.&lt;/p&gt;</value>
        public bool? giftCertCancelAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates cancellation of receipts of other workstations is allowed or not. If only same workstation is allowed. The currentWorkstationId must match the workstation identifier in the transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates cancellation of receipts of other workstations is allowed or not. If only same workstation is allowed. The currentWorkstationId must match the workstation identifier in the transaction.&lt;/p&gt;</value>
        public bool? onlySamePosAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;The current workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The current workstation identifier.&lt;/p&gt;</value>
        public string currentWorkstationId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
