namespace POSGkSwaggerModel
{
    /// <summary>
    /// CustomerAssignmentRequest &lt;p&gt;Request object for operation which assign customer to active transaction&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionCustomerCustomerAssignmentRequest	{
        /// <summary>
        /// &lt;p&gt;String : customer id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer id&lt;/p&gt;</value>
        public string customerId { get; init; }
        /// <summary>
        /// &lt;p&gt;String : customer card type&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer card type&lt;/p&gt;</value>
        public string customerCardType { get; init; }
        /// <summary>
        /// &lt;p&gt;String : customer card type description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer card type description&lt;/p&gt;</value>
        public string customerCardTypeDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;String : customer group id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer group id&lt;/p&gt;</value>
        public string customerGroupId { get; init; }
        /// <summary>
        /// &lt;p&gt;CustomerDO : customerDO&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerDO : customerDO&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdCustomerDtoDomcustomerDO customerDO { get; init; }
        /// <summary>
        /// Gets or Sets CustomerTenderGroup
        /// </summary>
        public ComGkSoftwareGkrApiServerMdCustomerTenderRuleDtoDomcustomerTenderGroupDO customerTenderGroup { get; init; }
        /// <summary>
        /// &lt;p&gt;CustomerData : customer data used for customer data entry process&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerData : customer data used for customer data entry process&lt;/p&gt;</value>
        public ComGkSoftwarePosFlowLibsCustomercustomerData customerData { get; init; }
        /// <summary>
        /// &lt;p&gt;CustomerWebserviceResult : customer web service data&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;CustomerWebserviceResult : customer web service data&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceCommunicationWsCustomerByIdCustomerWebserviceResult customerWebServiceData { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean : searchFor identification number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : searchFor identification number&lt;/p&gt;</value>
        public bool? searchForIdentificationNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;String : customer iD entry method code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer iD entry method code&lt;/p&gt;</value>
        public string customerIDEntryMethodCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String : preferredReceiptPrintoutTypeCode&lt;br /&gt; It defines the preferred printout type code of the customer:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;CLIENT - Printout depends on client settings.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTONLY - Customer wants to have a printed receipt.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;MAILONLY - Customer wants to have the receipt per mail.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;NOTHING - Customer wants to have nothing.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTANDMAIL - Customer wants to have a printed receipt and a mail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : preferredReceiptPrintoutTypeCode&lt;br /&gt; It defines the preferred printout type code of the customer:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;CLIENT - Printout depends on client settings.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTONLY - Customer wants to have a printed receipt.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;MAILONLY - Customer wants to have the receipt per mail.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;NOTHING - Customer wants to have nothing.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PRINTANDMAIL - Customer wants to have a printed receipt and a mail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string preferredReceiptPrintoutTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The organization name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The organization name&lt;/p&gt;</value>
        public string organizationName { get; init; }
        /// <summary>
        /// &lt;p&gt;The data provider id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The data provider id&lt;/p&gt;</value>
        public string dataProvider { get; init; }
        /// <summary>
        /// &lt;p&gt;It specifies if the customer is a dummy/unknown customer &lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It specifies if the customer is a dummy/unknown customer &lt;/p&gt;</value>
        public bool? genericFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
