namespace POSGkSwaggerModel
{
    /// <summary>
    /// DuplicatePrintOutTransactionsRequest &lt;p&gt;Request object to search for duplicate printout transactions.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionDuplicatePrintOutTransactionsRequest	{
        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are not voided should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are not voided should be searched.&lt;/p&gt;</value>
        public bool? transactionIsNotVoided { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are cancelled should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are cancelled should be searched.&lt;/p&gt;</value>
        public bool? cancelledFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that only transactions that are suspended should be searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only transactions that are suspended should be searched.&lt;/p&gt;</value>
        public bool? suspendedFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation identifier.&lt;/p&gt;</value>
        public string workstationID { get; init; }
        /// <summary>
        /// &lt;p&gt;The business unit group identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit group identifier.&lt;/p&gt;</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;The business unit identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit identifier.&lt;/p&gt;</value>
        public string businessUnitID { get; init; }
        /// <summary>
        /// &lt;p&gt;Limits the number of found receipts to the given value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Limits the number of found receipts to the given value.&lt;/p&gt;</value>
        public int? maxReceiptCount { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier for the original transaction (as part of the search criteria).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for the original transaction (as part of the search criteria).&lt;/p&gt;</value>
        public string originalTransactionId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
