namespace POSGkSwaggerModel
{
    /// <summary>
    /// LinkedItemRegistrationRequest &lt;p&gt;Request object for registering linked items.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionLinkedItemRegistrationRequest	{
        /// <summary>
        /// &lt;p&gt;The id of the linked item to be registered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id of the linked item to be registered.&lt;/p&gt;</value>
        public string linkedItemId { get; init; }
        /// <summary>
        /// &lt;p&gt;the UOM code of the linked item to be registered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;the UOM code of the linked item to be registered.&lt;/p&gt;</value>
        public string linkedItemUOMCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The id of the main item linked to this linked item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id of the main item linked to this linked item.&lt;/p&gt;</value>
        public string mainItemId { get; init; }
        /// <summary>
        /// &lt;p&gt;The actionCode of this linked item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The actionCode of this linked item.&lt;/p&gt;</value>
        public string actionCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The units of this linked item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The units of this linked item.&lt;/p&gt;</value>
        public double? units { get; init; }
        /// <summary>
        /// &lt;p&gt;The quantity of the mainitem.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The quantity of the mainitem.&lt;/p&gt;</value>
        public int? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;linkedLineItemSequenceNumber of this linked item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;linkedLineItemSequenceNumber of this linked item.&lt;/p&gt;</value>
        public int? maintemSequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;RetailTransactionLineItem&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;RetailTransactionLineItem&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem mainLineItem { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
