namespace POSGkSwaggerModel
{
    /// <summary>
    /// PrepaidCreditSaleRegistrationRequest &lt;p&gt;Request object for operations which create a SaleReturnLineItem for a prepaid credit sale on the active transaction.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionPrepaidPrepaidCreditSaleRegistrationRequest	{
        /// <summary>
        /// &lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;sellerRelationMethod to store the currently defined seller assignment method&lt;/p&gt;</value>
        public sellerRelationMethodEnum? sellerRelationMethod { get; init; }
        /// <summary>
        /// &lt;p&gt;The amount value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount value.&lt;/p&gt;</value>
        public double? amount { get; init; }
        /// <summary>
        /// &lt;p&gt;The quantity value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The quantity value.&lt;/p&gt;</value>
        public int? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;The action code for the line item. The default value is &#39;SI&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The action code for the line item. The default value is &#39;SI&#39;.&lt;/p&gt;</value>
        public string actionCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The adapter type for the call to the external system for prepaid credit sales.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The adapter type for the call to the external system for prepaid credit sales.&lt;/p&gt;</value>
        public string adapterType { get; init; }
        /// <summary>
        /// &lt;p&gt;The entry identifier from prepaidType configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The entry identifier from prepaidType configuration.&lt;/p&gt;</value>
        public int? smId { get; init; }
        /// <summary>
        /// &lt;p&gt;The item identifier of the prepaid item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item identifier of the prepaid item&lt;/p&gt;</value>
        public string itemId { get; init; }
        /// <summary>
        /// &lt;p&gt;The provider code of the prepaid item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The provider code of the prepaid item&lt;/p&gt;</value>
        public string providerCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The resource key of the prepaid receipt&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The resource key of the prepaid receipt&lt;/p&gt;</value>
        public string resourceId { get; init; }
        /// <summary>
        /// &lt;p&gt;The position operation configuration for the SaleReturnLineItem registration&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration for the SaleReturnLineItem registration&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionpositionOperationConfig positionOperationConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessFlowsalternativeTaxInfos alternativeTaxInfos { get; init; }
        /// <summary>
        /// &lt;p&gt;String to store seller Id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String to store seller Id&lt;/p&gt;</value>
        public string sellerId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
