namespace POSGkSwaggerModel
{
    /// <summary>
    /// RegisterScaleTransactionRequest &lt;p&gt;Request object for the retrieve scale transaction process.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionRegisterScaleTransactionRequest	{
        /// <summary>
        /// &lt;p&gt;The position operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionpositionOperationConfig positionOperationConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that return mode is active.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that return mode is active.&lt;/p&gt;</value>
        public bool? returnMode { get; init; }
        /// <summary>
        /// &lt;p&gt;The collective number. When single item resolving is not wanted or possible the item with collective number is used for scale transaction registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The collective number. When single item resolving is not wanted or possible the item with collective number is used for scale transaction registration.&lt;/p&gt;</value>
        public string collectiveNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The transaction identifier for the scale transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction identifier for the scale transaction.&lt;/p&gt;</value>
        public string transactionIdentifier { get; init; }
        /// <summary>
        /// &lt;p&gt;The amount. In case of collective item usage the unit price amount for the line item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount. In case of collective item usage the unit price amount for the line item registration.&lt;/p&gt;</value>
        public double? amount { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;offline&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;offline&#39; was confirmed.&lt;/p&gt;</value>
        public bool? statusOfflineConfirmed { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;redeemed&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;redeemed&#39; was confirmed.&lt;/p&gt;</value>
        public bool? statusRedeemedConfirmed { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;not found&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;not found&#39; was confirmed.&lt;/p&gt;</value>
        public bool? statusNotFoundConfirmed { get; init; }
        /// <summary>
        /// &lt;p&gt;A complete transaction holding the retrieved scale transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A complete transaction holding the retrieved scale transaction.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoCompleteTransaction scaleTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessFlowsalternativeTaxInfos alternativeTaxInfos { get; init; }
        /// <summary>
        /// &lt;p&gt;A Transaction which was converted from a suspend code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A Transaction which was converted from a suspend code.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTransaction suspendCodeTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
