namespace POSGkSwaggerModel
{
    /// <summary>
    /// ReturnLineItemBulkRequest &lt;p&gt;Request object for the the return line item operation.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionReturnLineItemBulkRequest	{
        /// <summary>
        /// &lt;p&gt;The return with transaction configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The return with transaction configuration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessFlowsreturnWithTransactionConfig returnWithTransactionConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier for the refund transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for the refund transaction.&lt;/p&gt;</value>
        public string refundTransactionID { get; init; }
        /// <summary>
        /// &lt;p&gt;The reason group code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The reason group code.&lt;/p&gt;</value>
        public string reasonGroupCode { get; init; }
        /// <summary>
        /// Gets or Sets SalesPersonNumber
        /// </summary>
        public string salesPersonNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;A list of return line items that should be returned.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of return line items that should be returned.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceTransactionReturnLineItemElement> ReturnLineItemElementList { get; init; }
        /// <summary>
        /// &lt;p&gt;It specifies whether a return receipt is created. This receipt includes return line items only.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It specifies whether a return receipt is created. This receipt includes return line items only.&lt;/p&gt;</value>
        public bool? createReturnReceipt { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
