namespace POSGkSwaggerModel
{
    /// <summary>
    /// ReturnLineItemRequest &lt;p&gt;Request object for the the return line item operation.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionReturnLineItemRequest	{
        /// <summary>
        /// &lt;p&gt;The operation configuration&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operation configuration&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessFlowsreturnWithTransactionConfig returnWithTransactionConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;Id of the line item to return&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Id of the line item to return&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey lineItemKeyToReturn { get; init; }
        /// <summary>
        /// &lt;p&gt;The SaleReturnTaxLineItem Key&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The SaleReturnTaxLineItem Key&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionSaleReturntaxLineItemKey taxLineItemKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Line item to be filled&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Line item to be filled&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionlineItem lineItem { get; init; }
        /// <summary>
        /// &lt;p&gt;The tax percent&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tax percent&lt;/p&gt;</value>
        public double? taxPercent { get; init; }
        /// <summary>
        /// &lt;p&gt;The tax amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tax amount&lt;/p&gt;</value>
        public double? taxAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The tax reason&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tax reason&lt;/p&gt;</value>
        public ComGkSoftwareSweeSesApiServerMdreasonDtoSoreasonSO reason { get; init; }
        /// <summary>
        /// &lt;p&gt;Quantity to return.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Quantity to return.&lt;/p&gt;</value>
        public int? quantity { get; init; }
        /// <summary>
        /// &lt;p&gt;Units to return.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Units to return.&lt;/p&gt;</value>
        public double? units { get; init; }
        /// <summary>
        /// &lt;p&gt;The reason code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The reason code&lt;/p&gt;</value>
        public string reasonCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The reason group Code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The reason group Code&lt;/p&gt;</value>
        public string reasonGroupCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The extension key&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The extension key&lt;/p&gt;</value>
        public string extensionKey { get; init; }
        /// <summary>
        /// &lt;p&gt;The extension value&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The extension value&lt;/p&gt;</value>
        public string extensionValue { get; init; }
        /// <summary>
        /// &lt;p&gt;The customerIdentifier&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customerIdentifier&lt;/p&gt;</value>
        public string customerIdentifier { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
