namespace POSGkSwaggerModel
{
    /// <summary>
    /// SaleReturnLineItemSalesOrder &lt;p&gt;The sale return line item sales order.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionSaleReturnLineItemSalesOrder	{
        /// <summary>
        /// &lt;p&gt;The position operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration { get; init; }
        /// <summary>
        /// &lt;p&gt;The line item key the operation refers to.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item key the operation refers to.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionlineItemKey lineItemKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;</value>
        public bool? returnMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;</value>
        public bool? emptiesReturnMode { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;</value>
        public bool? createReturnReceipt { get; init; }
        /// <summary>
        /// &lt;p&gt;The external customer order ID&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The external customer order ID&lt;/p&gt;</value>
        public string externalCustomerOrderID { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer order sequence number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer order sequence number&lt;/p&gt;</value>
        public int? customerOrderSequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The sales order type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales order type code&lt;/p&gt;</value>
        public string salesOrderTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The sales order delivery type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales order delivery type code&lt;/p&gt;</value>
        public string salesOrderDeliveryTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The requested delivery date&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The requested delivery date&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string requestedDeliveryDate { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
