namespace POSGkSwaggerModel
{
    /// <summary>
    /// SalesOrderCommonData &lt;p&gt;Entity describing common sales order data.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionSalesOrderCommonData	{
        /// <summary>
        /// &lt;p&gt;The result code for a ERP service call. If the result code is equal to 5, the call was not successful.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The result code for a ERP service call. If the result code is equal to 5, the call was not successful.&lt;/p&gt;</value>
        public string resultCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer order condition data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer order condition data.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceTransactionSalesOrderExtendedPriceComponent> PriceComponentList { get; init; }
        /// <summary>
        /// &lt;p&gt;The order amount (gross).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The order amount (gross).&lt;/p&gt;</value>
        public double? totalGross { get; init; }
        /// <summary>
        /// &lt;p&gt;The order amount (net).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The order amount (net).&lt;/p&gt;</value>
        public double? totalNet { get; init; }
        /// <summary>
        /// &lt;p&gt;The total tax amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total tax amount.&lt;/p&gt;</value>
        public double? totalTax { get; init; }
        /// <summary>
        /// &lt;p&gt;The order line items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The order line items.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceTransactionSalesOrderExtendedItemData> ItemList { get; init; }
        /// <summary>
        /// &lt;p&gt;Dummy identifier for actual SAP sales order.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Dummy identifier for actual SAP sales order.&lt;/p&gt;</value>
        public string sAP_DUMMY_ORDER_ID { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
