namespace POSGkSwaggerModel
{
    /// <summary>
    /// TransactionOperationResultEntry &lt;p&gt;An entity describing an operation result entry.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry	{
        /// <summary>
        /// &lt;p&gt;The resulting transaction after a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The resulting transaction after a service execution.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtotransaction transaction { get; init; }
        /// <summary>
        /// &lt;p&gt;The line items added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items added or modified by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem> AddedOrModifiedLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;The line items deleted by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items deleted by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> DeletedLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;The line items closed during a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line items closed during a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey> ClosedLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion input requests resulting from a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion input requests resulting from a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiModelDomAppPromotionInputRequestPromotionInputRequest> PromotionInputRequests { get; init; }
        /// <summary>
        /// &lt;p&gt;The transaction extensions added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction extensions added or modified by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoTransactionExtension> AddedOrModifiedTransactionExtensions { get; init; }
        /// <summary>
        /// &lt;p&gt;The transaction additional printouts added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction additional printouts added or modified by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoTransactionAdditionalPrintout> AddedTransactionAdditionalPrintouts { get; init; }
        /// <summary>
        /// &lt;p&gt;The price derivation rules added by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price derivation rules added by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionPriceDerivationRule> AddedPriceDerivationRules { get; init; }
        /// <summary>
        /// &lt;p&gt;The sale return line item prices added or modified by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sale return line item prices added or modified by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemPrice> AddedOrModifiedSaleReturnLineItemPrices { get; init; }
        /// <summary>
        /// &lt;p&gt;The transaction additional printouts deleted by a service execution.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction additional printouts deleted by a service execution.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiModelDomAppServicesTransactionTransactionAdditionalPrintoutKey> DeletedTransactionAdditionalPrintouts { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the price difference limit exceed action for positive items (warn, authorize, forbid, unchecked) if a set or change price operation is attempted.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the price difference limit exceed action for positive items (warn, authorize, forbid, unchecked) if a set or change price operation is attempted.&lt;/p&gt;</value>
        public string priceModificationResultCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The serial number set to a line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The serial number set to a line item.&lt;/p&gt;</value>
        public string serialNumberModificationResultCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
