namespace POSGkSwaggerModel
{
    /// <summary>
    /// TransactionTenderRequest &lt;p&gt;Request object for creation of various tender related transactions.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionTransactionTenderRequest	{
        /// <summary>
        /// &lt;p&gt;The tender registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tender registration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppTendertenderRegistration tenderRegistration { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate whether the transaction should be marked as cancelled or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether the transaction should be marked as cancelled or not.&lt;/p&gt;</value>
        public bool? canceled { get; init; }
        /// <summary>
        /// &lt;p&gt;The lead number used for the tender pickup transaction envelope identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The lead number used for the tender pickup transaction envelope identifier.&lt;/p&gt;</value>
        public string leadNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate whether the transaction should be finalized.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether the transaction should be finalized.&lt;/p&gt;</value>
        public bool? finalizeTransaction { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: this flag should be set to &#39;true&#39; if the values for balance amount should be copied from tillCopyObject and not from the tender request. Active balance amount from CRS is only taken for cash in main currency. Default is &#39;false&#39;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: this flag should be set to &#39;true&#39; if the values for balance amount should be copied from tillCopyObject and not from the tender request. Active balance amount from CRS is only taken for cash in main currency. Default is &#39;false&#39;&lt;/p&gt;</value>
        public bool? useBalanceAmountFromTillCopyObject { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
