namespace POSGkSwaggerModel
{
    /// <summary>
    /// UpdateSalesOrderSelectedDeliveryItemRequest &lt;p&gt;The update sales order selected delivery item request object&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionUpdateSalesOrderSelectedDeliveryItemRequest	{
        /// <summary>
        /// &lt;p&gt;The order id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The order id.&lt;/p&gt;</value>
        public string orderId { get; init; }
        /// <summary>
        /// &lt;p&gt;The use pos prices.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The use pos prices.&lt;/p&gt;</value>
        public bool? usePosPrices { get; init; }
        /// <summary>
        /// &lt;p&gt;The extend order mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The extend order mode.&lt;/p&gt;</value>
        public bool? extendOrderMode { get; init; }
        /// <summary>
        /// &lt;p&gt;The response data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The response data.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionSalesOrderCommonData responseData { get; init; }
        /// <summary>
        /// &lt;p&gt;The sales order standard price specification element type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales order standard price specification element type code.&lt;/p&gt;</value>
        public string salesOrderStandardPriceSpecificationElementTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The include sales tax.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The include sales tax.&lt;/p&gt;</value>
        public bool? includeSalesTax { get; init; }
        /// <summary>
        /// &lt;p&gt;The price type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price type code.&lt;/p&gt;</value>
        public string priceTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The sap debates promotion id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sap debates promotion id.&lt;/p&gt;</value>
        public string sapRebatesPromotionId { get; init; }
        /// <summary>
        /// &lt;p&gt;The line item list&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item list&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItem> LineItemList { get; init; }
        /// <summary>
        /// &lt;p&gt;The operation configuration&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operation configuration&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration { get; init; }
        /// <summary>
        /// &lt;p&gt;T delivery type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;T delivery type code&lt;/p&gt;</value>
        public string deliveryTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The salesorder final price pos price specification element type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The salesorder final price pos price specification element type code&lt;/p&gt;</value>
        public string salesOrderFinalPricePosPriceSpecificationElementTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The sales order default prepayment price specification element type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales order default prepayment price specification element type code&lt;/p&gt;</value>
        public string salesOrderDefaultPrepaymentPriceSpecificationElementTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The delivery plant ID&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The delivery plant ID&lt;/p&gt;</value>
        public string deliveryPlantID { get; init; }
        /// <summary>
        /// &lt;p&gt;The uuid&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The uuid&lt;/p&gt;</value>
        public string uuid { get; init; }
        /// <summary>
        /// &lt;p&gt;The down payment not allowed&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The down payment not allowed&lt;/p&gt;</value>
        public bool? downpaymentNotAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;The down payment request object&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The down payment request object&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionCreateDownpaymentLineItemRequest downPaymentRequest { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
