namespace POSGkSwaggerModel
{
    /// <summary>
    /// ReasonCodeGroupSO &lt;p&gt;Reason code group master data. Reason groups represent e.g. various processes.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareSweeSesApiServerMdReasonDtoSoReasonCodeGroupSO	{
        /// <summary>
        /// Gets or Sets Origin
        /// </summary>
        public originEnum? origin { get; init; }
        /// <summary>
        /// &lt;p&gt;A retailer assigned code denoting the family of related reason codes for classifying data and actions within the systems of the retail enterprise.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A retailer assigned code denoting the family of related reason codes for classifying data and actions within the systems of the retail enterprise.&lt;br /&gt;&lt;/p&gt;</value>
        public string reasonCodeGroupCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_Reason.xml: BusinessUnitGroupID or the BusinessUnitGroupID for the ExternalBusinessUnitGroupID from ReasonCodeGroup.BugHeader or if not filled, then from ReasonCodeGroupMasterData.BugHeader. If not filled, then the data is globally valid.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_Reason.xml: BusinessUnitGroupID or the BusinessUnitGroupID for the ExternalBusinessUnitGroupID from ReasonCodeGroup.BugHeader or if not filled, then from ReasonCodeGroupMasterData.BugHeader. If not filled, then the data is globally valid.&lt;br /&gt;&lt;/p&gt;</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;Description of the reason code group&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Description of the reason code group&lt;br /&gt;&lt;/p&gt;</value>
        public string reasonCodeGroupDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;List of parameters defined for this reason code group&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not used, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of parameters defined for this reason code group&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not used, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerMdReasonDtoSoReasonCodeGroupParameterSO> ReasonCodeGroupParameterList { get; init; }
        /// <summary>
        /// &lt;p&gt;Translation identifier&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translation identifier&lt;br /&gt;&lt;/p&gt;</value>
        public string tid { get; init; }
        /// <summary>
        /// &lt;p&gt;List of translations&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of translations&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerMdReasonDtoSoReasonCodeGroupTranslationSO> Translations { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
