namespace POSGkSwaggerModel
{
    /// <summary>
    /// AbstractOperatorSO &lt;p&gt;The data of an operator (person) who can work in many retail stores. The operator can obtain different login data and different roles in different retail stores.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from Operator.xml.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO	{
        /// <summary>
        /// &lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public originEnum? origin { get; init; }
        /// <summary>
        /// &lt;p&gt;The unique ID of the operator (Note: Not the login name. The login name can be store specific.)&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;dl&gt;&lt;br /&gt; &lt;dt&gt;+&lt;/dt&gt;&lt;br /&gt;&lt;/dl&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique ID of the operator (Note: Not the login name. The login name can be store specific.)&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;dl&gt;&lt;br /&gt; &lt;dt&gt;+&lt;/dt&gt;&lt;br /&gt;&lt;/dl&gt;</value>
        public string operatorID { get; init; }
        /// <summary>
        /// &lt;p&gt;Worker ID. This attribute can be used as the connection between the operator and the worker object.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Worker ID. This attribute can be used as the connection between the operator and the worker object.&lt;br /&gt;&lt;/p&gt;</value>
        public string workerID { get; init; }
        /// <summary>
        /// &lt;p&gt;Salutation&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Salutation&lt;br /&gt;&lt;/p&gt;</value>
        public string salutation { get; init; }
        /// <summary>
        /// &lt;p&gt;First name&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;First name&lt;br /&gt;&lt;/p&gt;</value>
        public string firstName { get; init; }
        /// <summary>
        /// &lt;p&gt;Last name&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Last name&lt;br /&gt;&lt;/p&gt;</value>
        public string lastName { get; init; }
        /// <summary>
        /// &lt;p&gt;ISO language ID. The GUI in the portal, on the hand-held and on the POS is displayed in this language after user login&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ISO language ID. The GUI in the portal, on the hand-held and on the POS is displayed in this language after user login&lt;br /&gt;&lt;/p&gt;</value>
        public string languageID { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag for left handed. The flag can control the GUI of the peripheral device.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag for left handed. The flag can control the GUI of the peripheral device.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? leftHandedFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;</value>
        public string emailAddress { get; init; }
        /// <summary>
        /// &lt;p&gt;Birth year&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth year&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthYearNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Birth month&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth month&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthMonthNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Birth day&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth day&lt;br /&gt;&lt;/p&gt;</value>
        public int? birthDayNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Role assignments in specific retail stores&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Role assignments in specific retail stores&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> OperatorAssignmentSOList { get; init; }
        /// <summary>
        /// &lt;p&gt;Login data for periphery classes in specific retail stores&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Login data for periphery classes in specific retail stores&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerUmOperatorDtoSoPeripheralAccessSO> PeripheralAccessSOList { get; init; }
        /// <summary>
        /// &lt;p&gt;Internal identifier of the import file&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Internal identifier of the import file&lt;br /&gt;&lt;/p&gt;</value>
        public string packageID { get; init; }
        /// <summary>
        /// Gets or Sets OpAsgnList
        /// </summary>
        public List<comGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> OpAsgnList { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;ISO country code&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ISO country code&lt;br /&gt;&lt;/p&gt;</value>
        public string isocountryCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
